SET QUOTED_IDENTIFIER ON
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[GenerateEventsResourceRequestSubmitted]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure GenerateEventsResourceRequestSubmitted'
		DROP PROCEDURE [dbo].[GenerateEventsResourceRequestSubmitted]
	END
GO

PRINT 'Creating procedure GenerateEventsResourceRequestSubmitted'
GO

/******************************************************************************
**		File: GenerateEventsResourceRequestSubmitted.sql
**		Name: GenerateEventsResourceRequestSubmitted
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/12/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [GenerateEventsResourceRequestSubmitted]
	@FromID TIdentifier,
	@EventType TName,
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@Data XML
AS
	SET NOCOUNT ON;

	DECLARE @ResponsibleEmployeeID TIdentifier, @ToID TIdentifier
	
	SELECT 
		@ResponsibleEmployeeID = [Resource].[ResponsibleEmployeeID]
	FROM
		[ResourceRequest] INNER JOIN [Resource]
			ON ([ResourceRequest].[ResourceID] = [Resource].[ID])
	WHERE
		[ResourceRequest].[ID] = @DocumentID
	
	SELECT @ToID = (SELECT [UserID] FROM [Employee] WHERE [ID] = @ResponsibleEmployeeID)
	
	IF @ToID IS NULL OR @ToID = @FromID
		RETURN 0
	
	INSERT INTO [MailItem]
		([State], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		[ResourceRequest].[FileAs],
		@EventType,
		@FromID,
		@ToID,
		@DocumentClass,
		@DocumentID,
		0,
		@Data,
		[ResourceRequest].[Comments]
	FROM
		[ResourceRequest]
	WHERE
		[ResourceRequest].[ID] = @DocumentID
		
	RETURN 0
GO

