IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCurrencyCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCurrencyCreate'
		DROP PROCEDURE [dbo].[adfCurrencyCreate]
	END
GO

PRINT 'Creating procedure adfCurrencyCreate'
GO

/******************************************************************************
**		File: adfCurrencyCreate.sql
**		Name: adfCurrencyCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 09/29/2004 15:30:36
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCurrencyCreate]
	@Code TCode3,
	@NumericCode TCode3,
	@FileAs TName,
	@Symbol TCurrencySymbol,
	@Width TCount,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('5117dce5-7003-402c-9c2f-2ffd6f36f9d8')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [Currency]
		([Flag], [State], [Code], [NumericCode], [FileAs], [Symbol], [Width], [Comments])
	VALUES
		(0, @State, @Code, @NumericCode, @FileAs, @Symbol, @Width, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfCurrencyGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCurrencyCreate TO PUBLIC
GO
