IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfCurrencyRateUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfCurrencyRateUpdate'
		DROP  Procedure  adfCurrencyRateUpdate
	END

GO

PRINT 'Creating Procedure adfCurrencyRateUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfCurrencyRateUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfCurrencyRateUpdate
	@ID TIdentifier,
	@ValidFrom TDate, 
	@ValidTo TDate,
	@Rate TMoney
AS
	DECLARE @ToCurrencyCode TCode3,
			@FromCurrencyCode TCode3
			
	SET NOCOUNT ON
	
	SELECT
		@ToCurrencyCode = [ToCurrencyCode],
		@FromCurrencyCode = [FromCurrencyCode]
	FROM
		[CurrencyRate]
	WHERE
		[ID] = @ID
	
	IF EXISTS(SELECT * FROM [CurrencyRate] WHERE
		[ID] != @ID
		AND
		[FromCurrencyCode]=@FromCurrencyCode 
		AND 
		[ToCurrencyCode]=@ToCurrencyCode 
		AND
		(
			(@ValidFrom BETWEEN [ValidFrom] AND [ValidTo]) 
			OR
			(@ValidTo BETWEEN [ValidFrom] AND [ValidTo])
			OR
			(@ValidFrom < [ValidFrom] AND @ValidTo > [ValidTo])
		)
	)
	BEGIN
		RAISERROR('#CurrencyRateAlreadyExists', 18, -1)
		RETURN 1
	END

	UPDATE
		[CurrencyRate]
	SET
		[ValidFrom] = @ValidFrom,
		[ValidTo] = @ValidTo,
		[Rate] = @Rate
	WHERE
		[ID] = @ID
		
	RETURN 0
GO

GRANT EXEC ON adfCurrencyRateUpdate TO PUBLIC
GO
