IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfDivisionBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfDivisionBrowse'
		DROP PROCEDURE [dbo].[adfDivisionBrowse]
	END
GO

PRINT 'Creating procedure adfDivisionBrowse'
GO

/******************************************************************************
**		File: adfDivisionBrowse.sql
**		Name: adfDivisionBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 12/19/2005 13:34:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.05.14	SAP				  [DivisionManagerEmployeeID]
*******************************************************************************/
CREATE PROCEDURE [adfDivisionBrowse]
	@CompanyID TIdentifier,
	@StateSelector int,
	@ExecutiveEmployeeSelector TIdentifier,
	@ExecutiveEmployeeID TIdentifier = NULL
AS
	SET NOCOUNT ON
	SELECT
		[Division].[ID],
		[Division].[Class],
		[Division].[State],
		[Division].[Flag],
		[Division].[CompanyID],
		[Division].[Code],
		[Division].[FileAs],
		[Division].[Comments],
		[Division].[Created],
		[Division].[CreatedBy],
		[Division].[Modified],
		[Division].[ModifiedBy],
		[Division].[Timestamp],
		[Division].[ExecutiveEmployeeID]
	FROM
		[Division]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [Division].[State] = @StateSelector))
	AND
		[Division].[CompanyID] = @CompanyID
	AND
		(
			(@ExecutiveEmployeeSelector = 0) 
			OR 
			(
				(@ExecutiveEmployeeSelector <> 0) 
				AND
				( 
					(@ExecutiveEmployeeID IS NULL AND [Division].[ExecutiveEmployeeID] IS NULL)
					OR
					(@ExecutiveEmployeeID  IS NOT NULL AND [Division].[ExecutiveEmployeeID] = @ExecutiveEmployeeID)
				)
			)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [adfDivisionBrowse] TO PUBLIC
GO
 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfDivisionGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfDivisionGet'
		DROP PROCEDURE [dbo].[adfDivisionGet]
	END
GO

PRINT 'Creating procedure adfDivisionGet'
GO

/******************************************************************************
**		File: adfDivisionGet.sql
**		Name: adfDivisionGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 12/19/2005 13:34:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.05.14	SAP				  [DivisionManagerEmployeeID]
*******************************************************************************/
CREATE PROCEDURE [adfDivisionGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[Division].[ID],
		[Division].[Class],
		[Division].[State],
		[Division].[Flag],
		[Division].[CompanyID],
		[Division].[Code],
		[Division].[FileAs],
		[Division].[Comments],
		[Division].[Created],
		[Division].[CreatedBy],
		[Division].[Modified],
		[Division].[ModifiedBy],
		[Division].[Timestamp],
		[Division].[ExecutiveEmployeeID]
	FROM
		[Division]
	WHERE
		[Division].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfDivisionGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfDivisionCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfDivisionCreate'
		DROP PROCEDURE [dbo].[adfDivisionCreate]
	END
GO

PRINT 'Creating procedure adfDivisionCreate'
GO

/******************************************************************************
**		File: adfDivisionCreate.sql
**		Name: adfDivisionCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 12/19/2005 13:34:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.05.14	SAP				  [DivisionManagerEmployeeID]
*******************************************************************************/
CREATE PROCEDURE [adfDivisionCreate]
	@CompanyID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes,
	@ExecutiveEmployeeID TIdentifier = NULL

AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('8aee3355-c878-4b7e-929f-29745719bd38')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [Division]
		([Flag], [State], [CompanyID], [Code], [FileAs], [Comments], [ExecutiveEmployeeID])
	VALUES
		(0, @State, @CompanyID, @Code, @FileAs, @Comments, @ExecutiveEmployeeID)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfDivisionGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfDivisionCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfDivisionUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfDivisionUpdate'
		DROP PROCEDURE [dbo].[adfDivisionUpdate]
	END
GO

PRINT 'Creating procedure adfDivisionUpdate'
GO

/******************************************************************************
**		File: adfDivisionUpdate.sql
**		Name: adfDivisionUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 12/19/2005 13:34:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.05.14	SAP				  [DivisionManagerEmployeeID]
*******************************************************************************/
CREATE PROCEDURE adfDivisionUpdate
	@ID TIdentifier,
	@CompanyID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes,
	@ExecutiveEmployeeID TIdentifier
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[Division]
	SET
		[Division].[CompanyID] = @CompanyID,
		[Division].[Code] = @Code,
		[Division].[FileAs] = @FileAs,
		[Division].[Comments] = @Comments,
		[Division].[Modified] = GETDATE(),
		[Division].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[Division].[ExecutiveEmployeeID] = @ExecutiveEmployeeID
	WHERE
		[Division].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfDivisionGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfDivisionUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfDivisionDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfDivisionDelete'
		DROP PROCEDURE [dbo].[adfDivisionDelete]
	END
GO

PRINT 'Creating procedure adfDivisionDelete'
GO

/******************************************************************************
**		File: adfDivisionDelete.sql
**		Name: adfDivisionDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 12/19/2005 13:34:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfDivisionDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [Division] WHERE [Division].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfDivisionDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfDivisionChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfDivisionChangeState'
		DROP PROCEDURE [dbo].[adfDivisionChangeState]
	END
GO

PRINT 'Creating procedure adfDivisionChangeState'
GO

/******************************************************************************
**		File: adfDivisionChangeState.sql
**		Name: adfDivisionChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 12/19/2005 13:34:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfDivisionChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Division].[Class],
		@FromState = [Division].[State]
	FROM
		[Division]
	WHERE
		[Division].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[Division]
	SET
		[Division].[State] = @ToState,
		[Division].[Modified] = GETDATE(),
		[Division].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Division].[ID] = @ID
	AND
		[Division].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfDivisionChangeState TO PUBLIC
GO
