IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfCompanyList')
	BEGIN
		PRINT 'Dropping Procedure adfCompanyList'
		DROP  Procedure  adfCompanyList
	END
GO

PRINT 'Creating Procedure adfCompanyList'
GO
/******************************************************************************
**		File: 
**		Name: adfCompanyList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      09.09.09	LKA				,     
**		15.09.09	LKA				    [Customers]  LEFT JOIN
**		10.08.11	SPV				  
*******************************************************************************/
CREATE Procedure adfCompanyList
AS
	SET NOCOUNT ON

	SELECT
		[Company].[ID],
		[Company].[FileAs] as [Code],
		[Company].[FileAs] as [Name],
		[Company].[LegalCode],
		[Company].[LegalName],
		[Company].[State],
		[Company].[Own],
		CASE
			WHEN EXISTS(SELECT * FROM [Project] WHERE [CustomerCompanyID] = [Company].[ID]) THEN 1
			ELSE 0 
		END AS [IsCustomer]
	FROM
		[Company]
	WHERE
		[Company].[State] < 100 
		
	RETURN 0
GO

GRANT EXEC ON adfCompanyList TO PUBLIC
GO
