IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfEmailTypeList')
	BEGIN
		PRINT 'Dropping Procedure adfEmailTypeList'
		DROP  Procedure  adfEmailTypeList
	END

GO

PRINT 'Creating Procedure adfEmailTypeList'
GO
/******************************************************************************
**		File: 
**		Name: adfEmailTypeList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfEmailTypeList
AS
	SET NOCOUNT ON
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[EmailType].[ID],
		[DocumentGlobal].[FileAs] as [Name]
	FROM
		[EmailType] INNER JOIN [DocumentGlobal]
			ON ([EmailType].[Class] = [DocumentGlobal].[Class] AND
				[EmailType].[ID] = [DocumentGlobal].[ID] AND
				[DocumentGlobal].[Language] = @Lang)

	RETURN 0
GO

GRANT EXEC ON adfEmailTypeList TO PUBLIC
GO
