IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfMailItemEventTypeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfMailItemEventTypeBrowse'
		DROP PROCEDURE [dbo].[adfMailItemEventTypeBrowse]
	END
GO

PRINT 'Creating procedure adfMailItemEventTypeBrowse'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: adfMailItemEventTypeBrowse.sql
**		Name: adfMailItemEventTypeBrowse
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/17/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfMailItemEventTypeBrowse]
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[MailItemEventType].[EventType],
		ISNULL([MailItemEventTypeGlobal].[FileAs], [MailItemEventType].[FileAs]) as [FileAs]
	FROM
		[MailItemEventType] LEFT OUTER JOIN [MailItemEventTypeGlobal]
			ON ([MailItemEventType].[EventType] = [MailItemEventTypeGlobal].[EventType] AND
				[MailItemEventTypeGlobal].[Language] = @Lang)

	RETURN 0
GO

GRANT EXECUTE ON [adfMailItemEventTypeBrowse] TO PUBLIC
GO
    