IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfProjectsBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfProjectsBrowse'
		DROP PROCEDURE [dbo].[adfProjectsBrowse]
	END
GO

PRINT 'Creating procedure adfProjectsBrowse'
GO

/******************************************************************************
**		File: adfProjectsBrowse.sql
**		Name: adfProjectsBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfProjectsBrowse]
	@StartDate	TDate,
	@EndDate	TDate	
AS

	IF dbo.adfHasAccessRightByName('ManageAllTimeEntries') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET NOCOUNT ON
	
		
	SELECT
		[Project].[ID],
		[Project].[Number],
		[Project].[FileAs]
	FROM
		[Project]
	WHERE
		[Project].[ProjectTypeID] = 1 AND [Project].[State] IN (2) AND
		EXISTS(SELECT *FROM [TimeEntry] WHERE [TimeEntry].ProjectID = [Project].[ID] AND 
			[TimeEntry].[State] IN (1,2,3,5) AND [TimeEntry].[StartTime] >= @StartDate AND 
			[TimeEntry].[StartTime] < @EndDate)
																		
		
	RETURN 0
GO

GRANT EXECUTE ON [adfProjectsBrowse] TO PUBLIC
GO
