IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfDocumentSetRead')
	BEGIN
		PRINT 'Dropping Procedure adfDocumentSetRead'
		DROP  Procedure  adfDocumentSetRead
	END

GO

PRINT 'Creating Procedure adfDocumentSetRead'
GO
/******************************************************************************
**		File: 
**		Name: adfDocumentSetRead
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfDocumentSetRead
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@Read TBool
AS
	DECLARE @UserID TIdentifier
	SET NOCOUNT ON

	SET @UserID = dbo.adfGetCurrentUserID()

	IF @Read = 1
	BEGIN
		IF EXISTS(SELECT * FROM [DocumentUserState] WHERE [DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID  AND [UserID] = @UserID)
		BEGIN
			UPDATE [DocumentUserState] SET [Read] = 1
			WHERE [DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID AND [UserID] = @UserID
		END
		ELSE
		BEGIN
			INSERT INTO [DocumentUserState] ([UserID], [DocumentClass], [DocumentID], [Read]) 
			VALUES(@UserID, @DocumentClass, @DocumentID, 1)
		END
	END
	ELSE
	BEGIN
		UPDATE [DocumentUserState] SET [Read] = 0 
		WHERE [DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID AND [UserID] = @UserID
	END
	
	RETURN 0
GO

GRANT EXEC ON adfDocumentSetRead TO PUBLIC

GO
