IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCountryCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCountryCreate'
		DROP PROCEDURE [dbo].[adfCountryCreate]
	END
GO

PRINT 'Creating procedure adfCountryCreate'
GO

/******************************************************************************
**		File: adfCountryCreate.sql
**		Name: adfCountryCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 16:07:28
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCountryCreate]
	@Code TCode2,
	@FileAs TName,
	@Alf3 TCode3,
	@LongName TName,
	@PhoneCode TPhoneCountryCode,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('1962f008-cd5c-4748-a5a9-a23e967d83f2')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [Country]
		([Flag], [State], [Code], [FileAs], [Alf3], [LongName], [PhoneCode], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Alf3, @LongName, @PhoneCode, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfCountryGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCountryCreate TO PUBLIC
GO
 