﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCountryCurrency]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCountryCurrency'
		DROP PROCEDURE [dbo].[adfCountryCurrency]
	END

GO

PRINT 'Creating procedure adfCountryCurrency'
GO
/******************************************************************************
**		File: adfCountryCurrency.sql
**		Name: adfCountryCurrency
**		Desc: 
**
**		This template can be customized:
**              
**		Return values: Country string
** 
**		Called by: CountryAttribute()  
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCountryCurrency
AS
	SET NOCOUNT ON

	DECLARE
		@Currency TVariant

	EXEC 
		adfParameterGet 
			@Name = 'NationalCurrency', 
			@Group = 'CommonBusiness', 
			@Value = @Currency OUTPUT

	SELECT
		[CountryCode]
	FROM
		[CountryCurrency]
	WHERE 
		[CurrencyCode] = @Currency

	RETURN 0
GO

GRANT EXECUTE ON adfCountryCurrency TO PUBLIC
GO