IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPositionCreateInternal')
	BEGIN
		PRINT 'Dropping Procedure adfPositionCreateInternal'
		DROP  Procedure  adfPositionCreateInternal
	END

GO

PRINT 'Creating Procedure adfPositionCreateInternal'
GO
/******************************************************************************
**		File: 
**		Name: adfPositionCreateInternal
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPositionCreateInternal
	@FileAs TName,
	@ID TIdentifier OUTPUT
AS
	DECLARE @Code TCode, @Index INT
	
	SET NOCOUNT ON

	SELECT @Index = (COUNT(*) + 1) FROM [Position] WHERE [State] = 100
	
	SET @Code = CAST(@FileAs as VARCHAR(3)) + CAST(@Index as varchar(10))
	
	INSERT INTO [Position]
		([Flag], [State], [Code], [FileAs])
	VALUES
		(0, 100, @Code, @FileAs)
		
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	RETURN 0
GO

