IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfStateList')
	BEGIN
		PRINT 'Dropping Procedure adfStateList'
		DROP  Procedure  adfStateList
	END

GO

PRINT 'Creating Procedure adfStateList'
GO
/******************************************************************************
**		File: 
**		Name: adfStateList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfStateList
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[State].[Class],
		[State].[State],
		ISNULL([StateGlobal].[Name], [State].[Name]) as [Name],
		[Class].[Code] as [ClassCode]
	FROM
		[State] INNER JOIN [Class]
			ON ([State].[Class] = [Class].[Class])
		LEFT OUTER JOIN [StateGlobal]
			ON ([State].[Class]=[StateGlobal].[Class] AND [State].[State]=[StateGlobal].[State] 
				AND [StateGlobal].[Language] = @Lang)
	RETURN 0
GO

GRANT EXEC ON adfStateList TO PUBLIC
GO
