IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfSecurityImportValidateTransitionID')
	BEGIN
		PRINT 'Dropping Procedure adfSecurityImportValidateTransitionID'
		DROP  Procedure  adfSecurityImportValidateTransitionID
	END

GO

PRINT 'Creating Procedure adfSecurityImportValidateTransitionID'
GO
/******************************************************************************
**		File: 
**		Name: adfSecurityImportValidateTransitionID
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.03.13	SOV				 OpenXml  Xml
*******************************************************************************/
CREATE Procedure adfSecurityImportValidateTransitionID
	@Xml XML, @OldTransitionTemplateID TIdentifier, @NewTransitionTemplateID TIdentifier OUTPUT
AS
	DECLARE @Guid TGuid, @FromState TState, @ToState TState, @Class TClass
	
	SET NOCOUNT ON

	SELECT 
		[XmlTable].value('Guid[1]', 'uniqueidentifier'), 
		[XmlTable].value('FromState[1]', 'INT'), 
		[XmlTable].value('ToState[1]', 'INT')
	FROM 
		@Xml.nodes('/SecurityDataSet/TransitionTemplate') AS List(XmlTable)
	WHERE
		[XmlTable].value('ID[1]', 'INT') = @OldTransitionTemplateID

	SELECT @Class = [Class] FROM [Class] WHERE [Guid] = @Guid
	
	SELECT
		@NewTransitionTemplateID = [ID]
	FROM
		[TransitionTemplate]
	WHERE
		[Class]=@Class 
	AND 
		((@FromState IS NULL AND [FromState] IS NULL) OR (@FromState IS NOT NULL AND [FromState]=@FromState)) 
	AND 
		((@ToState IS NULL AND [ToState] IS NULL) OR (@ToState IS NOT NULL AND [ToState]=@ToState)) 
		

	RETURN 0
GO

