IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfClassCreate')
	BEGIN
		PRINT 'Dropping Procedure adfClassCreate'
		DROP  Procedure  adfClassCreate
	END

GO

PRINT 'Creating Procedure adfClassCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfClassCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfClassCreate
	@Code					TCode,
	@Name					TName,
	@ClassGuid				TGuid,
	@Comments				TNotes,
	@CodeIsUnique			TBool,
	@CodeIsNullable			TBool,
	@TableName				TSysname,
	@SmallImage				TPicture,
	@LargeImage				TPicture,
	@SPBrowse				TSysname,
	@SPGet					TSysname,
	@SPCreate				TSysname,
	@SPUpdate				TSysname,
	@SPChangeState			TSysname,
	@SPDelete				TSysname
AS
	DECLARE @Class TClass
	SET NOCOUNT ON
	
	IF @ClassGuid IS NULL
		SET @ClassGuid=NEWID()
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	BEGIN TRANSACTION
	
	INSERT INTO [Class]
		([Code], [Name], [Guid], [Comments], [CodeIsUnique], [CodeIsNullable],
		[TableName], [SmallImage], [LargeImage],
		[SPBrowse], [SPGet], [SPCreate], [SPUpdate], [SPChangeState], [SPDelete])
	VALUES
		(@Code, @Name, @ClassGuid, @Comments, @CodeIsUnique, @CodeIsNullable,
		@TableName, @SmallImage, @LargeImage,
		@SPBrowse, @SPGet, @SPCreate, @SPUpdate, @SPChangeState, @SPDelete)
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	
	SET @Class = SCOPE_IDENTITY()
	
	INSERT INTO [ClassGlobal]
		([Class], [Language], [Name], [Comments])
	VALUES
		(@Class, @Lang, @Name, @Comments)

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
		
	EXEC adfClassGet @Class
	
	RETURN 0
GO

GRANT EXEC ON adfClassCreate TO PUBLIC
GO
