IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfClientValidate')
	BEGIN
		PRINT 'Dropping Procedure adfClientValidate'
		DROP  Procedure  adfClientValidate
	END

GO

PRINT 'Creating Procedure adfClientValidate'
GO
/******************************************************************************
**		File: 
**		Name: adfClientValidate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfClientValidate
	@Version varchar(32),
	@AdfVersion varchar(32)
AS
/*
	IF		(	
					@Version IS NOT NULL
			AND NOT	(	EXISTS(SELECT * FROM vwSetting WHERE [Group] = 'Version' AND [Name] = 'Compatible' AND CAST([Value] AS varchar(32)) <= @Version)
					AND EXISTS(SELECT * FROM vwSetting WHERE [Group] = 'Version' AND [Name] = 'Current' AND CAST([Value] AS varchar(32)) >= @Version)
					)
			)
	OR NOT	(
					EXISTS(SELECT * FROM vwSetting WHERE [Group] = 'AdfVersion' AND [Name] = 'Compatible' AND CAST([Value] AS varchar(32)) <= @AdfVersion)
			AND		EXISTS(SELECT * FROM vwSetting WHERE [Group] = 'AdfVersion' AND [Name] = 'Current' AND CAST([Value] AS varchar(32)) >= @AdfVersion)
			)
	BEGIN
		RAISERROR('#VersionIsOutdated', 18, -1)
		RETURN 1
	END
*/
	DECLARE @Param TVariant, @result INT, @Ver varchar(8000)
	
	SET NOCOUNT ON

	EXEC @result = adfParameterGet 'DatabaseVersion', 'VersionInfo', @Param OUTPUT
	SET @Ver = CAST(@Param as varchar(8000))
	
	SELECT 
		[User].[ID],
		SUSER_SNAME() AS [Login],
		[Trustee].[Name],
		[User].[Locked],
		[User].[NTLogin],
		[User].[SQLLogin],
		@Ver as [Version],
		[User].[ProductKey],
		[User].[SerialNumber],
		[User].[IsPermanent],
		[User].[InitialDate],
		[User].[ValidationData],
		(CASE WHEN [EmployeeTimeZone].[TimeZone] IS NOT NULL THEN [EmployeeTimeZone].[TimeZone] ELSE '' END) AS [TimeZone]
	FROM
		[User] INNER JOIN [Trustee] ON ([User].[ID] = [Trustee].[ID])
		LEFT OUTER JOIN [Employee]
			ON [User].[ID] = [Employee].[UserID]
		LEFT OUTER JOIN [EmployeeTimeZone]
			ON [Employee].[ID] = [EmployeeTimeZone].[EmployeeID]
	WHERE
		[User].[ID] = dbo.adfGetCurrentUserID()
		
	RETURN 0
GO

GRANT EXEC ON adfClientValidate TO PUBLIC
GO
