IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleCreate')
	BEGIN
		PRINT 'Dropping Procedure adfRoleCreate'
		DROP  Procedure  adfRoleCreate
	END

GO

PRINT 'Creating Procedure adfRoleCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfRoleCreate
	@Name TSysname,
	@DisplayName TName,
	@Comments TNotes
AS
	DECLARE @ID TIdentifier, 
			@result INT
	
	SET NOCOUNT ON
	
	EXEC @result = adfAccessRightCheck 'ManageRights'
	IF @result != 0
		RETURN @result
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	BEGIN TRANSACTION
	
	INSERT INTO [Trustee] 
		([Name], [DisplayName], [Comments]) 
	VALUES
		(@Name, @DisplayName, @Comments)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [TrusteeGlobal]
		([ID], [Language], [DisplayName], [Comments])
	VALUES
		(@ID, @Lang, @DisplayName, @Comments)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [Role] ([ID], [IsGroup]) VALUES(@ID, 0)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
	
	EXEC adfRoleGet @ID

	RETURN 0
GO

GRANT EXEC ON adfRoleCreate TO PUBLIC
GO
