IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleUsersGet')
	BEGIN
		PRINT 'Dropping Procedure adfRoleUsersGet'
		DROP  Procedure  adfRoleUsersGet
	END

GO

PRINT 'Creating Procedure adfRoleUsersGet'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleUsersGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfRoleUsersGet
	@Name TSysname
AS
	SET NOCOUNT ON

	SELECT
		[Trustee].[Name],
		[Trustee].[DisplayName]
	FROM
		[UserRole] 
		INNER JOIN [Role] ON
			[UserRole].[RoleID] = [Role].[ID]
		INNER JOIN [Trustee] ON
			[UserRole].[UserID] = [Trustee].[ID]
		INNER JOIN [Employee]
			ON [Trustee].[ID] = [Employee].[UserID] 
	WHERE
		[Role].[ID] = dbo.adfGetRoleID(@Name) AND
		([Role].[IsGroup] = 0 OR [Employee].[State] = 1)
		
	ORDER BY
		[Trustee].[DisplayName]

	RETURN 0
GO

GRANT EXEC ON adfRoleUsersGet TO PUBLIC
GO
