IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserDelete')
	BEGIN
		PRINT 'Dropping Procedure adfUserDelete'
		DROP  Procedure  adfUserDelete
	END

GO

PRINT 'Creating Procedure adfUserDelete'
GO
/******************************************************************************
**		File: 
**		Name: adfUserDelete
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserDelete
	@Name TSysname
AS
	SET NOCOUNT ON
	DECLARE 
		@result INT,
		@UserID TIdentifier
	
	EXEC @result = adfAccessRightCheck 'ManageUsers'
	IF @result != 0
		RETURN @result
	
	SET @UserID = dbo.adfGetUserID(@Name)
	
	BEGIN TRANSACTION

	UPDATE [Employee]
	SET
		[UserID] = NULL
	WHERE
		[UserID] = @UserID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [CalendarEmployee] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [CalendarProject] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [CalendarResource] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [ExchangeAttributesForSync] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [ExchangeDocumentSync] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [ExchangeSync] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [IssueProject] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	--DELETE FROM [Presence] WHERE [ID] = @UserID
	--IF @@ERROR != 0
	--BEGIN
	--	ROLLBACK TRANSACTION
	--	RETURN 1
	--END

	DELETE FROM [ReminderSetting] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [UserReminder] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [SearchFolder] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [Sticker] WHERE [RecipientUserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [SubscriptionRule] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	--DELETE FROM [SuperTimer] WHERE [CreatedBy] = @UserID
	--IF @@ERROR != 0
	--BEGIN
	--	ROLLBACK TRANSACTION
	--	RETURN 1
	--END

	DELETE FROM [UserContact] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [UserFavoriteFolder] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [UserNTLoginMapping] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [UserParameter] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [UserRole] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE [Trustee] WHERE [Trustee].[ID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXEC ON adfUserDelete TO PUBLIC
GO


