IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserRightsGet')
	BEGIN
		PRINT 'Dropping Procedure adfUserRightsGet'
		DROP  Procedure  adfUserRightsGet
	END

GO

PRINT 'Creating Procedure adfUserRightsGet'
GO
/******************************************************************************
**		File: 
**		Name: adfUserRightsGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values: 
** 
**		Called by: UserRights
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		15/06/11	YVI             procedure for getting Rights for User specified
**		05.06.14	SAP				    Active
*******************************************************************************/
--TO-DO add Rights.Global
CREATE PROCEDURE adfUserRightsGet
	@Name TSysname -- user name
AS
	DECLARE @UserID TIdentifier
	
	SET NOCOUNT ON
	
	SET @UserID = dbo.adfGetUserID(@Name)
	
	SELECT DISTINCT
		[Right].[Name],
		[Right].[DisplayName],
		[Right].[Active]
	FROM
		[AccessRight] INNER JOIN [Right]
			ON ([AccessRight].[RightID] = [Right].[ID])
	WHERE
		[AccessRight].[TrusteeID] = @UserID
	RETURN 0
GO

GRANT EXEC ON adfUserRightsGet TO PUBLIC
GO
