IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfuiClassTransitionBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfuiClassTransitionBrowse'
		DROP  Procedure  adfuiClassTransitionBrowse
	END

GO

PRINT 'Creating Procedure adfuiClassTransitionBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfuiClassTransitionBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfuiClassTransitionBrowse
	@Guid TGuid
AS
	SET NOCOUNT ON

	SELECT 
		[TransitionTemplate].[ID],
		[TransitionTemplate].[FromState],
		[TransitionTemplate].[ToState],
		[UICommand].[Name] as [Command],
		[TransitionTemplate].[ActionID],
		[Right].[Name] as [Right],
		[TransitionTemplate].[ConfirmationMessage]
	FROM 
		[adfvwTransitionTemplate] as [TransitionTemplate] INNER JOIN [adfvwClass] as [Class]
			ON ([TransitionTemplate].[Class] = [Class].[Class])
		LEFT OUTER JOIN [adfvwUICommand] as [UICommand]
			ON ([TransitionTemplate].[UICommandID] = [UICommand].[ID])
		INNER JOIN [adfvwRight] as [Right]
			ON ([TransitionTemplate].[RightID] = [Right].[ID])
		INNER JOIN dbo.adfGetCurrentUserRights() C
			ON ([Right].[ID] = [C].[ID])
	WHERE
		[Class].[Guid] = @Guid
	ORDER BY
		[UICommand].[Text]
		
	SELECT
		[State].[State],
		[State].[UIText]
	FROM
		[adfvwState] as [State] INNER JOIN [Class]
			ON ([State].[Class] = [Class].[Class])
	WHERE
		[Class].[Guid] = @Guid
	AND
		[State].[UIText] IS NOT NULL
		
	RETURN 0
GO

GRANT EXEC ON adfuiClassTransitionBrowse TO PUBLIC
GO
