IF NOT EXISTS (SELECT * FROM sys.types st JOIN sys.schemas ss ON st.schema_id = ss.schema_id WHERE st.name = N'TKey' AND ss.name = N'dbo')
BEGIN
	CREATE TYPE TKey FROM varbinary(40)
	GRANT REFERENCES ON TYPE ::dbo.TKey TO PUBLIC
END
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'License') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	create table License
	(
		ID					TIdentifier			identity,
		UserID				TIdentifier			null,
		Code				TCode				not null,
		Name				TName				not null,
		PerUser				TBool				not null default 1,
		Created				TDate				not null,
		Initialized			TDate				null,
		Functions			TNotes				not null,
		Value				TKey				not null,
		SignedValue			TKey				not null,
		constraint LicensePK primary key (ID),
		constraint LicenseValueAK unique (Value)
	)
END