set nocount on
/*
	Drop defaults for audit fields
*/
declare auditFields cursor local forward_only read_only for
	select name, object_name(id) from syscolumns 
	where name in ('CreatedBy', 'ModifiedBy') and objectproperty(id, N'IsUserTable') = 1
open auditFields

declare @columnName sysname, @tableName sysname, @sql nvarchar(4000), @name varchar(128), @count int

set @count = 0
fetch next from auditFields into @columnName, @tableName
while @@fetch_status = 0
begin
	set @name = N'adfDefault' + @tableName + @columnName
	
	if exists(select * from sysobjects where id = object_id(@name) and objectproperty(id, N'IsDefaultCnst') = 1)
	begin
		select @sql = N'alter table [dbo].[' + @tableName + N'] drop constraint [' + @name + N']';
		exec sp_executesql @sql;
		set @count = @count + 1;
	end			
	fetch next from auditFields into @columnName, @tableName;
end

print N'dropped ' + cast(@count as nvarchar(10)) + N' default constraints'

close auditFields
deallocate auditFields
go

if  exists (select * from sys.objects where object_id = object_id(N'[dbo].[adfGetCurrentUserID]') and type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
begin
	print 'dropping function [dbo].[adfGetCurrentUserID]'
	drop function [dbo].[adfGetCurrentUserID]
end
go

print 'creating function [dbo].[adfGetCurrentUserID]'
go

create function [dbo].[adfGetCurrentUserID]()
returns int
as
begin
	declare @login sysname, @returnValue int
				
	set @login = suser_sname()

	if charindex('\', @login) > 0
		select @returnValue	= [User].[ID] from [User] where [User].[NTLogin] = @login
	ELSE
		select @returnValue	= [User].[ID] from [User] where [User].[SQLLogin] = @login
		
	if @returnValue is not null
		return @returnValue

	if is_member('db_owner') = 1 or user_name() = 'pjmexchangesync'
		return 1
			
	return null
end

go

set nocount on
/*
	Create defaults for audit fields
*/
declare auditFields cursor local forward_only read_only for
	select name, object_name(id) from syscolumns 
	where name in ('CreatedBy', 'ModifiedBy') and OBJECTPROPERTY(id, N'IsUserTable') = 1

open auditFields

declare @columnName sysname, @tableName sysname, @sql nvarchar(4000), @name varchar(128), @count int

set @count = 0

fetch next from auditFields into @columnName, @tableName
while @@fetch_status = 0
begin
	set @name = N'adfDefault' + @tableName + @columnName
	set @sql = N'alter table [dbo].[' + @tableName + N'] add constraint [' + @name + N'] default dbo.adfGetCurrentUserID() FOR ' + @columnName
	exec sp_executesql @sql
	set @count = @count + 1
	fetch next from auditFields into @columnName, @tableName
end
print N'created ' + cast(@count as nvarchar(10)) + N' default constraints'

close auditFields
deallocate auditFields
go