﻿/******************************************************************************
**		File: TransitionTemplateMethodsInitialize.sql
**		Name: 
**		Desc: Скрипт, где указываются какие методы будут выполняться после 
			  изменения состояния документа
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAB
**		Date: 26.11.2012
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		23.11.12	MAB				Вставка методов для Актов
**		30.06.14	SAP				Добавлены методы для калькуляции
*******************************************************************************/
UPDATE 
	[TransitionTemplate] 
SET 
	[PreProcessMethod] = 'PreTransitionToApproved', 
	[PostProcessMethod] = 'PostTransitionToApproved' 
WHERE
	[TransitionTemplate].[Class] = dbo.adfGetClassByName('Pjm5.Statement')
	AND
	[TransitionTemplate].[FromState] IN (1, 3)
	AND
	[TransitionTemplate].[ToState] = 2
	AND
	[TransitionTemplate].[ActionID] = 0


UPDATE 
	[TransitionTemplate] 
SET 
	[PreProcessMethod] = 'PreTransitionToApproved', 
	[PostProcessMethod] = 'PostTransitionToApproved' 
WHERE
	[TransitionTemplate].[Class] = dbo.adfGetClassByName('Pjm5.Calculation')
	AND
	[TransitionTemplate].[FromState] = 1
	AND
	[TransitionTemplate].[ToState] = 2

