﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[DivisionGetOrCreate]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure DivisionGetOrCreate'
	drop procedure [exch].[DivisionGetOrCreate]
end
go

print 'Creating procedure DivisionGetOrCreate'
go

create procedure [exch].[DivisionGetOrCreate] @Division TName, @UserID TIdentifier, @CompanyID TIdentifier, @DivisionID TIdentifier output
with execute as 'pjmexchangesync'
as
begin
	set nocount on;
	
	declare @State TState, @SyncComment TNotes, @UserName TName;
	
	set @DivisionID = null;

	if @Division is not null
	begin
		select @DivisionID = [ID] from [dbo].[Division] where [FileAs] = @Division and [CompanyID] = @CompanyID;

		if @DivisionID is null 
		begin
			select @UserName = [FileAs] from [Employee] where [UserID] = @UserID;

			set @SyncComment = N'Подразделение создан ' + CONVERT(nvarchar(8), GETDATE(), 4)  + N' в результате синхронизации с Microsoft Exchange' +
				(case when @UserName is not null then  N' почтового ящика пользователя ''' + @UserName +  N'''' else N'' end);

			insert into [dbo].[Division]
				([State], [Code], [CompanyID], [FileAs], [Comments])
			values
				(1, SUBSTRING(@Division, 1, 32), @CompanyID, @Division, @SyncComment);

			set @DivisionID = SCOPE_IDENTITY();
		end
	end
	return 0;
end
GO


