﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[PositionGetOrCreate]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure PositionGetOrCreate'
	drop procedure [exch].[PositionGetOrCreate]
end
go

print 'Creating procedure PositionGetOrCreate'
go

create procedure [exch].[PositionGetOrCreate] @Position TName, @UserID TIdentifier, @PositionID TIdentifier output
with execute as 'pjmexchangesync'
as
begin
	set nocount on;
	
	declare @State TState, @SyncComment TNotes, @UserName TName;
	
	set @PositionID = null;

	if @Position is not null
	begin
		select @PositionID = [ID] from [Position] where	[FileAs] = @Position;

		if @PositionID is null 
		begin
			select @UserName = [FileAs] from [Employee] where [UserID] = @UserID;

			set @SyncComment = N'Должность создана ' + CONVERT(nvarchar(8), GETDATE(), 4)  + N' в результате синхронизации с Microsoft Exchange' +
				(case when @UserName is not null then  N' почтового ящика пользователя ''' + @UserName +  N'''' else N'' end);

			insert into [Position]
				([State], [Code], [FileAs], [Comments])
			values
				(1, SUBSTRING(@Position, 1, 32), @Position, @SyncComment);

			set @PositionID = SCOPE_IDENTITY();
		end
	end
	return 0;
end
GO


