﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[ServiceParametersGet]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure ServiceParametersGet'
	drop procedure [exch].[ServiceParametersGet]
end
go

print 'Creating procedure ServiceParametersGet'
go

create procedure [exch].[ServiceParametersGet]
with execute as 'pjmexchangesync'
as
begin
	set nocount on;
	select 
		[Name], 
		[Value]
	from 
		[dbo].[F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] as [Value] 
	where 
		Name in ('ExchangeContactSyncMode',
				'ExchangeSyncAdministrator',
				'ExchangeSyncCalendars',
				'ExchangeSyncContacts',
				'ExchangeSyncMeetingRequests',
				'ExchangeSyncServerName',
				'DataBaseTimeZone',
				'CleanUpSyncData')
	for xml auto, root('Parameters');
	return 0;
end;
go


grant execute on [exch].[ServiceParametersGet] to [projectmateservice];
go
