IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetBudgetTotal') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetBudgetTotal'
		DROP FUNCTION [dbo].fnPjm6GetBudgetTotal
	END

GO

PRINT 'Creating function fnPjm6GetBudgetTotal'
GO
/******************************************************************************
**		File:	fnPjm6GetBudgetTotal.sql
**		Name: 	fnPjm6GetBudgetTotal
**		Desc:	
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	18.02.11		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetBudgetTotal(
	@VATRate			TPercent,
	@VATIsIncluded		TBool,
	@Total				TMoney,
	@TotalWithVAT		TMoney,
	@TotalType			TName)
RETURNS TMoney
BEGIN
	DECLARE
		@totalSum			TMoney
		
	SET @totalSum = 
		(CASE 
			WHEN @TotalType = 'ManHour' THEN
				(CASE 
					WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN 
						@TotalWithVAT
					ELSE 
						@Total
				END)
			WHEN @TotalType = 'Expense' THEN
				(CASE 
					WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN 
						@Total + dbo.fnPjm6GetVATForTotal(@Total, @VATRate, 0, 1)
					ELSE 
						@Total
				END)
		END)

	RETURN @totalSum
END
GO

GRANT EXEC ON fnPjm6GetBudgetTotal TO PUBLIC
GO