﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetBudgetTotalWithDiscount') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetBudgetTotalWithDiscount'
		DROP FUNCTION [dbo].fnPjm6GetBudgetTotalWithDiscount
	END

GO

PRINT 'Creating function fnPjm6GetBudgetTotalWithDiscount'
GO
/******************************************************************************
**		File:	fnPjm6GetTotalWithDiscount.sql
**		Name: 	fnPjm6GetTotalWithDiscount
**		Desc:	returns formatted time interval
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	18.02.11		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetBudgetTotalWithDiscount(
	@VATRate			TPercent,
	@VATIsIncluded		TBool,
	@DiscountView		TBool,
	@DiscountPercent	TMoney,
	@DiscountTotal		TMoney,
	@Total				TMoney,
	@TotalWithVAT		TMoney)
RETURNS TMoney
BEGIN
	DECLARE
		@totalSum			TMoney
		
		SET @totalSum = 
			(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN 
				@TotalWithVAT + dbo.fnPjm6GetBudgetTotalDiscount(@DiscountView, @DiscountPercent, @DiscountTotal, @TotalWithVAT)
				ELSE
				@Total + dbo.fnPjm6GetBudgetTotalDiscount(@DiscountView, @DiscountPercent, @DiscountTotal, @Total)
			END)
		
	RETURN @totalSum
END
GO

GRANT EXEC ON fnPjm6GetBudgetTotalWithDiscount TO PUBLIC
GO