IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetAssignmentListByTask]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetAssignmentListByTask'
		DROP FUNCTION [dbo].[fnPjm5GetAssignmentListByTask]
	END

GO

PRINT 'Creating function fnPjm5GetAssignmentListByTask'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetAssignmentListByTask(@TaskID TIdentifier)
RETURNS nvarchar(4000)
AS
BEGIN
	DECLARE @AssignmentName	nvarchar(4000),
			@tmpName		TName,
			@tmpPercent		int
			
		DECLARE assignment CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		SELECT
			[Assignment].[FileAs],
			[TaskAssignment].[Units] * 100
		FROM
			[Assignment]
		INNER JOIN [TaskAssignment]
			ON [Assignment].[ID]=[TaskAssignment].[AssignmentID]
		INNER JOIN [Task]
			ON [TaskAssignment].[TaskID]=[Task].[ID]
		WHERE
			[Task].[ID] = @TaskID	
			
		OPEN assignment
		FETCH NEXT FROM assignment INTO @tmpName,@tmpPercent
		
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--------------
			SELECT @AssignmentName = ISNULL(@AssignmentName + ', ', '') + @tmpName + ' (' + CAST(@tmpPercent AS VARCHAR) + '%)'
			--------------
			FETCH NEXT FROM assignment INTO @tmpName,@tmpPercent
		END
		CLOSE assignment
		DEALLOCATE assignment
	RETURN(@AssignmentName)
END
GO

GRANT EXEC ON fnPjm5GetAssignmentListByTask TO PUBLIC
GO
