IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5IsProjectManager]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5IsProjectManager'
		DROP FUNCTION [dbo].[fnPjm5IsProjectManager]
	END

GO

PRINT 'Creating function fnPjm5IsProjectManager'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5IsProjectManager
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5IsProjectManager
	(@ProjectID TIdentifier, @EmployeeID TIdentifier)
RETURNS BIT
AS
BEGIN
	DECLARE @result BIT
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	DECLARE @ProjectManagerEmployeeID TIdentifier
	
	SELECT @ProjectManagerEmployeeID = [ProjectManagerEmployeeID] FROM [Project] WHERE [ID] = @ProjectID
	
	IF @EmployeeID = @ProjectManagerEmployeeID AND
		dbo.adfHasAccessRightByName('ManageProject') = 1
		SET @result = 1
	ELSE
		SET @result = 0
	
	RETURN @result
END
GO

GRANT EXEC ON fnPjm5IsProjectManager TO PUBLIC
GO
