IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5NonWorkingTime]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5NonWorkingTime'
		DROP FUNCTION [dbo].[fnPjm5NonWorkingTime]
	END

GO

PRINT 'Creating function fnPjm5NonWorkingTime'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5IsWorkingDay
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5NonWorkingTime(@start datetime)
RETURNS bit
AS
BEGIN
	DECLARE @curdate datetime,
			@curday int,
			@curmonth int,
			@res bit

	SET @curdate = CAST(CONVERT(varchar(8), @start, 112) AS DATETIME)
	SET @curday = DATEPART(day, @curdate)
	SET @curmonth = DATEPART(month, @curdate)
		
	SELECT 
		@res = [NonWorkingTime]
		FROM [Calendar]
		WHERE
		(
			[Recurrent] = 0 AND
			(CAST(CONVERT(varchar(8), [Date], 112) AS DATETIME) = @curdate)
		) OR
		(
			[Recurrent] = 1 AND (DATEPART(day, [Calendar].[Date]) = @curday) AND
			(DATEPART(month, [Calendar].[Date]) = @curmonth)
		)	

	RETURN @res
END
GO

GRANT EXEC ON fnPjm5NonWorkingTime TO PUBLIC
GO
   