 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6AllowCreateResourceRequest]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6AllowCreateResourceRequest'
		DROP FUNCTION [dbo].[fnPjm6AllowCreateResourceRequest]
	END

GO

PRINT 'Creating function fnPjm6AllowCreateResourceRequest'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6AllowCreateResourceRequest
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: SYV
**		Date: 04.10.2010
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		01.04.13	SOV				 ,    . -
*******************************************************************************/
CREATE FUNCTION fnPjm6AllowCreateResourceRequest(
	@ProjectID TIdentifier, 
	@EmployeeID TIdentifier
	)
RETURNS BIT
AS
BEGIN
	DECLARE @CurrentEmployeeID TIdentifier,
			@CanViewResourceRequest		TBool,
			@ViewAllFinance			TBool,
			@ViewAllProjects		TBool, 
			@Assistant				TBool,
			@ProjectManagerEmployeeID TIdentifier

	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) 
	SET @Assistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
	
	IF (@ViewAllFinance = 1) OR (@ViewAllProjects = 1 AND @Assistant = 1)
		SET @CanViewResourceRequest = 1
	ELSE
		SET @CanViewResourceRequest = 0
			
	SET @ProjectManagerEmployeeID = (SELECT [ProjectManagerEmployeeID] FROM [Project] where [ID] = @ProjectID)
	
	IF (@CanViewResourceRequest = 0 AND 
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0 AND
		dbo.fnPjm7IsManagerAssistant(@ProjectID, @EmployeeID) = 0 AND
		ISNULL(@ProjectManagerEmployeeID, -1) <> @EmployeeID)
	BEGIN
		RETURN 0
	END	
	
	RETURN 1
END
GO

GRANT EXEC ON fnPjm6AllowCreateResourceRequest TO PUBLIC
GO
