IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm7GetEmployeeBirthdayFormatted') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetEmployeeBirthdayFormatted'
		DROP FUNCTION [dbo].fnPjm7GetEmployeeBirthdayFormatted
	END

GO

PRINT 'Creating Function fnPjm7GetEmployeeBirthdayFormatted'
GO
/******************************************************************************
**		File:	fnPjm7GetEmployeeBirthdayFormatted.sql
**		Name: 	fnPjm7GetEmployeeBirthdayFormatted
**		Desc:	returns 
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	23.11.11		ASA		first version
*******************************************************************************/

CREATE FUNCTION fnPjm7GetEmployeeBirthdayFormatted(@Birthdate datetime)
RETURNS varchar(64)
BEGIN
	DECLARE
		@Language TCode, 
		@CurrentWeek int,
		@NextWeek int,
		@CurrentMonth int,
		@NextMonth int,
		@IsNext2Weeks bit,
		@DateFirstBefore int,
		@Today int,
		@Tomorrow int,
		@JanuaryFirstBirthDate int,
		@JanuaryFirstThisYear int,
		@Adjust int,
		@Result varchar(64)

	IF(@Birthdate IS NULL)
		RETURN NULL

	SET @CurrentWeek = DATEPART(week, GetDate())
	SET @NextWeek = DATEPART(week, DATEADD(week, 1, GetDate()))
	SET @CurrentMonth = DATEPART(month, GetDate())
	SET @NextMonth = DATEPART(month, DATEADD(month, 1, GetDate()))
	SET @Today = DATEPART(day, GetDate())
	SET @Tomorrow = DATEPART(day, DATEADD(day, 1, GetDate()))
	SET @JanuaryFirstBirthDate = Datepart(dw, CAST(convert(varchar(4),YEAR(@Birthdate))+'-01-01 00:00:00.000' AS datetime))
	SET @JanuaryFirstThisYear = Datepart(dw, CAST(convert(varchar(4),YEAR(GetDate()))+'-01-01 00:00:00.000' AS datetime))
	--       
	SET @Adjust = @JanuaryFirstThisYear - @JanuaryFirstBirthDate
	--   
	IF(isdate(datename(year,@Birthdate)+'0229') = 1 AND Datepart(month, @Birthdate) > 2)
	BEGIN
		SET @Adjust = @Adjust - 1
	END

	SET @Result = ''
	SET @language = dbo.adfGetLanguage()

	IF(@Language = 'en')
	BEGIN
		IF(DATEPART(day,@Birthdate) = @Today AND DATEPART(month,@Birthdate) = @CurrentMonth)
		BEGIN
			SET @Result = '7Today'
			RETURN @Result
		END
		IF(DATEPART(day,@Birthdate) = @Tomorrow AND DATEPART(month,@Birthdate) = DATEPART(month, DATEADD(day, 1, GetDate())))
		BEGIN
			SET @Result = '6Tomorrow'
			RETURN @Result
		END
		IF(DATEPART(week,DATEADD(day,@Adjust,@Birthdate)) = @CurrentWeek)
		BEGIN
			IF ((DATEPART(month,@Birthdate) = @CurrentMonth AND DATEPART(day,@Birthdate) < DATEPART(day,GetDate())) OR (DATEPART(month,@Birthdate) < @CurrentMonth))
			BEGIN
				SET @Result = '1Later'
				RETURN @Result
			END
			ELSE
			BEGIN
				SET @Result = '5This week'
				RETURN @Result
			END
		END
		IF(DATEPART(week,DATEADD(day,@Adjust,@Birthdate)) = @NextWeek)
		BEGIN
			SET @Result = '4Next week'
			RETURN @Result
		END
		IF(DATEPART(month,@Birthdate) = @CurrentMonth)
		BEGIN
			IF(DATEPART(day,@Birthdate) >= DATEPART(day,GetDate()))
			BEGIN
				SET @Result = '3This month'
			END
			ELSE IF(DATEPART(day,@Birthdate) < DATEPART(day,GetDate()))
			BEGIN
				SET @Result = '1Later'
			END
			RETURN @Result
		END
		IF(DATEPART(month,@Birthdate) = @NextMonth)
		BEGIN
			SET @Result = '2Next month'
			RETURN @Result
		END
		ELSE
		BEGIN
			SET @Result = '1Later'
			RETURN @Result
		END
	END
	ELSE IF(@Language = 'ru')
	BEGIN
		IF(DATEPART(day,@Birthdate) = @Today AND DATEPART(month,@Birthdate) = @CurrentMonth)
		BEGIN
			SET @Result = '7'
			RETURN @Result
		END
		IF(DATEPART(day,@Birthdate) = @Tomorrow AND DATEPART(month,@Birthdate) = DATEPART(month, DATEADD(day, 1, GetDate())))
		BEGIN
			SET @Result = '6'
			RETURN @Result
		END
		IF(DATEPART(week,DATEADD(day,@Adjust,@Birthdate)) = @CurrentWeek)
		BEGIN
			IF (DATEPART(month,@Birthdate) = @CurrentMonth AND DATEPART(day,@Birthdate) < DATEPART(day,GetDate()) OR (DATEPART(month,@Birthdate) < @CurrentMonth))
			BEGIN
				SET @Result = '1'
				RETURN @Result
			END
			ELSE
			BEGIN
				SET @Result = '5  '
				RETURN @Result
			END
		END
		IF(DATEPART(week,DATEADD(day,@Adjust,@Birthdate)) = @NextWeek)
		BEGIN
			SET @Result = '4  '
			RETURN @Result
		END
		IF(DATEPART(month,@Birthdate) = @CurrentMonth)
		BEGIN
			IF(DATEPART(day,@Birthdate) >= DATEPART(day,GetDate()))
			BEGIN
				SET @Result = '3  '
			END
			ELSE IF(DATEPART(day,@Birthdate) < DATEPART(day,GetDate()))
			BEGIN
				SET @Result = '1'
			END
			RETURN @Result
		END
		IF(DATEPART(month,@Birthdate) = @NextMonth)
		BEGIN
			SET @Result = '2  '
			RETURN @Result
		END
		ELSE
		BEGIN
			SET @Result = '1'
			RETURN @Result
		END
	END	
	RETURN @Result
END
GO

GRANT EXEC ON fnPjm7GetEmployeeBirthdayFormatted TO PUBLIC
GO
