IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnReportCalculateSmartValue]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnReportCalculateSmartValue'
		DROP FUNCTION [dbo].[fnReportCalculateSmartValue]
	END

GO

PRINT 'Creating function fnReportCalculateSmartValue'
GO
/******************************************************************************
**		File: 
**		Name: fnReportCalculateSmartValue
**		Desc:    
**		
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Sergey Pelevin
**		Date: 24.04.14
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnReportCalculateSmartValue
(
	@ScaleSelector int, --  (0 - , 1 - , 2 - , 3 - )
	@MaxValue decimal(18,2) -- ,     
)
RETURNS int
AS
BEGIN

	DECLARE @Scale int

	IF @ScaleSelector = 3
	BEGIN
		--   (SmartValue)
		SET @Scale = 
			CASE  
				WHEN @MaxValue < 10000 THEN 1
				WHEN @MaxValue >= 10000 AND @MaxValue < 10000000 THEN 1000
				WHEN @MaxValue >= 10000000 AND @MaxValue < 10000000000 THEN 1000000
				WHEN @MaxValue >= 10000000000 THEN 1000000000
			END
	END
	ELSE
	BEGIN
		SET	@Scale = 
			CASE @ScaleSelector
				WHEN 0 THEN 1
				WHEN 1 THEN 1000
				WHEN 2 THEN 1000000
			END
	END	


	RETURN @Scale
END
