IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnReportSplitPeriodOnMonths]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnReportSplitPeriodOnMonths'
		DROP FUNCTION [dbo].[fnReportSplitPeriodOnMonths]
	END
GO

PRINT 'Creating function fnReportSplitPeriodOnMonths'
GO

/******************************************************************************
**		File: fnReportSplitPeriodOnMonths.sql
**		Name: fnReportSplitPeriodOnMonths
**
**              
**		Return values: 
**		   
**		Called by:   
**              
**		Parameters:
**		Input								Output
**      ----------							-----------
**		  
**		  
**		
**		
**		Auth: Sergey Pelevin
**		Date: 23.04.14 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		15.05.14	SAP				   " "
*******************************************************************************/
CREATE FUNCTION fnReportSplitPeriodOnMonths
(
	@PeriodStart date,
	@PeriodEnd date,
	@LangCode TCode3,
	@Short bit,
	@WithYears bit
)
RETURNS @Months TABLE
(
	PeriodStartDate date,
	PeriodEndDate date,
	PeriodName TName	
)
AS
BEGIN
	DECLARE @period int = 0, @dateDiff int = DATEDIFF(MONTH, @PeriodStart, @PeriodEnd)

	DECLARE @periodTab table ( [Number] int )
	
	WHILE @period <= @dateDiff
	BEGIN
		INSERT INTO @periodTab VALUES(@period)
		SET @period = @period + 1 
	END

	INSERT INTO @Months
	SELECT 
		DATEADD(MONTH, n.Number, @PeriodStart), 
		DATEADD(day, -1, DATEADD(MONTH, n.Number+1, @PeriodStart)),
		dbo.fnReportGetPeriodName(DATEADD(MONTH, n.Number, @PeriodStart), NULL,'ru',@Short,@WithYears)
	FROM 
		@periodTab AS n
	WHERE 
		n.Number <= @dateDiff	


RETURN
END
GO