IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5AssignmentBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5AssignmentBrowse'
		DROP PROCEDURE [dbo].[pjm5AssignmentBrowse]
	END
GO

PRINT 'Creating procedure pjm5AssignmentBrowse'
GO

/******************************************************************************
**		File: pjm5AssignmentBrowse.sql
**		Name: pjm5AssignmentBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:18:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		01.04.13	SOV				   @Approver
**		02.04.13	SOV				  " "   
**									 
*******************************************************************************/
CREATE PROCEDURE [pjm5AssignmentBrowse]
	@StateSelector INT,
	@ProjectID TIdentifier
AS
	
	SET NOCOUNT ON
	DECLARE 
		@ManagerID TIdentifier,
		@ProjectState TState,
		@ProjectTypeID TIdentifier
	
	SELECT 
		@ManagerID = [ProjectManagerEmployeeID],
		@ProjectState = [State],
		@ProjectTypeID = [ProjectTypeID]
	FROM 
		[Project] 
	WHERE 
		[ID] = @ProjectID
	
	DECLARE @IsFinanceEnable	bit,
			@ViewAllFinance TBool,
			@CurrentEmployeeID TIdentifier,
			@ViewFinance TBool,
			@IsMember TBool,
			@IsPM TBool,
			@IsAssignmentEditor TBool,
			@IsAssistant TBool,
			@FinanceManagement TBool
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @IsMember = dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)		

	SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance'))
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
	SET @IsPM = CASE @ManagerID WHEN @CurrentEmployeeID THEN 1 ELSE 0 END
	SET @FinanceManagement = dbo.fnPjm7HasPossibilityToProjectFinanceManagement(@ProjectID, @CurrentEmployeeID)
	
	SELECT @IsFinanceEnable = CASE
				WHEN (@CurrentEmployeeID = @ManagerID) THEN 1
				WHEN dbo.fnPjm7IsFinanceManager(@ProjectID, @CurrentEmployeeID) = 1 THEN 1
				WHEN @ProjectState IN (5,6) THEN 1
				WHEN @ViewFinance = 1 AND ((@IsMember = 1 AND @FinanceManagement = 1) OR
					(@IsAssistant = 1 AND dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment')) = 1)) THEN 1
				ELSE @ViewAllFinance
			END

	SELECT
		[Assignment].[Class],
		[Assignment].[ID],
		[Assignment].[State],
		[Assignment].[Flag],
		[Assignment].[FileAs],
		[Assignment].[EmployeeID],
		[Assignment].[ProjectID],
		[Assignment].[QualificationID],
		CASE
			WHEN (@IsFinanceEnable = 1 OR 
				([Assignment].[EmployeeID] = @CurrentEmployeeID AND [Assignment].[RateVisible] = 1)) AND (@ProjectTypeID = 1)
				THEN [Assignment].[StandardRate]
			WHEN @ProjectTypeID != 1 THEN 0.00
			ELSE -1
		END AS [StandardRate],
		CASE
			WHEN (@IsFinanceEnable = 1 OR 
				([Assignment].[EmployeeID] = @CurrentEmployeeID  AND [Assignment].[RateVisible] = 1)) AND (@ProjectTypeID = 1)
				THEN [Assignment].[OvertimeRate]
			WHEN @ProjectTypeID != 1 THEN 0.00
			ELSE -1
		END AS [OvertimeRate],
		(CASE WHEN [Assignment].[EmployeeID] = @ManagerID THEN 1 ELSE 0 END) as [Manager],
		[Assignment].[Approver],
		[Assignment].[Administrator],
		[Assignment].[FinanceManagement] AS Finance,
		[Assignment].[Comments],
		[Assignment].[Created],
		[Assignment].[CreatedBy],
		[Assignment].[Modified],
		[Assignment].[ModifiedBy],
		[Assignment].[Timestamp],
		[Employee].[CompanyID],
		(SELECT [Phone] FROM [Phone] WHERE [Phone].[BusinessCardID] = [Employee].[ID] AND [Phone].[BusinessCardClass] = [Employee].[Class] AND [Phone].[PhoneTypeID] = 1) as Phone1,
		(SELECT [Phone] FROM [Phone] WHERE [Phone].[BusinessCardID] = [Employee].[ID] AND [Phone].[BusinessCardClass] = [Employee].[Class] AND [Phone].[PhoneTypeID] = 2) as Phone2,
		(SELECT [Street] FROM [Address] WHERE [Address].[BusinessCardID] = [Employee].[ID] AND [Address].[BusinessCardClass] = [Employee].[Class] AND [Address].[AddressTypeID] = 3) as [Street],
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Employee].[ID] AND [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[EmailTypeID] = 1) as Email,
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Employee].[ID] AND [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[EmailTypeID] = 4) as WebPage
	FROM
		[vwAssignment] AS [Assignment]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Assignment].[EmployeeID]
	WHERE
		[Assignment].[ProjectID] = @ProjectID AND
		((@StateSelector = 0) OR (@StateSelector != 0 AND [Assignment].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5AssignmentBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5AssignmentGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5AssignmentGet'
		DROP PROCEDURE [dbo].[pjm5AssignmentGet]
	END
GO

PRINT 'Creating procedure pjm5AssignmentGet'
GO

/******************************************************************************
**		File: pjm5AssignmentGet.sql
**		Name: pjm5AssignmentGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:18:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		29.03.13	SOV				   ,    
**									  
**		29.03.13	SOV				 ,    . -
**		02.04.13	SOV				   ,    
**									  ;   
**									          
**									" ",   - . -
**		12.04.13	SOV				   -     
**									 
**		10.07.13	SOV				       - @IsMember
**		06.09.13	SOV				. -     
*******************************************************************************/
CREATE PROCEDURE [pjm5AssignmentGet]
	@ID TIdentifier
AS
	DECLARE 
		@ManagerID TIdentifier,
		@ProjectID TIdentifier,
		@ProjectState TState
	
	SET NOCOUNT ON
	DECLARE @P1 sql_variant
	
	SET @P1=N'RUB'
	
	EXEC adfParameterGet @Name = N'BaseCurrency', @Group = N'CommonBusiness', @Value = @P1 output
	
	SELECT 
		@ManagerID = [Project].[ProjectManagerEmployeeID],
		@ProjectID = [Project].[ID],
		@ProjectState = [Project].[State]
	FROM 
		[Project]
		INNER JOIN [Assignment]
			ON [Assignment].[ProjectID] = [Project].[ID]
	WHERE 
		[Assignment].[ID] = @ID
	
	DECLARE @IsFinanceEnable	bit,
			@ViewAllFinance TBool,
			@CurrentEmployeeID TIdentifier,
			@ViewFinance TBool,
			@IsMember TBool,
			@IsPM TBool,
			@IsAssignmentEditor TBool,
			@IsAssistant TBool,
			@IsManagerAssistant TBool,
			@FinanceManagement TBool,
			@IsFinanceManager TBool

		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @IsMember = dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)
	
	SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance'))
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
	SET @IsPM = CASE @ManagerID WHEN @CurrentEmployeeID THEN 1 ELSE 0 END
	SET @IsManagerAssistant = dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID)
	SET @IsAssignmentEditor = (@IsAssistant | @IsPM | @IsMember)
		& dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment'))

	SET @IsFinanceManager = dbo.fnPjm7IsFinanceManager(@ProjectID, @CurrentEmployeeID)
	SET @FinanceManagement = dbo.fnPjm7HasPossibilityToProjectFinanceManagement(@ProjectID, @CurrentEmployeeID)
	
	SELECT  @IsFinanceEnable = CASE
				WHEN (@CurrentEmployeeID = @ManagerID) THEN 1
				WHEN @IsFinanceManager = 1 THEN 1
				WHEN @ProjectState IN (5,6) THEN 1
				WHEN @ViewFinance = 1 AND @IsMember = 1 AND @FinanceManagement = 1 THEN 1
				ELSE @IsAssignmentEditor | @ViewAllFinance
			END
			
	SELECT
		[Assignment].[Class],
		[Assignment].[ID],
		[Assignment].[State],
		[Assignment].[Flag],
		[Assignment].[FileAs],
		[Assignment].[EmployeeID],
		[Assignment].[ProjectID],
		[Assignment].[QualificationID],
		CASE
			WHEN @IsFinanceEnable = 1 OR 
				([Assignment].[EmployeeID] = @CurrentEmployeeID AND [Assignment].[RateVisible] = 1)
				THEN [Assignment].[StandardRate]
			ELSE NULL
		END AS [StandardRate],
		CASE
			WHEN @IsFinanceEnable = 1 OR 
				([Assignment].[EmployeeID] = @CurrentEmployeeID  AND [Assignment].[RateVisible] = 1)
				THEN [Assignment].[OvertimeRate]
			ELSE NULL
		END AS [OvertimeRate],
		[Assignment].[RateVisible],
		(CASE WHEN [Assignment].[EmployeeID] = @ManagerID THEN 1 ELSE 0 END) as [Manager],
		[Assignment].[Approver],
		[Assignment].[Administrator],
		[Assignment].[FinanceManagement],
		[Assignment].[AlwaysUseRate],
		[Assignment].[Comments],
		[Assignment].[Created],
		[Assignment].[CreatedBy],
		[Assignment].[Modified],
		[Assignment].[ModifiedBy],
		[Assignment].[Timestamp],
		CAST(@P1 AS varchar(256)) AS [RateCurrencyCode],
		[Assignment].[ReceiveTaskStatusReports],
		[Assignment].[ReceiveIssueStatusReports],
		[Assignment].[EqualEmployeeFileAs],
		CASE 
			WHEN [Assignment].[State] = 1 
				THEN dbo.fnPjm7IsManagerAssistant(@ProjectID, [Assignment].[EmployeeID])
			ELSE 0
		END AS [ManagerAssistant],
		CASE 
			WHEN [Assignment].[State] = 1 
				THEN dbo.fnPjm7IsFinanceManager(@ProjectID, [Assignment].[EmployeeID])
			ELSE 0
		END AS [FinanceManager],
		CASE 
			WHEN [Employee].[UserID] IS NOT NULL AND 
				(dbo.adfHasAccessRightByNameForUser('ViewFinance', [Employee].[UserID]) = 1 OR
				dbo.adfHasAccessRightByNameForUser('ViewALLFinance', [Employee].[UserID]) = 1) THEN 1
			ELSE 0
		END AS [CanManageFinance] --      ?
	FROM
		[vwAssignment] AS [Assignment]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Assignment].[EmployeeID]
	WHERE
		[Assignment].[ID] = @ID
	
	SELECT
		[AssignmentEntry].[ID],
		[AssignmentEntry].[ValidFrom],
		[AssignmentEntry].[ValidTo],
		[AssignmentEntry].[EmployeeID],
		[Employee].[FileAs] AS [Employee]
	FROM
		[AssignmentEntry]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		[AssignmentEntry].[AssignmentID] = @ID
		
	SELECT 
		[MsResource].[ID]
	FROM
		[MsResource]
			INNER JOIN [Assignment]
				ON [MsResource].[ID]= [Assignment].[MsResourceID]
	WHERE
		[Assignment].[ID] = @ID
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5AssignmentGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5AssignmentCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5AssignmentCreate'
		DROP PROCEDURE [dbo].[pjm5AssignmentCreate]
	END
GO

PRINT 'Creating procedure pjm5AssignmentCreate'
GO

/******************************************************************************
**		File: pjm5AssignmentCreate.sql
**		Name: pjm5AssignmentCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:18:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		15.04.10	SYV				 ,    
**		07.03.13	SOV				 OpenXml  Xml
**		29.03.13	SOV				 ,    . -
*******************************************************************************/
CREATE PROCEDURE [pjm5AssignmentCreate]
	@Xml	XML
AS
	SET NOCOUNT ON
	DECLARE @State TState,
			@ID TIdentifier,
			@FileAs TName,
			@EmployeeID TIdentifier,
			@ProjectID TIdentifier,
			@QualificationID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@RateVisible TBool,
			@Approver TBool,
			@Administrator TBool,
			@FinanceManagement TBool,
			@TaskReport TBool,
			@IssueReport TBool,
			@Comments TNotes,
			@doc INT,
			@rv int,
			@AlwaysUseRate TBool,
			@IsMember TBool,
			@IsAssistant TBool,
			@IsAssignmentEditor TBool,
			@MsProjectID TIdentifier
	
	SET @State = dbo.adfwfGetInitialState('7797bd53-86ce-415e-9e13-b11bcbd52359')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT
		@FileAs = [XmlTable].value('FileAs[1]', 'nvarchar(256)'),
		@ProjectID = [XmlTable].value('ProjectID[1]', 'int'),
		@EmployeeID = [XmlTable].value('EmployeeID[1]', 'int'),
		@QualificationID = [XmlTable].value('QualificationID[1]', 'int'),
		@StandardRate = [XmlTable].value('StandardRate[1]', 'money'),
		@OvertimeRate = [XmlTable].value('OvertimeRate[1]', 'money'),
		@RateVisible = (CASE [XmlTable].value('RateVisible[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@Approver = (CASE [XmlTable].value('Approver[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@Administrator = (CASE [XmlTable].value('Administrator[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@FinanceManagement = (CASE @Xml.value('(/pjm5AssignmentGet/Assignment/FinanceManagement)[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@TaskReport = (CASE [XmlTable].value('ReceiveTaskStatusReports[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@IssueReport = (CASE [XmlTable].value('ReceiveIssueStatusReports[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@Comments = [XmlTable].value('Comments[1]', 'nvarchar(max)'),
		@AlwaysUseRate = (CASE [XmlTable].value('AlwaysUseRate[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END)   
	FROM
		@Xml.nodes('/pjm5AssignmentGet/Assignment') AS List(XmlTable)
	
	SELECT @MsProjectID = [MsProjectID] FROM [Project] WHERE [ID] = @ProjectID
	IF @MsProjectID IS NOT NULL
	BEGIN
		RAISERROR('#documentfrommsproject', 18, -1)
		RETURN 1
	END
	
	DECLARE 
		@CurrentEmployeeID int, 
		@ProjectState TState,
		@IsPM TBool,
		@IsProjectManager TBool

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND 
		dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID) = 0
	BEGIN
		SET @IsPM = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProjectTemplates'))
		SELECT @ProjectState = [State] FROM [Project] WHERE [ID] = @ProjectID
		
		SET @IsMember = dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)
		SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
		SET @IsAssignmentEditor = 
				(@IsAssistant | @IsMember) 
			& 
				(dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment')) & dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')))
		IF	(
			NOT(
				(@ProjectState IN (5, 6) AND @IsPM = 1) OR
				(@ProjectState NOT IN (5, 6) AND @IsAssignmentEditor = 1)
				)
			)
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	IF EXISTS (SELECT * FROM [ProjectTemplate] WHERE [ID] = @ProjectID)
	BEGIN
		SET @State = 3
	END
	
	IF @EmployeeID IS NOT NULL AND
		EXISTS (
		SELECT 
			*
		FROM
			[vwAssignment] AS [Assignment]
		WHERE
			[Assignment].[ProjectID]  = @ProjectID AND
			[Assignment].[EmployeeID]  = @EmployeeID AND
			[Assignment].[State] = @State
		) 
	BEGIN
		RAISERROR('#AssignmentAlreadyExist', 18, -1)
		RETURN 1
	END

	IF @EmployeeID IS NOT NULL AND
		EXISTS (
		SELECT 
			*
		FROM
			[Employee]
		WHERE
			[ID]  = @EmployeeID AND
			[State] = 2
		) 
	BEGIN
		RAISERROR('#EmployeeFire', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION
	EXEC @rv = pjm5AssignmentCreateInternal
			@ID OUTPUT,
			0,
			@State,
			@FileAs,
			@EmployeeID,
			@ProjectID,
			@QualificationID,
			@StandardRate,
			@OvertimeRate,
			@RateVisible,
			@Approver,
			@Administrator,
			@FinanceManagement,
			@TaskReport,
			@IssueReport,
			@Comments,
			@AlwaysUseRate
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION

	EXEC pjm5AssignmentGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5AssignmentCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5AssignmentDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5AssignmentDelete'
		DROP PROCEDURE [dbo].[pjm5AssignmentDelete]
	END
GO

PRINT 'Creating procedure pjm5AssignmentDelete'
GO

/******************************************************************************
**		File: pjm5AssignmentDelete.sql
**		Name: pjm5AssignmentDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:18:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		29.03.13	SOV				 ,    . -
**		05.04.13	SOV				   ,     
*******************************************************************************/
CREATE PROCEDURE pjm5AssignmentDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
		
	DECLARE 
		@ProjectID int,
		@CurrentEmployeeID int,
		@MsResourceID TIdentifier,
		@State TState,
		@IsManagerAssistant TBool
		
	SELECT @ProjectID = [ProjectID] FROM [Assignment] WHERE [ID] = @ID
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @IsManagerAssistant = dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID)

	IF dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
		@IsManagerAssistant = 0 AND	dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment')) = 0 
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE 
	@ProjectState TState,
	@IsPM TBool,
	@IsMember TBool,
	@IsAssistant TBool,
	@IsAssignmentEditor TBool

	IF dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND @IsManagerAssistant = 0
	BEGIN
		SET @IsPM = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProjectTemplates'))
		SELECT @ProjectState = [State] FROM [Project] WHERE [ID] = @ProjectID
		
		SET @IsMember = dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)
		SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
		
		SET @IsAssignmentEditor = 
				(@IsAssistant | @IsMember) 
			& 
				(dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment')) & dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')))
		IF	(
			NOT(
				(@ProjectState IN (5, 6) AND @IsPM = 1) OR
				(@ProjectState NOT IN (5, 6) AND @IsAssignmentEditor = 1)
				)
			)
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END

	IF EXISTS(SELECT * FROM [Expense] INNER JOIN [vwAssignment] ON [Expense].[EmployeeID] = [vwAssignment].[EmployeeID] 
		WHERE [vwAssignment].[ID] = @ID AND [vwAssignment].[ProjectID] = [Expense].[ProjectID])
	BEGIN
		RAISERROR('A check constraint violation occurred', 18, -1)
		RETURN 1
	END
	
	SELECT
		@MsResourceID = [Assignment].[MsResourceID],
		@State = [Assignment].[State]
	FROM [Assignment]
	WHERE [Assignment].[ID] = @ID
	
	IF (@MsResourceID IS NOT NULL AND @State != 2)
	BEGIN
		RAISERROR('#documentfrommsproject', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION

	DELETE FROM [AssignmentEntry] WHERE [AssignmentID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE [Assignment] FROM [Assignment] WHERE [Assignment].[ID] = @ID 
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE [MsResource]
	FROM
		[MsResource]
			INNER JOIN [Assignment]
			ON [Assignment].[MsResourceID] = [MsResource].[ID]
	WHERE [Assignment].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5AssignmentDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5AssignmentChangeStateInternal]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5AssignmentChangeStateInternal'
		DROP PROCEDURE [dbo].[pjm5AssignmentChangeStateInternal]
	END
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5AssignmentChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5AssignmentChangeState'
		DROP PROCEDURE [dbo].[pjm5AssignmentChangeState]
	END
GO

PRINT 'Creating procedure pjm5AssignmentChangeState'
GO

/******************************************************************************
**		File: pjm5AssignmentChangeState.sql
**		Name: pjm5AssignmentChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:18:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		26.01.10	syv				   ,  
**									   
**		20.04.10	SYV				 ,    
**		29.03.13	SOV				   , 
**									  -   , 
**									    ;
**									 ,    . -
**		02.04.13	SOV				   , 
**									  - . - , 
**									    
**		08.05.13	SOV				   " ", 
**									     ,
**									       
*******************************************************************************/
CREATE PROCEDURE pjm5AssignmentChangeState
	@ID TIdentifier,
	@ToState TState
AS

	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@ProjectID TIdentifier,
			@EmployeeID TIdentifier,
			@FinanceManagement TBool

	SET NOCOUNT ON
	
	SELECT
		@Class = [Assignment].[Class],
		@FromState = [Assignment].[State],
		@ProjectID = [Assignment].[ProjectID],
		@EmployeeID = [Assignment].[EmployeeID],
		@FinanceManagement = [Assignment].[FinanceManagement]
	FROM
		[vwAssignment] AS [Assignment]
	WHERE
		[Assignment].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END

	DECLARE 
		@CurrentEmployeeID int, 
		@ProjectState TState,
		@IsPM TBool,
		@IsMember TBool,
		@IsAssistant TBool,
		@IsAssignmentEditor TBool,
		@UserID TIdentifier,
		@ViewFinance TBool,
		@ViewAllFinance TBool

	SET @UserID = dbo.fnPjm5GetEmployeeUserID(@EmployeeID)
	SET @ViewFinance = dbo.adfHasAccessRightByNameForUser('ViewFinance', @UserID)
	SET @ViewAllFinance = dbo.adfHasAccessRightByNameForUser('ViewAllFinance', @UserID)
	
	IF (@ViewFinance=0 AND @ViewAllFinance=0 AND @FinanceManagement=1)
	BEGIN
		SET @FinanceManagement = 0
	END

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 
		AND dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID) = 0
	BEGIN
		SET @IsPM = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProjectTemplates'))
		SELECT @ProjectState = [State] FROM [Project] WHERE [ID] = @ProjectID
		
		SET @IsMember = dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)
		SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
		SET @IsAssignmentEditor = 
				(@IsAssistant | @IsMember) 
			& 
				(dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment')) & dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')))
		IF	(
			NOT(
				(@ProjectState IN (5, 6) AND @IsPM = 1) OR
				(@ProjectState NOT IN (5, 6) AND @IsAssignmentEditor = 1)
				)
			)
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @EmployeeID IS NOT NULL AND
		EXISTS (
		SELECT 
			*
		FROM
			[Employee]
		WHERE
			[ID]  = @EmployeeID AND
			[State] = 2
		) 
	BEGIN
		RAISERROR('#EmployeeFire', 18, -1)
		RETURN 1
	END
	
	IF @ToState = 1 AND @EmployeeID IS NOT NULL AND
		EXISTS (
			SELECT 
				*
			FROM
				[vwAssignment] AS [Assignment]
			WHERE
				[Assignment].[ProjectID]  = @ProjectID AND
				[Assignment].[EmployeeID]  = @EmployeeID AND
				[Assignment].[State] = @ToState AND
				[Assignment].[ID] != @ID
			) 
	BEGIN
		RAISERROR('#AssignmentAlreadyExist', 18, -1)
		RETURN 1
	END

	IF (@ToState = 2)
	BEGIN
		IF EXISTS (SELECT * 
					FROM
						[TaskAssignment]
						INNER JOIN [Task]
							ON [Task].[ID] = [TaskAssignment].[TaskID]
							AND [Task].[ProjectID] = @ProjectID
						INNER JOIN [TimeEntry]
							ON [TaskAssignment].[AssignmentID] = [TimeEntry].[AssignmentID]
							AND [TaskAssignment].[TaskID] = [TimeEntry].[TaskID]
					WHERE [TimeEntry].[State] IN (1,2,5)
						AND [TaskAssignment].[AssignmentID] = @ID)
		BEGIN
			RAISERROR('#EmployeeWithNotApprovedTime', 18, -1)
			RETURN 1	
		END
		
	END

	IF (@ToState = 1 AND dbo.fnPjm7IsManagerAssistant(@ProjectID, @EmployeeID) = 1)
	BEGIN
		UPDATE
			[Assignment]
		SET
			[Assignment].[State] = @ToState,
			[Assignment].[ModifiedBy] = dbo.adfGetCurrentUserID(),
			[Assignment].[Approver] = 1,
			[Assignment].[Administrator] = 1,
			[Assignment].[ReceiveTaskStatusReports] = 1,
			[Assignment].[ReceiveIssueStatusReports] = 1,
			[Assignment].[FinanceManagement] = 
			CASE 
				WHEN dbo.fnPjm7IsFinanceManager(@ProjectID, @EmployeeID) = 1 THEN 1
				ELSE @FinanceManagement
			END
		WHERE
			[Assignment].[ID] = @ID
		AND
			[Assignment].[State] = @FromState
	END
	ELSE
	BEGIN
		UPDATE
			[Assignment]
		SET
			[Assignment].[State] = @ToState,
			[Assignment].[Modified] = GETDATE(),
			[Assignment].[ModifiedBy] = dbo.adfGetCurrentUserID(),
			[Assignment].[FinanceManagement] = 
			CASE 
				WHEN dbo.fnPjm7IsFinanceManager(@ProjectID, @EmployeeID) = 1 THEN 1
				ELSE @FinanceManagement
			END
		WHERE
			[Assignment].[ID] = @ID
		AND
			[Assignment].[State] = @FromState
	END

	IF @@ERROR != 0
		RETURN 1
		
	IF (@ToState = 2)
	BEGIN
		IF EXISTS (SELECT * 
						FROM
							[TaskAssignment]
							INNER JOIN [Task]
								ON [Task].[ID] = [TaskAssignment].[TaskID]
								AND [Task].[ProjectID] = @ProjectID
						WHERE [TaskAssignment].[AssignmentID] = @ID)
			EXEC pjm6DeactivateTaskAssignments @ID		
			
			IF @@ERROR != 0
			RETURN 1
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm5AssignmentChangeState TO PUBLIC
GO
 