IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm5AssignedEmployeeBrowseSelectorDialog')
	BEGIN
		PRINT 'Dropping Procedure pjm5AssignedEmployeeBrowseSelectorDialog'
		DROP  Procedure  pjm5AssignedEmployeeBrowseSelectorDialog
	END

GO

PRINT 'Creating Procedure pjm5AssignedEmployeeBrowseSelectorDialog'
GO
/******************************************************************************
**		File: 
**		Name: pjm5AssignedEmployeeBrowseSelectorDialog
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure pjm5AssignedEmployeeBrowseSelectorDialog
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[Employee].[Class],
		[Employee].[ID],
		[Employee].[State],
		[Employee].[FileAs] as [Name],
		[Company].[FileAs] as [Organization],
		[Qualification].[FileAs] as [Qualification]
	FROM
		[vwAssignment] AS [Assignment] 
		INNER JOIN [Employee]
			ON ([Assignment].[EmployeeID] = [Employee].[ID] AND [Employee].[State]=1)
		INNER JOIN [Company]
			ON ([Employee].[CompanyID] = [Company].[ID])
		LEFT OUTER JOIN [Qualification]
			ON ([Assignment].[QualificationID] = [Qualification].[ID])
	WHERE
		[Assignment].[ProjectID] = @ProjectID
	AND
		[Assignment].[State] = 1

	RETURN 0

GO

GRANT EXEC ON pjm5AssignedEmployeeBrowseSelectorDialog TO PUBLIC

GO
