IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6AssignmentIntoPeriodBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6AssignmentIntoPeriodBrowse'
		DROP PROCEDURE [dbo].[pjm6AssignmentIntoPeriodBrowse]
	END
GO

PRINT 'Creating procedure pjm6AssignmentIntoPeriodBrowse'
GO

/******************************************************************************
**		File: pjm6AssignmentIntoPeriodBrowse.sql
**		Name: pjm6AssignmentIntoPeriodBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 21/10/2010
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.10.2012	SOV				    [Project].[CurrencyCode]
*******************************************************************************/

CREATE PROCEDURE [pjm6AssignmentIntoPeriodBrowse]
	@ProjectID	    TIdentifier,
	@PeriodStart	TDateTime,
	@PeriodEnd		TDateTime
	
AS
	SET NOCOUNT ON
	
	IF dbo.adfHasAccessRightByName('ManageAllTimeEntries') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT
	DISTINCT
		[Employee].[ID],
		[Employee].[FileAs],
		[Project].[ID] AS [ProjectID],
		[Project].[Number],
		[Project].[CurrencyCode],
		(SELECT TOP(1)
			[StandardRate]
		FROM
			[vwAssignment]
		WHERE
			[vwAssignment].[ProjectID] = @ProjectID
			AND
			[vwAssignment].[EmployeeID] = [Employee].[ID]
		ORDER BY [Modified] DESC) AS [StandardRate],
		(SELECT TOP(1)
			[OvertimeRate]
		FROM
			[vwAssignment]
		WHERE
			[vwAssignment].[ProjectID] = @ProjectID
			AND
			[vwAssignment].[EmployeeID] = [Employee].[ID]
		ORDER BY [Modified] DESC) AS [OvertimeRate]
	FROM
		[TimeEntry]
		INNER JOIN [Employee]
			ON [TimeEntry].[EmployeeID] = [Employee].[ID]
		INNER JOIN [Project]
			ON [TimeEntry].[ProjectID] = [Project].[ID]
	WHERE 
		[TimeEntry].[StartTime] > @PeriodStart
		AND
		[TimeEntry].[StartTime] < @PeriodEnd
		AND
		[TimeEntry].[State] IN (1, 2, 3, 5)
		AND
		[Project].[ID] = @ProjectID

	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6AssignmentIntoPeriodBrowse] TO PUBLIC
GO