IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6AssignmentsAppendtoProjects]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6AssignmentsAppendtoProjects'
		DROP PROCEDURE [dbo].[pjm6AssignmentsAppendtoProjects]
	END
GO

PRINT 'Creating procedure pjm6AssignmentsAppendtoProjects'
GO

/******************************************************************************
**		File: pjm6AssignmentsAppendtoProjects.sql
**		Name: pjm6AssignmentsAppendtoProjects
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Yuriy.Soldatkin
**		Date: 10/28/2009
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		15.04.10	SYV				 ,    
**		07.03.13	SOV				 OpenXml  Xml
**		19.03.13	SOV				   @FinanceManagement 
**									    
**		29.03.13	SOV				 ,    . -
*******************************************************************************/
CREATE PROCEDURE pjm6AssignmentsAppendtoProjects
	@Xml XML,
	@EmployeeID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @State TState,
			@ID TIdentifier,
			@FileAs TName,
			@QualificationID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@RateVisible TBool,
			@Approver TBool,
			@Administrator TBool,
			@FinanceManagement TBool,
			@TaskReport TBool,
			@IssueReport TBool,
			@Comments TNotes,
			@AlwaysUseRate TBool,
			@IsMember TBool,
			@IsAssistant TBool,
			@IsAssignmentEditor TBool,
			@MsProjectID TIdentifier,
			@IsError TBool,
			@IsLocalError TBool,
			@IsError_Access TBool,
			@IsError_MSProject TBool,
			@rv INT,
			@doc INT,			
			@assignmentClass TClass
	
	SET @assignmentClass = dbo.adfGetClassByName('Pjm5.Assignment')
	SET @IsError = 0
	SET @State = dbo.adfwfGetInitialState('7797bd53-86ce-415e-9e13-b11bcbd52359')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @CurrentEmployeeID int, 
			@ProjectState TState,
			@IsPM TBool

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SELECT
		@FileAs = [FileAs], 
		@QualificationID = [QualificationID]
	FROM
		[Employee]
	WHERE
		[Employee].[ID] = @EmployeeID
	
	IF @EmployeeID IS NOT NULL AND
		EXISTS (
		SELECT 
			*
		FROM
			[Employee]
		WHERE
			[ID]  = @EmployeeID AND
			[State] = 2
		) 
	BEGIN
		RAISERROR('#EmployeeFire', 18, -1)
		RETURN 1
	END

	DECLARE @Param TVariant
	EXEC adfParameterGet 'ShowRateInTimeEntry', 'Pjm5', @Param OUTPUT
	IF(@Param IS NULL)
	BEGIN
		SET @Param = 0 
	END

	SET @RateVisible = 0
	SET @AlwaysUseRate = 0
	SET @Comments = NULL
	SET @Approver = 0
	SET @Administrator = 0
	SET @FinanceManagement = 0
	SET @TaskReport = 0
	SET @IssueReport = 0

	DECLARE @AddProjectID TIdentifier
	DECLARE For_Add CURSOR LOCAL FAST_FORWARD FOR 
		SELECT 
			XmlTable.value('ID[1]', 'int') 
		FROM
			@Xml.nodes('/Employee/Project') AS List(XmlTable)
	OPEN For_Add
	FETCH NEXT FROM For_Add INTO @AddProjectID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @IsLocalError = 0
		
		SET @StandardRate = 0
		SET @OvertimeRate = 0
		
		IF (@QualificationID IS NOT NULL)
		BEGIN
			SELECT 
				@StandardRate = [Standard],
				@OvertimeRate = [Overtime]
			FROM
				[QualificationRate], [Project]
			WHERE
				[QualificationRate].[QualificationID] = @QualificationID
			AND
				[Project].[ID] = @AddProjectID
			AND
				[QualificationRate].[CurrencyCode] = [Project].[CurrencyCode]
		END
		ELSE
		BEGIN
			SET @StandardRate = NULL
			SET	@OvertimeRate = NULL
		END
		
		IF dbo.fnPjm5IsProjectManager(@AddProjectID, @CurrentEmployeeID) = 0 AND
			dbo.fnPjm7IsManagerAssistant(@AddProjectID, @CurrentEmployeeID) = 0
		BEGIN
			SET @IsPM = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProjectTemplates'))
			SELECT @ProjectState = [State] FROM [Project] WHERE [ID] = @AddProjectID
			
			SET @IsMember = dbo.fnPjm5IsProjectMember(@AddProjectID, @CurrentEmployeeID)
			SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
			SET @IsAssignmentEditor = (@IsAssistant | @IsMember) 
				& dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment'))
			IF (NOT (
				(@ProjectState IN (5, 6) AND @IsPM = 1) OR
				(@ProjectState NOT IN (5, 6) AND @IsAssignmentEditor = 1)
				))
			BEGIN
				SET @IsError_Access = 1
				SET @IsLocalError = 1
			END
		END
		
		IF EXISTS (SELECT * FROM [ProjectTemplate] WHERE [ID] = @AddProjectID)
		BEGIN
			SET @State = 3
		END

		IF @EmployeeID IS NOT NULL AND
			EXISTS (
			SELECT 
				*
			FROM
				[vwAssignment] AS [Assignment]
			WHERE
				[Assignment].[ProjectID]  = @AddProjectID AND
				[Assignment].[EmployeeID]  = @EmployeeID AND
				[Assignment].[State] = @State
			) 
		BEGIN
			SET @IsError = 1
			SET @IsLocalError = 1
		END

		SELECT @MsProjectID = [MsProjectID] FROM [Project] WHERE [ID] = @AddProjectID
		IF @MsProjectID IS NOT NULL
		BEGIN
			SET @IsError_MSProject = 1
			SET @IsLocalError = 1
		END

		IF(@IsLocalError = 0)
		BEGIN
			BEGIN TRANSACTION
			EXEC @rv = pjm5AssignmentCreateInternal
					@ID OUTPUT,
					0,
					@State,
					@FileAs,
					@EmployeeID,
					@AddProjectID,
					@QualificationID,
					@StandardRate,
					@OvertimeRate,
					@RateVisible,
					@Approver,
					@Administrator,
					@FinanceManagement,
					@TaskReport,
					@IssueReport,
					@Comments,
					@AlwaysUseRate
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
			END
			ELSE
			BEGIN
				COMMIT TRANSACTION
				EXEC pjm5AssignmentGet @ID	
			END
		END
		FETCH NEXT FROM For_Add INTO @AddProjectID
	END
	CLOSE For_Add
	DEALLOCATE For_Add

	IF(@IsError = 1)
	BEGIN		
		RAISERROR('#AssignmentAlreadyExist', 18, -1)
	END
	IF(@IsError_MSProject = 1)
	BEGIN		
		RAISERROR('#documentfrommsproject', 18, -1)
	END
	IF(@IsError_Access = 1)
	BEGIN		
		RAISERROR('#accessdenied', 18, -1)
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm6AssignmentsAppendtoProjects TO PUBLIC
GO