﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7BudgetLineExpenseBrowseForProjectTemplate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7BudgetLineExpenseBrowseForProjectTemplate'
		DROP PROCEDURE [dbo].[pjm7BudgetLineExpenseBrowseForProjectTemplate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseBrowse'
GO

/******************************************************************************
**		File: BudgetLineExpenseBrowseForProjectTemplate.sql
**		Name: pjm7BudgetLineExpenseBrowseForProjectTemplate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		------------------------------------------- 
*******************************************************************************/
CREATE PROCEDURE pjm7BudgetLineExpenseBrowseForProjectTemplate
	@BudgetID				TIdentifier
	
AS
	DECLARE
		@DocumentClass			TClass,
		@PlanningEmployee		TBool,
		@PlanningExpenseType	TBool,
		@VATRate				TPercent,
		@VATIsIncluded			TBool,
		@MaxOrder				TCount,
		@BudgetCurrency			TCode3,
		@value					TVariant,
		@Lang					TLanguage

	SET @Lang = dbo.adfGetLanguage()

	DECLARE @nationalCurrency TCode3
	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @value OUTPUT
	SET @nationalCurrency = CAST(@value as varchar(3))

	SET @MaxOrder = (SELECT MAX([Order]) FROM [BudgetLineGroup] WHERE [BudgetID] = @BudgetID AND
		[GroupTypeID] = 2)

	SELECT
		@VATRate = [Budget].[VATRate],
		@VATIsIncluded = [Budget].[VATIsIncluded],
		@PlanningEmployee = [Budget].[PlanningEmployeeForExpense],
		@PlanningExpenseType = [Budget].[PlanningExpenseTypeForExpense],
		@BudgetCurrency = [Budget].[CurrencyCode]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	SELECT
		[BudgetLineExpense].[ID],
		[BudgetLineExpense].[Class],
		[BudgetLineExpense].[State],
		[BudgetLineExpense].[Flag],
		[BudgetLineExpense].[FileAs],
		[BudgetLineExpense].[BudgetID],
		[BudgetLineExpense].[DocumentClass],
		[BudgetLineExpense].[DocumentID],
		CASE WHEN [BudgetLineExpense].[DocumentID] IS NOT NULL 
			THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([BudgetLineExpense].[DocumentID], [BudgetLineExpense].[DocumentClass])) ELSE
			NULL END  AS [DocumentName],
		[BudgetLineExpense].[BudgetLineGroupID],
		[BudgetLineExpense].[Order],
		dbo.fnPjm6GetSortedBudgetGroup(ISNULL([BudgetLineGroupGlobal].[FileAs], [BudgetLineGroup].[FileAs]), 
			[BudgetLineGroup].[Order], LEN(CAST(@MaxOrder AS NVARCHAR(MAX)))) AS [SortedGroupName],
		[BudgetLineExpense].[StartDate],
		[BudgetLineExpense].[EndDate],
		/*
		(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			ROUND([Price] * (CASE WHEN @BudgetCurrency != [CurrencyCode] THEN (CASE WHEN [CurrencyCode] = @nationalCurrency THEN 1 / [CurrencyRate] ELSE [CurrencyRate] END) ELSE 1 END), 2)
			ELSE
			ROUND([Price] * (1 + ISNULL(@VATRate, 0)) * (CASE WHEN @BudgetCurrency != [CurrencyCode] THEN (CASE WHEN [CurrencyCode] = @nationalCurrency THEN 1 / [CurrencyRate] ELSE [CurrencyRate] END) ELSE 1 END), 2)
		END) AS [Price],*/

		(CASE 
			WHEN @BudgetCurrency != [CurrencyCode] THEN 
			(CASE 
				WHEN [CurrencyCode] = @nationalCurrency THEN 
					[Price] / [CurrencyRate]
				ELSE 
					[Price] * [CurrencyRate] 
			END) 
			ELSE 
				[Price] 
		END) AS	[Price],
		(CASE 
			WHEN @BudgetCurrency != [CurrencyCode] THEN 
			(CASE
				WHEN [CurrencyCode] = @nationalCurrency THEN 
					[BudgetLineExpense].[PlanPurchasePrice] / [CurrencyRate] 
				ELSE 
					[BudgetLineExpense].[PlanPurchasePrice] * [CurrencyRate]
			END) 
			ELSE 
				[BudgetLineExpense].[PlanPurchasePrice] 
		END) AS	[PlanPurchasePrice],
		[BudgetLineExpense].[AssignmentID],
		[BudgetLineExpense].[ExpenseCodeID],
		[BudgetLineExpense].[CurrencyCode],
		[BudgetLineExpense].[PlannedAmount],
		[BudgetLineExpense].[PlanPurchaseAmount] AS [PurchaseAmount],
		[BudgetLineExpense].[ActualAmount],	
		[BudgetLineExpense].[TotalWithVATPCPlannedExpense] AS [TotalPlanned],
		[BudgetLineExpense].[TotalPCPlannedExpense] AS [TotalWithoutVATPlanned],
		(CASE WHEN @VATRate IS NOT NULL THEN
		[BudgetLineExpense].[TotalWithVATPCActualExpense] ELSE
		[BudgetLineExpense].[TotalPCActualExpense] END) AS [TotalActual],
		[BudgetLineExpense].[TotalPCActualExpense] AS [TotalWithoutVATActual],

		[BudgetLineExpense].[TotalPCPlanPurchase]	AS	[TotalPurchase],
		[BudgetLineExpense].[TotalWithVATPCPlanPurchase]	AS	[TotalWithVATPurchase],

		[BudgetLineExpense].[Comments],
		[BudgetLineExpense].[Created],
		[BudgetLineExpense].[CreatedBy],
		[BudgetLineExpense].[Modified],
		[BudgetLineExpense].[ModifiedBy],
		[BudgetLineExpense].[Timestamp]
	FROM
		[BudgetLineExpense]
		LEFT OUTER JOIN [BudgetLineGroup]
			ON [BudgetLineGroup].[ID] = [BudgetLineExpense].[BudgetLineGroupID]
		LEFT OUTER JOIN [BudgetLineGroupGlobal] 
			ON ([BudgetLineGroup].[ID] = [BudgetLineGroupGlobal].[ID]
				AND [BudgetLineGroupGlobal].[Language] = @Lang)
	WHERE
		[BudgetLineExpense].[BudgetID] = @BudgetID

	RETURN 0
GO

GRANT EXECUTE ON pjm7BudgetLineExpenseBrowseForProjectTemplate TO PUBLIC
GO