﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineExpenseByGroupBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineExpenseByGroupBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetLineExpenseByGroupBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseByGroupBrowse'
GO

/******************************************************************************
**		File: BudgetLineExpenseByGroupBrowse.sql
**		Name: pjm6BudgetLineExpenseByGroupBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 05/04/2011 11:40:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		------------------------------------------- 
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineExpenseByGroupBrowse
	@BudgetID				TIdentifier,
	@GroupID				TIdentifier
	
AS
	DECLARE
		@DocumentClass			TClass,
		@PlanningEmployee		TBool,
		@PlanningExpenseType	TBool,
		@VATRate				TPercent,
		@VATIsIncluded			TBool,
		@MaxOrder				TCount,
		@Lang					TLanguage

	SELECT
		@VATRate = [Budget].[VATRate],
		@VATIsIncluded = [Budget].[VATIsIncluded]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	SELECT
		[BudgetLineExpense].[ID],
		[BudgetLineExpense].[Class],
		[BudgetLineExpense].[State],
		[BudgetLineExpense].[Flag],
		[BudgetLineExpense].[FileAs],
		[BudgetLineExpense].[BudgetID],
		[BudgetLineExpense].[DocumentClass],
		[BudgetLineExpense].[DocumentID],
		CASE WHEN [BudgetLineExpense].[DocumentID] IS NOT NULL 
			THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([BudgetLineExpense].[DocumentID], [BudgetLineExpense].[DocumentClass])) ELSE
			NULL END  AS [DocumentName],
		[BudgetLineExpense].[BudgetLineGroupID],
		[BudgetLineExpense].[Order],
		[BudgetLineExpense].[StartDate],
		[BudgetLineExpense].[EndDate],
		(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN
			(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			[Price]
			ELSE
			[Price] * (1 + ISNULL(@VATRate, 0))
			END)
		ELSE
			(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			ROUND([Price] / (1 + [VATRate]), 2)
			ELSE
			[Price] 
			END)
		END) AS [Price],
		[BudgetLineExpense].[EmployeeID],
		[BudgetLineExpense].[ExpenseCodeID],
		[BudgetLineExpense].[CurrencyCode],
		[BudgetLineExpense].[PlannedAmount],
		[BudgetLineExpense].[ActualAmount],
		(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN
		[BudgetLineExpense].[TotalWithVATPCPlannedExpense] ELSE
		[BudgetLineExpense].[TotalPCPlannedExpense] END) AS [TotalPlanned],
		(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN
		[BudgetLineExpense].[TotalWithVATPCActualExpense] ELSE
		[BudgetLineExpense].[TotalPCActualExpense] END) AS [TotalActual],
		[BudgetLineExpense].[Comments],
		[BudgetLineExpense].[Created],
		[BudgetLineExpense].[CreatedBy],
		[BudgetLineExpense].[Modified],
		[BudgetLineExpense].[ModifiedBy],
		[BudgetLineExpense].[Timestamp]
	FROM
		[BudgetLineExpense]
	WHERE
		[BudgetLineExpense].[BudgetLineGroupID] = @GroupID AND
		(dbo.fnPjm6CanEditBudget(@BudgetID) = 1 OR dbo.fnPjm6CanViewBudget(@BudgetID) = 1)

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineExpenseByGroupBrowse TO PUBLIC
GO
