IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineExpenseCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineExpenseCreate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineExpenseCreate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseCreate'
GO

/******************************************************************************
**		File: pjm6BudgetLineExpenseCreate.sql
**		Name: pjm6BudgetLineExpenseCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 17/11/2010 15:20:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.02.13	MAB				   /
**		11.03.13	MAB				  OPENXML
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineExpenseCreate
	@Xml	XML
	
AS
	DECLARE
		@State							TState,
		@Class							TClass,
		@ID								TIdentifier,
		@FileAs							TName,
		@BudgetID						TIdentifier,
		@BudgetState					TState,
		@LineParrentClass				TName,
		@StartDate						TDate,
		@EndDate						TDate,
		@Order							TCount,
		@DocumentClass					TIdentifier,
		@DocumentID						TIdentifier,
		@BudgetLineGroupID				TIdentifier,
		@EmployeeID						TIdentifier,
		@ExpenseCodeID        			TIdentifier,
		@ExpenseID						TIdentifier,
		@FromCurrencyCode				TCode3,
		@ToCurrencyCode					TCode3,
		@UOMID							TIdentifier,
		@Price							TMoney,
		@PlanPurchasePrice				TMoney,		
		@PlannedAmount					TAmount,  
		@PlanPurchaseAmount				TAmount,		
		@ActualAmount					TAmount,  
		@Comments             			TNotes,  
		@VATIsIncluded        			TBool,
		@PlanPurchaseVATIsIncluded		TBool,	   
		@CurrencyRate         			TMoney,  
		@VATRate              			TPercent,
		@VATPlannedExpense    			TMoney,  
		@VATPCPlannedExpense  			TMoney,  
		@TotalPCPlannedExpense			TMoney,
		@TotalWithVATPCPlannedExpense	TMoney,
		@VATPlanPurchase				TMoney,				
		@TotalPlanPurchase				TMoney,				
		@TotalWithVATPlanPurchase		TMoney,					
		@VATPCPlanPurchase				TMoney,				
		@TotalPCPlanPurchase			TMoney,					
		@TotalWithVATPCPlanPurchase		TMoney,	
		@PlanningExpenseTypeForExpense	TBool,
		@PlanningEmployeeForExpense		TBool,
		@PlanningPriceForExpense		TBool,
		@PlanningDateForExpense			TBool,
		@value							TVariant,
		@AssignmentID					TIdentifier
	
	
	SET NOCOUNT ON

	SET @State = dbo.adfwfGetInitialState('b8fd335f-1232-4a5a-a823-92225e38f361')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET @Class = dbo.adfGetClassByName('Pjm6.BudgetLineExpense')

	SELECT												
		@FileAs =						@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/FileAs)[1]','nvarchar(256)'),				
		@BudgetID =						@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/BudgetID)[1]','int'),		
		@StartDate =					CAST(@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/StartDate)[1]','varchar(19)') as datetime),  			
		@EndDate =						CAST(@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/EndDate)[1]','varchar(19)') as datetime),			 				
		@DocumentClass =				dbo.adfGetClassByName(@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/DocumentClass)[1]','varchar(32)')),		
		@DocumentID =					@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/DocumentID)[1]','int'),
		@LineParrentClass =				@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/BudgetClass)[1]','int'),			
		@BudgetLineGroupID =			@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/BudgetLineGroupID)[1]','int'),	
		@EmployeeID =					@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/EmployeeID)[1]','int'), 				
		@ExpenseCodeID =				@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/ExpenseCodeID)[1]','int'),     		
		@ExpenseID =					@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/ExpenseID)[1]','int'),		
		@FromCurrencyCode =				@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/FromCurrencyCode)[1]','char(3)'),
		@ToCurrencyCode =				[Budget].[CurrencyCode],				
		@UOMID =						@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/UOMID)[1]','int'),
		@Price =						@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/Price)[1]','decimal(18,4)'),	
		@PlanPurchasePrice = 			@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/PlanPurchasePrice)[1]','money'),
		@PlannedAmount =				@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/PlannedAmount)[1]','decimal(18,4)'),
		@PlanPurchaseAmount = 			@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/PlanPurchaseAmount)[1]','decimal(18,4)'),   		          		
		@VATIsIncluded =				@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/VATIsIncluded)[1]','bit'), 
		@PlanPurchaseVATIsIncluded =	@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/PlanPurchaseVATIsIncluded)[1]','bit'), 
		@CurrencyRate =					@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/CurrencyRate)[1]','decimal(18,4)'),       		
		@VATRate =						@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/VATRate)[1]','decimal(18,4)'),                		
		@VATPlannedExpense =			@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/VATPlannedExpense)[1]','decimal(18,4)'),     		
		@VATPCPlannedExpense =			@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/VATPCPlannedExpense)[1]','decimal(18,4)'), 
		@TotalPCPlannedExpense =		@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/TotalPCPlannedExpense)[1]','decimal(18,4)'), 
		@TotalWithVATPCPlannedExpense =	@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/TotalWithVATPCPlannedExpense)[1]','decimal(18,4)'), 
		@VATPlanPurchase =				@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/VATPlanPurchase)[1]','money'), 
		@TotalPlanPurchase =			@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/TotalPlanPurchase)[1]','money'), 
		@TotalWithVATPlanPurchase =		@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/TotalWithVATPlanPurchase)[1]','money'), 
		@VATPCPlanPurchase =			@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/VATPCPlanPurchase)[1]','money'), 
		@TotalPCPlanPurchase =			@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/TotalPCPlanPurchase)[1]','money'), 
		@TotalWithVATPCPlanPurchase =	@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/TotalWithVATPCPlanPurchase)[1]','money'), 
		@Comments =						@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/Comments)[1]','nvarchar(max)'),
		@AssignmentID =					@Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/AssignmentID)[1]','int')
						
	FROM
		[Budget]
	WHERE [Budget].[ID] = @Xml.value('(/pjm6BudgetLineExpenseGet/BudgetLineExpense/BudgetID)[1]','int')	
	
	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT		
		@PlanningExpenseTypeForExpense	= [Budget].[PlanningExpenseTypeForExpense],
		@PlanningEmployeeForExpense		= [Budget].[PlanningEmployeeForExpense],
		@PlanningPriceForExpense		= [Budget].[PlanningPriceForExpense],
		@PlanningDateForExpense			= [Budget].[PlanningDateForExpense],
		@BudgetState					= [Budget].[State]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	IF (@BudgetState <> 1 AND @BudgetState <> 6) AND @LineParrentClass = dbo.adfGetClassByName('Pjm6.Budget')
	BEGIN
		RAISERROR('#budgetIsOpenOrClosed', 18, -1)
		RETURN 1
	END

	IF ((@PlanningExpenseTypeForExpense = 1 AND @ExpenseCodeID IS NULL) OR 
		(@PlanningEmployeeForExpense = 1 AND ((@BudgetState != 6 AND @EmployeeID IS NULL) OR (@BudgetState = 6 AND @AssignmentID IS NULL))) OR
		((@BudgetState != 4 AND @BudgetState != 5) AND @PlanningDateForExpense = 1 AND (@StartDate IS NULL OR @EndDate IS NULL)))
	BEGIN
		RAISERROR('#budgetplanningparameterisnull', 18, -1)
		RETURN 1
	END

	IF @CurrencyRate = 0 OR @CurrencyRate IS NULL
	BEGIN
		RAISERROR('#CurrencyRateCannotBeNull', 18, -1)
		RETURN 1
	END

	IF EXISTS(SELECT TOP 1 * FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[State] = 1 AND
						[BudgetLineExpense].[BudgetID] = @BudgetID AND [BudgetLineExpense].[DocumentClass] = @DocumentClass AND
						[BudgetLineExpense].[DocumentID] = @DocumentID) OR
		EXISTS(SELECT * FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[State] = 1 AND
						[BudgetLineExpense].[BudgetID] = @BudgetID AND [BudgetLineExpense].[ExpenseID] = @ExpenseID)
	BEGIN
		RAISERROR('#BudgetLineAssociatedWithThisDocument', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION

	IF @DocumentID IS NULL
		SET @DocumentClass = NULL

	INSERT INTO [BudgetLineExpense]
		([Class], [State], [FileAs], [BudgetID], [DocumentClass], [DocumentID],
		[BudgetLineGroupID], [StartDate], [EndDate], 
		[Order], 
		[Price], [PlanPurchasePrice],
		[EmployeeID], [AssignmentID],
		[ExpenseCodeID], [ExpenseID], [CurrencyCode],
		[UOMID], [PlannedAmount], [PlanPurchaseAmount], [VATIsIncluded], [PlanPurchaseVATIsIncluded], [CurrencyRate],
		[VATRate], [VATPlannedExpense], [TotalPCPlannedExpense], [TotalWithVATPCPlannedExpense],
		[VATPlanPurchase], [TotalPlanPurchase], [TotalWithVATPlanPurchase],
		[VATPCPlanPurchase], [TotalPCPlanPurchase], [TotalWithVATPCPlanPurchase],
		[Comments]
		)
	VALUES
		(@Class, @State, @FileAs, @BudgetID, @DocumentClass, @DocumentID,
		@BudgetLineGroupID, @StartDate, @EndDate, 
		dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'ExpenseLine', 'Planned', NULL, @BudgetLineGroupID),  
		@Price, @PlanPurchasePrice,
		(CASE 
			WHEN @BudgetState = 6 OR @PlanningEmployeeForExpense != 1 THEN
				NULL
			ELSE 
				@EmployeeID
		END),
		(CASE 
			WHEN @BudgetState = 6 OR @PlanningEmployeeForExpense != 1 THEN
				@AssignmentID
			ELSE 
				NULL
		END),
		@ExpenseCodeID, @ExpenseID, @FromCurrencyCode,
		@UOMID, @PlannedAmount, @PlanPurchaseAmount, @VATIsIncluded, @PlanPurchaseVATIsIncluded, @CurrencyRate,
		@VATRate, @VATPlannedExpense, @TotalPCPlannedExpense, @TotalWithVATPCPlannedExpense,
		@VATPlanPurchase, @TotalPlanPurchase, @TotalWithVATPlanPurchase,
		@VATPCPlanPurchase, @TotalPCPlanPurchase, @TotalWithVATPCPlanPurchase,
		@Comments
		)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	COMMIT TRANSACTION

	EXEC pjm6BudgetLineExpenseGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineExpenseCreate TO PUBLIC
GO