﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineExpenseEntryBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineExpenseEntryBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetLineExpenseEntryBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseEntryBrowse'
GO

/******************************************************************************
**		File: BudgetLineExpenseEntryBrowse.sql
**		Name: pjm6BudgetLineExpenseEntryBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetLineExpenseEntryBrowse]
	@BudgetLineID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@CurrentUserID TIdentifier,
		@RestrictedView TBool,
		@ExpenseSecretary TBool
		
	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[EmployeeID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		[Expense].[VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentClassName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT dbo.adfGetDocumentClassNameByTable('Task'))
		END AS [DocumentClassName],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT [Task].[FileAs] FROM [Task] WHERE [Task].[ID] = [Expense].[TaskID])
		END AS [DocumentName]
	FROM
		[BudgetLineExpenseEntries]
		INNER JOIN [pjm5vwExpense] AS [Expense]
			ON [BudgetLineExpenseEntries].[EntryID] = [Expense].[ID]
	WHERE
		[BudgetLineExpenseEntries].[BudgetLineID] = @BudgetLineID
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetLineExpenseEntryBrowse] TO PUBLIC
GO