﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineExpenseGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineExpenseGet'
		DROP PROCEDURE [dbo].[pjm6BudgetLineExpenseGet]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseGet'
GO

/******************************************************************************
**		File: pjm6BudgetLineExpenseGet.sql
**		Name: pjm6BudgetLineExpenseGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 17/11/2010 15:20:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**		25.04.11	SYV			Добавлено поле BudgetState
**		21.02.13	MAB			Добавление полей раздела Закупа/план
**		08.08.14	SAP			Исправление выборки поля DocumentClass
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineExpenseGet
	@ID	TIdentifier
	
AS
	SET NOCOUNT ON

	DECLARE
		@BudgetClass	TClass,
		@TemplateClass  TClass,
		@Class			TClass,
		@BudgetID		TIdentifier


	SET @TemplateClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	SET @BudgetClass = dbo.adfGetClassByName('Pjm6.Budget')
	SET @BudgetID = (SELECT [BudgetID] FROM [BudgetLineExpense] WHERE [ID] = @ID)
	SET @Class = (SELECT [Class] FROM [Document] WHERE [ID] = @BudgetID AND [Class] = @TemplateClass)

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1 AND dbo.fnPjm6CanViewBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT
		[BudgetLineExpense].[ID],                   
		[BudgetLineExpense].[Class],                 
		[BudgetLineExpense].[State],                 
		[BudgetLineExpense].[Flag],                  
		[BudgetLineExpense].[FileAs],                
		[BudgetLineExpense].[BudgetID],
		[Budget].[DocumentID] AS [ProjectID],              
		(SELECT TOP(1) [Code] FROM [Class] WHERE [Class] =  [BudgetLineExpense].[DocumentClass]) AS [DocumentClass],         
		[BudgetLineExpense].[DocumentID],
		CASE WHEN @Class IS NOT NULL THEN @TemplateClass ELSE @BudgetClass END AS [BudgetClass],
		[Budget].[CurrencyCode] AS [ToCurrencyCode],           
		[BudgetLineExpense].[BudgetLineGroupID],      
		[BudgetLineExpense].[StartDate],             
		[BudgetLineExpense].[EndDate],                            
		[Budget].[PlanningExpenseTypeForExpense],
		[Budget].[PlanningEmployeeForExpense],
		[Budget].[PlanningDateForExpense],
		[BudgetLineExpense].[Price],
		[BudgetLineExpense].[PlanPurchasePrice],
		[BudgetLineExpense].[EmployeeID],            
		[BudgetLineExpense].[ExpenseCodeID],        
		[BudgetLineExpense].[ExpenseID],
		[BudgetLineExpense].[UOMID],   
		[BudgetLineExpense].[CurrencyRate],
		[BudgetLineExpense].[CurrencyCode] AS [FromCurrencyCode],     
		[BudgetLineExpense].[PlannedAmount], 
		[BudgetLineExpense].[PlanPurchaseAmount],        
		[BudgetLineExpense].[ActualAmount],                       
		[BudgetLineExpense].[VATIsIncluded],
		[BudgetLineExpense].[PlanPurchaseVATIsIncluded],
		[BudgetLineExpense].[VATRate],
		[BudgetLineExpense].[VATPlannedExpense],
		[BudgetLineExpense].[VATPCPlannedExpense],
		[BudgetLineExpense].[TotalPCPlannedExpense],
		[BudgetLineExpense].[TotalWithVATPCPlannedExpense],
		[BudgetLineExpense].[VATPlanPurchase],		
		[BudgetLineExpense].[TotalPlanPurchase],		
		[BudgetLineExpense].[TotalWithVATPlanPurchase], 
		[BudgetLineExpense].[VATPCPlanPurchase], 			
		[BudgetLineExpense].[TotalPCPlanPurchase],
		[BudgetLineExpense].[TotalWithVATPCPlanPurchase], 
		[BudgetLineExpense].[VATActualExpense],
		[BudgetLineExpense].[TotalActualExpense],
		[BudgetLineExpense].[TotalWithVATActualExpense],
		[BudgetLineExpense].[VATActualExpense],
		[BudgetLineExpense].[VATPCActualExpense],
		[BudgetLineExpense].[TotalPCActualExpense],
		[BudgetLineExpense].[TotalWithVATPCActualExpense],
		[BudgetLineExpense].[Created] AS [Date],
		[BudgetLineExpense].[Comments],
		[BudgetLineExpense].[Created],               
		[BudgetLineExpense].[CreatedBy],             
		[BudgetLineExpense].[Modified],              
		[BudgetLineExpense].[ModifiedBy],
		[BudgetLineExpense].[Timestamp],
		[Budget].[State] AS [BudgetState],
		[Budget].[PlanPurchases],
		[BudgetLineExpense].[AssignmentID]
	FROM
		[BudgetLineExpense]
	INNER JOIN [Budget]
		ON [Budget].[ID] = [BudgetLineExpense].[BudgetID]
	WHERE
		[BudgetLineExpense].[ID] = @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineExpenseGet TO PUBLIC
GO