IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineGroupBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineGroupBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetLineGroupBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineGroupBrowse'
GO

/******************************************************************************
**		File: pjm6BudgetLineGroupBrowse.sql
**		Name: pjm6BudgetLineGroupBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 10/10/2010 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineGroupBrowse
	@BudgetID	TIdentifier,
	@GroupType TIdentifier
	
AS
	DECLARE
		@Lang			TLanguage

	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[BudgetLineGroup].[ID],
		[BudgetLineGroup].[Class],
		[BudgetLineGroup].[State],
		[BudgetLineGroup].[Flag],
		ISNULL([BudgetLineGroupGlobal].[FileAs], [BudgetLineGroup].[FileAs]) AS [FileAs],
		[BudgetLineGroup].[BudgetID],
		[BudgetLineGroup].[StartDate],
		[BudgetLineGroup].[EndDate],
		[BudgetLineGroup].[Order],
		[BudgetLineGroup].[GroupTypeID],
		[BudgetLineGroup].[Created],
		[BudgetLineGroup].[CreatedBy],
		[BudgetLineGroup].[Modified],
		[BudgetLineGroup].[ModifiedBy],
		[BudgetLineGroup].[Timestamp]
	FROM
		[BudgetLineGroup]
	LEFT OUTER JOIN [BudgetLineGroupGlobal] 
			ON ([BudgetLineGroup].[ID] = [BudgetLineGroupGlobal].[ID]
				AND [BudgetLineGroupGlobal].[Language] = @Lang)
	WHERE
		[BudgetLineGroup].[BudgetID] = @BudgetID AND
		[BudgetLineGroup].[GroupTypeID] = @GroupType AND
		(dbo.fnPjm6CanEditBudget(@BudgetID) = 1 OR dbo.fnPjm6CanViewBudget(@BudgetID) = 1)

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineGroupBrowse TO PUBLIC
GO