IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineGroupCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineGroupCreate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineGroupCreate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineGroupCreate'
GO

/******************************************************************************
**		File: pjm6BudgetLineGroupCreate.sql
**		Name: pjm6BudgetLineGroupCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 10/10/2010 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
** 
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineGroupCreate
	@Xml	XML
	
AS
	DECLARE
		@State				TState,
		@Class				TClass,
		@ID					TIdentifier,
		@FileAs				TName,
		@BudgetID			TIdentifier,
		@StartDate			TDate,
		@EndDate			TDate,
		@Order				TCount,
		@Comments			TNotes,
		@GroupType			TIdentifier,
		@LineParrentClass	TName,
		@BudgetState		TState

	SET NOCOUNT ON

	SET @State = dbo.adfwfGetInitialState('6ddad7aa-2950-47d3-90c9-8f3bda678a19')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @Class = dbo.adfGetClassByName('Pjm6.BudgetLineGroup')

	SELECT
		@FileAs				= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/FileAs)[1]','nvarchar(256)'),		
		@BudgetID			= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/BudgetID)[1]','int'),	
		@StartDate			= CAST(@Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/StartDate)[1]','varchar(19)') as datetime),
		@EndDate			= CAST(@Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/EndDate)[1]','varchar(19)') as datetime),
		@GroupType			= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/GroupTypeID)[1]','int'),	
		@Comments			= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/Comments)[1]','nvarchar(max)'),	
		@LineParrentClass	= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/BudgetClass)[1]','int'),	
		@BudgetState		= [Budget].[State]
	FROM
		[Budget]
	WHERE 
		[Budget].[ID]= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/BudgetID)[1]','int')

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF (@BudgetState <> 1 AND @BudgetState <> 6) AND @LineParrentClass = dbo.adfGetClassByName('Pjm6.Budget')
	BEGIN
		RAISERROR('#budgetIsOpenOrClosed', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION

	INSERT INTO [BudgetLineGroup]
		([Class], [State], [BudgetID], [FileAs], [StartDate],
		[EndDate], [Order], [GroupTypeID], [Comments])
	VALUES 
		(@Class, @State, @BudgetID, @FileAs, @StartDate,
		@EndDate, 
		dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'Group', NULL, @GroupType, NULL),
		@GroupType, @Comments)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()


	COMMIT TRANSACTION

	EXEC pjm6BudgetLineGroupGet @ID

	RETURN 0

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineGroupCreate TO PUBLIC
GO