IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetSystemGroupsInsert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetSystemGroupsInsert'
		DROP PROCEDURE [dbo].[pjm6BudgetSystemGroupsInsert]
	END
GO

PRINT 'Creating procedure pjm6BudgetSystemGroupsInsert'
GO

/******************************************************************************
**		File: pjm6BudgetSystemGroupsInsert.sql
**		Name: pjm6BudgetSystemGroupsInsert
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 24/09/2010 14:20:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetSystemGroupsInsert]
@BudgetID	TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @NewGroupID TIdentifier

	BEGIN TRANSACTION
	
	INSERT INTO [BudgetLineGroup]
		([Class], [State], [BudgetID], [FileAs], [StartDate], [EndDate],
		[Order], [GroupTypeID], [Comments])
	VALUES
		(dbo.adfGetClassByName('Pjm6.BudgetLineGroup'), 2, @BudgetID, ' ', NULL, NULL,
		1, 1, NULL)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @NewGroupID = SCOPE_IDENTITY()

	INSERT INTO [BudgetLineGroupGlobal] ([ID], [Language], [FileAs])
	VALUES 
		(@NewGroupID,'en', 'Unplanned works')

	INSERT INTO [BudgetLineGroup]
		([Class], [State], [BudgetID], [FileAs], [StartDate], [EndDate],
		[Order], [GroupTypeID], [Comments])
	VALUES
		(dbo.adfGetClassByName('Pjm6.BudgetLineGroup'), 2, @BudgetID, ' ', NULL, NULL,
		1, 2, NULL)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @NewGroupID = SCOPE_IDENTITY()

	INSERT INTO [BudgetLineGroupGlobal] ([ID], [Language], [FileAs])
	VALUES 
		(@NewGroupID,'en', 'Unplanned expenses')
	
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetSystemGroupsInsert TO PUBLIC
GO
