IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineWorkCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineWorkCreate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineWorkCreate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineWorkCreate'
GO

/******************************************************************************
**		File: pjm6BudgetLineWorkCreate.sql
**		Name: pjm6BudgetLineWorkCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 01/11/2010 14:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.02.13	MAB				  " "  ""
**		28.02.13	MAB				  OPENXML
**		08.07.13	MAB				    
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineWorkCreate
	@Xml	XML
	
AS
	DECLARE
		@State							TState,
		@Class							TClass,
		@ID								TIdentifier,
		@FileAs							TName,
		@BudgetID						TIdentifier,
		@BudgetState					TState,
		@LineParrentClass				TName,
		@StartDate						TDate,
		@EndDate						TDate,
		@Order							TCount,
		@DocumentClass					TIdentifier,
		@DocumentID						TIdentifier,
		@BudgetLineGroupID				TIdentifier,
		@Rate							TMoney,
		@EmployeeID						TIdentifier,
		@VATIsIncluded					TBool,
		@ActivityTypeID					TIdentifier,
		@QualificationID				TIdentifier,
		@Own							TBool,
		@PlannedManHour					TAmount,
		@VATPCPlannedManHour			TMoney,
		@TotalPCPlannedManHour			TMoney,
		@TotalWithVATPCPlannedManHour	TMoney,
		@ExpenseID						TIdentifier,
		@Comments						TNotes,
		@PlanningActivityForWork		TBool,
		@PlanningEmployeeForWork		TBool,
		@PlanningQualificationForWork	TBool,
		@PlanningRateForWork			TBool,
		@PlanningDateForWork			TBool,
		@AssignmentID					TIdentifier

	SET NOCOUNT ON

	SET @State = dbo.adfwfGetInitialState('af97690a-3eb9-41a4-bb20-bd145b566a85')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @Class = dbo.adfGetClassByName('Pjm6.BudgetLineWork')

	SELECT												
		@FileAs							= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/FileAs)[1]','nvarchar(256)'),			
		@BudgetID						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/BudgetID)[1]','int'),		
		@StartDate						= CAST(@XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/StartDate)[1]','varchar(19)') as datetime), 			
		@EndDate						= CAST(@XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/EndDate)[1]','varchar(19)') as datetime),				 				
		@DocumentClass					= dbo.adfGetClassByName(@XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/DocumentClass)[1]','varchar(32)')),		
		@DocumentID						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/DocumentID)[1]','int'),	
		@LineParrentClass				= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/BudgetClass)[1]','int'),		
		@BudgetLineGroupID				= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/BudgetLineGroupID)[1]','int'),	
		@Rate							= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/Rate)[1]','decimal(18,4)'),				
		@EmployeeID						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/EmployeeID)[1]','int'),			
		@ActivityTypeID					= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/ActivityTypeID)[1]','int'),	
		@QualificationID				= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/QualificationID)[1]','int'),
		@Own							= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/Own)[1]','bit'),
		@PlannedManHour					= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/PlannedManHour)[1]','decimal(18,4)'),
		@VATPCPlannedManHour			= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/VATPCPlannedManHour)[1]','decimal(18,4)'),		
		@TotalPCPlannedManHour			= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/TotalPCPlannedManHour)[1]','decimal(18,4)'),		
		@TotalWithVATPCPlannedManHour	= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/TotalWithVATPCPlannedManHour)[1]','decimal(18,4)'),	 
		@ExpenseID						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/ExpenseID)[1]','int'),		
		@Comments						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/Comments)[1]','nvarchar(max)')	,
		@AssignmentID					= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/AssignmentID)[1]','int')

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END		

	SELECT		
		@PlanningActivityForWork		= [Budget].[PlanningActivityForWork],
		@PlanningEmployeeForWork		= [Budget].[PlanningEmployeeForWork],
		@PlanningQualificationForWork	= [Budget].[PlanningQualificationForWork],
		@PlanningRateForWork			= [Budget].[PlanningRateForWork],
		@PlanningDateForWork			= [Budget].[PlanningDateForWork],
		@VATIsIncluded					= [Budget].[VATIsIncluded],
		@BudgetState					= [Budget].[State]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	IF (@BudgetState <> 1 AND @BudgetState <> 6) AND @LineParrentClass = dbo.adfGetClassByName('Pjm6.Budget')
	BEGIN
		RAISERROR('#budgetIsOpenOrClosed', 18, -1)
		RETURN 1
	END

	IF ((@PlanningActivityForWork = 1 AND @ActivityTypeID IS NULL) OR 
		(@PlanningEmployeeForWork = 1 AND ((@BudgetState != 6 AND @EmployeeID IS NULL) OR (@BudgetState = 6 AND @AssignmentID IS NULL))) OR
		(@PlanningQualificationForWork = 1 AND @QualificationID IS NULL) OR
		((@BudgetState != 4 AND @BudgetState != 5) AND @PlanningDateForWork = 1 AND (@StartDate IS NULL OR @EndDate IS NULL)))
	BEGIN
		RAISERROR('#budgetplanningparameterisnull', 18, -1)
		RETURN 1
	END

	IF EXISTS(SELECT TOP 1 *FROM [BudgetLineWork] WHERE [BudgetLineWork].[State] = 1 AND
					[BudgetLineWork].[BudgetID] = @BudgetID AND [BudgetLineWork].[DocumentClass] = @DocumentClass AND
					[BudgetLineWork].[DocumentID] = @DocumentID)
	BEGIN
		RAISERROR('#BudgetLineAssociatedWithThisDocument', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION

	IF @DocumentID IS NULL
		SET @DocumentClass = NULL


	--IF @VATIsIncluded = 1
	--BEGIN
	--	SET @TotalPCPlannedManHour = @PlannedManHour * @Rate - @VATPCPlannedManHour
	--	SET @TotalWithVATPCPlannedManHour = @PlannedManHour * @Rate
	--END
	--ELSE
	--BEGIN
	--	SET @TotalPCPlannedManHour = @PlannedManHour * @Rate
	--	SET @TotalWithVATPCPlannedManHour = @PlannedManHour * @Rate + @VATPCPlannedManHour
	--END

	INSERT INTO [BudgetLineWork]
		([Class], [State], [FileAs], [BudgetID], [DocumentClass], [DocumentID],
		[BudgetLineGroupID], [StartDate], [EndDate],
		[Order], 
		[Rate],
		[EmployeeID], [AssignmentID],
		[ActivityTypeID], [QualificationID],
		[Own],
		[PlannedManHour], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour],
		[ExpenseID],
		[Comments])
	VALUES
		(@Class, @State, @FileAs, @BudgetID, @DocumentClass, @DocumentID,
		@BudgetLineGroupID, @StartDate, @EndDate, 
		dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'WorkLine', 'Planned', NULL, @BudgetLineGroupID), 
		@Rate,
		(CASE 
			WHEN @BudgetState = 6 OR @PlanningEmployeeForWork != 1 THEN
				NULL
			ELSE 
				@EmployeeID
		END),
		(CASE 
			WHEN @BudgetState = 6 OR @PlanningEmployeeForWork != 1 THEN
				@AssignmentID
			ELSE 
				NULL
		END),
		@ActivityTypeID, @QualificationID,
		~@Own, 
		@PlannedManHour, @TotalPCPlannedManHour, @TotalWithVATPCPlannedManHour,
		(CASE
			WHEN @Own = 0 THEN
				NULL
			ELSE
				@ExpenseID
		END),
		@Comments
		)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	UPDATE 
		[TaskRequest]
	SET
		[ManHour] = @PlannedManHour,
		[Budget] = @Rate * @PlannedManHour
	WHERE
		[TaskRequest].[ID] = @DocumentID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm6BudgetLineWorkGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineWorkCreate TO PUBLIC
GO