IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CreditMemoBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CreditMemoBrowse'
		DROP PROCEDURE [dbo].[pjm5CreditMemoBrowse]
	END
GO

PRINT 'Creating procedure pjm5CreditMemoBrowse'
GO

/******************************************************************************
**		File: pjm5CreditMemoBrowse.sql
**		Name: pjm5CreditMemoBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CreditMemoBrowse]
	@StateSelector INT,
	@ProjectID TIdentifier,
	@CompanyID TIdentifier,
	@DateSelector int,
	@PeriodStart TDateTime,
	@PeriodEnd TDateTime
AS
	SET NOCOUNT ON
	DECLARE
		@BaseCurrencyCode TCode3,
		@value TVariant

	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))
	
	IF @DateSelector != 0
		EXEC BillingFilterPeriodGet @DateSelector, @PeriodStart OUTPUT, @PeriodEnd OUTPUT

	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SELECT
		[CreditMemo].[Class],
		[CreditMemo].[ID],
		[CreditMemo].[State],
		[CreditMemo].[Flag],
		[CreditMemo].[FileAs],
		[CreditMemo].[Date],
		[CreditMemo].[Number],
		[CreditMemo].[VAT],
		[CreditMemo].[PaymentTypeID],
		[CreditMemo].[PayeeCompanyID],
		[CreditMemo].[PayeeBankAccountID],
		[CreditMemo].[PayerCompanyID],
		[CreditMemo].[ProjectID],
		[CreditMemo].[Value],
		[CreditMemo].[Value]-[CreditMemo].[VAT] AS [TotalBC],
		[CreditMemo].[CurrencyCode],
		[CreditMemo].[TotalWithVATBC] AS [BaseTotal],
		@BaseCurrencyCode AS [BaseCurrencyCode],
		[CreditMemo].[Comments],
		[CreditMemo].[Created],
		[CreditMemo].[CreatedBy],
		[CreditMemo].[Modified],
		[CreditMemo].[ModifiedBy],
		[CreditMemo].[Timestamp]
	FROM
		[CreditMemo]
	WHERE
		(
			(@StateSelector = 0) OR
			(@StateSelector = 4 AND [CreditMemo].[State] != 3) OR
			(@StateSelector != 0 AND [CreditMemo].[State] = @StateSelector)
		) AND
		(
			(@DateSelector = 0) OR 
			([CreditMemo].[Date] >= @PeriodStart AND [CreditMemo].[Date] < DATEADD(day, 1, @PeriodEnd))
		) AND
		(
			@ProjectID IS NULL OR [CreditMemo].[ProjectID] = @ProjectID
		) AND
		(
			@CompanyID IS NULL OR [CreditMemo].[PayeeCompanyID] = @CompanyID OR
			[CreditMemo].[PayerCompanyID] = @CompanyID
		) AND
		dbo.fnPjm5HasFinansDataAccess([CreditMemo].[ProjectID], @EmployeeID, [CreditMemo].[Class], NULL) = 1

		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CreditMemoBrowse] TO PUBLIC
GO
 