IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[pjm6fnNationalCurrencyGetRate]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[pjm6fnNationalCurrencyGetRate]
GO

CREATE FUNCTION pjm6fnNationalCurrencyGetRate(
	@CurrencyCode TCode3,
	@Date TDate
)

RETURNS money

AS
BEGIN

	DECLARE	@Rate TMoney
	SET @Date = CAST(CONVERT(varchar(8), @Date, 112) AS datetime)
	
	IF(@CurrencyCode != dbo.fnPjm5GetNationalCurrency())
		SET @Rate = (SELECT 
			 TOP 1 [CurrencyRate].[Rate]
		FROM
			[CurrencyRate]
		WHERE
			[CurrencyRate].[FromCurrencyCode] = @CurrencyCode
			AND (@Date BETWEEN [ValidFrom] AND [ValidTo]
			OR @Date NOT BETWEEN [ValidFrom] AND [ValidTo]
			 AND @Date > [ValidTo])
		ORDER BY [ValidFrom] DESC)
	ELSE
		SELECT @Rate = 1

RETURN (@Rate)
END
GO
