IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardDraftBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardDraftBrowse'
		DROP PROCEDURE [dbo].[pjm5DocumentCardDraftBrowse]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardDraftBrowse'
GO

/******************************************************************************
**		File: pjm5DocumentCardDraftBrowse.sql
**		Name: pjm5DocumentCardDraftBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    07.09.09		syv				  AnswerTo  
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardDraftBrowse]
	@CompanyID TIdentifier,
	@CorrespondentSelector int,
	@CorrespondentID TIdentifier,
	@ClassifierSelector int,
	@ClassifierID TIdentifier,
	@DateSelector int,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE @Date TDate, @q int
	SET @Date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS DATETIME)
	SET	@q = CASE CAST(MONTH(@Date) % 3 as int)
			WHEN 1 THEN 0
			WHEN 2 THEN 1
			ELSE 2
		END
	IF @DateSelector = 2 
		SELECT
			@PeriodStart = DATEADD(day, 1 - DATEPART(day, @Date), @Date),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 1, @Date))
	IF @DateSelector = 3
		SELECT
			@PeriodStart = DATEADD(month, 0 - @q, DATEADD(day, 1 - DATEPART(day, @Date), @Date)),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 3, @PeriodStart))
	IF @DateSelector = 4
		SELECT
			@PeriodStart = DATEADD(month, 0 - @q - 3, DATEADD(day, 1 - DATEPART(day, @Date), @Date)),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 3, @PeriodStart))

	SELECT
		[DocumentCard].[Class],
		[DocumentCard].[ID],
		[DocumentCard].[State],
		[DocumentCard].[Flag],
		[DocumentCard].[FileAs] ,
		[DocumentCard].[FolderID],
		[DocumentCard].[Number],
		[DocumentCard].[Date],
		[DocumentCard].[CompanyID],
		[DocumentCard].[ContactID],
		[DocumentCard].[CorrespondentCompanyID],
		[DocumentCard].[CorrespondentContactID],
		[DocumentCard].[CaseID],
		[DocumentCard].[DocumentSendTypeID],

		[DocumentCard].[DocumentCardClassID],
		[DocumentCard].[DivisionID],
		[DocumentCard].[CustodyPlaceID],
		[DocumentCard].[AppendixCount],
		[DocumentCard].[PageCount],
		[DocumentCard].[Package],
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[Copy],
		[DocumentCard].[StorePeriod],

		[DocumentItem].[ID]		AS [DocumentItemID],
		[DocumentItem].[State]	AS [DocumentItemState],
		[DocumentItem].[Flag]	AS [DocumentItemFlag],
		[DocumentItem].[FileName],
		[DocumentItem].[Extension],
		[DocumentItem].[LatestVersion],
		[DocumentItem].[CheckedOutBy],
		[DocumentVersion].[DataLength],
		[Folder].[FileAs] AS [FolderFileAs],
		[DocumentCard].[Comments],
		[DocumentCard].[Created],
		[DocumentCard].[CreatedBy],
		[DocumentCard].[Modified],
		[DocumentCard].[ModifiedBy],
		[DocumentCard].[Timestamp],
		CAST('6cc877ce-4425-4e49-a3d5-76b01ae709ae' as uniqueidentifier) AS [Guid]
	FROM
		[DocumentCard]
		INNER JOIN [Folder]
			ON [DocumentCard].[FolderID] = [Folder].[ID]
		INNER JOIN [Case]
			ON [Case].[ID] = [DocumentCard].[CaseID]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
		LEFT OUTER JOIN [DocumentVersion]
			ON [DocumentVersion].[DocumentItemID] = [DocumentItem].[ID] AND
				[DocumentVersion].[Version] = [DocumentItem].[LatestVersion]
	WHERE
		[DocumentCard].[State] = 1 AND
		[Case].[AllowInternal] = 1 AND
		(@CompanyID IS NULL OR [DocumentCard].[CompanyID] = @CompanyID) AND
		(
			@CorrespondentSelector = 0 OR
			@CorrespondentID IS NULL AND [DocumentCard].[CorrespondentCompanyID] IS NULL OR 
			[DocumentCard].[CorrespondentCompanyID] = @CorrespondentID
		) AND
		(
			@ClassifierSelector = 0 OR 
			@ClassifierID IS NULL AND [DocumentCard].[DocumentCardClassID] IS NULL OR 
			[DocumentCard].[DocumentCardClassID] = @ClassifierID
		) AND
		(
			@DateSelector = 0 OR
			@DateSelector = 1 AND [DocumentCard].[Date] IS NULL OR
			@DateSelector > 1 AND [DocumentCard].[Date] BETWEEN @PeriodStart AND @PeriodEnd
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentCardDraftBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IncomingDocumentDraftBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IncomingDocumentDraftBrowse'
		DROP PROCEDURE [dbo].[pjm5IncomingDocumentDraftBrowse]
	END
GO

PRINT 'Creating procedure pjm5IncomingDocumentDraftBrowse'
GO

/******************************************************************************
**		File: pjm5IncomingDocumentDraftBrowse.sql
**		Name: pjm5IncomingDocumentDraftBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    07.09.09		syv				  AnswerTo  
*******************************************************************************/
CREATE PROCEDURE [pjm5IncomingDocumentDraftBrowse]
	@CompanyID TIdentifier,
	@CorrespondentSelector int,
	@CorrespondentID TIdentifier,
	@ClassifierSelector int,
	@ClassifierID TIdentifier,
	@DateSelector int,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE @Date TDate, @q int
	SET @Date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS DATETIME)
	SET	@q = CASE CAST(MONTH(@Date) % 3 as int)
			WHEN 1 THEN 0
			WHEN 2 THEN 1
			ELSE 2
		END
	IF @DateSelector = 2 
		SELECT
			@PeriodStart = DATEADD(day, 1 - DATEPART(day, @Date), @Date),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 1, @Date))
	IF @DateSelector = 3
		SELECT
			@PeriodStart = DATEADD(month, 0 - @q, DATEADD(day, 1 - DATEPART(day, @Date), @Date)),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 3, @PeriodStart))
	IF @DateSelector = 4
		SELECT
			@PeriodStart = DATEADD(month, 0 - @q - 3, DATEADD(day, 1 - DATEPART(day, @Date), @Date)),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 3, @PeriodStart))

	SELECT
		[DocumentCard].[Class],
		[DocumentCard].[ID],
		[DocumentCard].[State],
		[DocumentCard].[Flag],
		[DocumentCard].[FileAs] ,
		[DocumentCard].[FolderID],
		[DocumentCard].[Number],
		[DocumentCard].[Date],
		[DocumentCard].[NumberOut],
		[DocumentCard].[DateOut],
		[DocumentCard].[CompanyID],
		[DocumentCard].[ContactID],
		[DocumentCard].[CorrespondentCompanyID],
		[DocumentCard].[CorrespondentContactID],
		[DocumentCard].[CaseID],
		[DocumentCard].[DocumentSendTypeID],

		[DocumentCard].[DocumentCardClassID],
		[DocumentCard].[DivisionID],
		[DocumentCard].[CustodyPlaceID],
		[DocumentCard].[AppendixCount],
		[DocumentCard].[PageCount],
		[DocumentCard].[Package],
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[Copy],
		[DocumentCard].[StorePeriod],

		[DocumentItem].[ID]		AS [DocumentItemID],
		[DocumentItem].[State]	AS [DocumentItemState],
		[DocumentItem].[Flag]	AS [DocumentItemFlag],
		[DocumentItem].[FileName],
		[DocumentItem].[Extension],
		[DocumentItem].[LatestVersion],
		[DocumentItem].[CheckedOutBy],
		[DocumentVersion].[DataLength],
		[Folder].[FileAs] AS [FolderFileAs],
		[DocumentCard].[Comments],
		[DocumentCard].[Created],
		[DocumentCard].[CreatedBy],
		[DocumentCard].[Modified],
		[DocumentCard].[ModifiedBy],
		[DocumentCard].[Timestamp],
		CAST('6cc877ce-4425-4e49-a3d5-76b01ae709ae' as uniqueidentifier) AS [Guid]
	FROM
		[DocumentCard]
		INNER JOIN [Folder]
			ON [DocumentCard].[FolderID] = [Folder].[ID]
		INNER JOIN [Case]
			ON [Case].[ID] = [DocumentCard].[CaseID]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
		LEFT OUTER JOIN [DocumentVersion]
			ON [DocumentVersion].[DocumentItemID] = [DocumentItem].[ID] AND
				[DocumentVersion].[Version] = [DocumentItem].[LatestVersion]
	WHERE
		[DocumentCard].[State] = 1 AND
		[Case].[AllowIncoming] = 1 AND
		(@CompanyID IS NULL OR [DocumentCard].[CompanyID] = @CompanyID) AND
		(
			@CorrespondentSelector = 0 OR
			@CorrespondentID IS NULL AND [DocumentCard].[CorrespondentCompanyID] IS NULL OR 
			[DocumentCard].[CorrespondentCompanyID] = @CorrespondentID
		) AND
		(
			@ClassifierSelector = 0 OR 
			@ClassifierID IS NULL AND [DocumentCard].[DocumentCardClassID] IS NULL OR 
			[DocumentCard].[DocumentCardClassID] = @ClassifierID
		) AND
		(
			@DateSelector = 0 OR
			@DateSelector = 1 AND [DocumentCard].[Date] IS NULL OR
			@DateSelector > 1 AND [DocumentCard].[Date] BETWEEN @PeriodStart AND @PeriodEnd
		)

	RETURN 0
GO

GRANT EXECUTE ON [pjm5IncomingDocumentDraftBrowse] TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5OutgoingDocumentDraftBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5OutgoingDocumentDraftBrowse'
		DROP PROCEDURE [dbo].[pjm5OutgoingDocumentDraftBrowse]
	END
GO

PRINT 'Creating procedure pjm5OutgoingDocumentDraftBrowse'
GO

/******************************************************************************
**		File: pjm5OutgoingDocumentDraftBrowse.sql
**		Name: pjm5OutgoingDocumentDraftBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    07.09.09		syv				  AnswerTo  
*******************************************************************************/
CREATE PROCEDURE [pjm5OutgoingDocumentDraftBrowse]
	@CompanyID TIdentifier,
	@CorrespondentSelector int,
	@CorrespondentID TIdentifier,
	@ClassifierSelector int,
	@ClassifierID TIdentifier,
	@DateSelector int,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE @Date TDate, @q int
	SET @Date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS DATETIME)
	SET	@q = CASE CAST(MONTH(@Date) % 3 as int)
			WHEN 1 THEN 0
			WHEN 2 THEN 1
			ELSE 2
		END
	IF @DateSelector = 2 
		SELECT
			@PeriodStart = DATEADD(day, 1 - DATEPART(day, @Date), @Date),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 1, @Date))
	IF @DateSelector = 3
		SELECT
			@PeriodStart = DATEADD(month, 0 - @q, DATEADD(day, 1 - DATEPART(day, @Date), @Date)),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 3, @PeriodStart))
	IF @DateSelector = 4
		SELECT
			@PeriodStart = DATEADD(month, 0 - @q - 3, DATEADD(day, 1 - DATEPART(day, @Date), @Date)),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 3, @PeriodStart))

	SELECT
		[DocumentCard].[Class],
		[DocumentCard].[ID],
		[DocumentCard].[State],
		[DocumentCard].[Flag],
		[DocumentCard].[FileAs] ,
		[DocumentCard].[FolderID],
		[DocumentCard].[Number],
		[DocumentCard].[Date],
		[DocumentCard].[NumberOut],
		[DocumentCard].[DateOut],
		[DocumentCard].[CompanyID],
		[DocumentCard].[ContactID],
		[DocumentCard].[CorrespondentCompanyID],
		[DocumentCard].[CorrespondentContactID],
		[DocumentCard].[CaseID],
		[DocumentCard].[DocumentSendTypeID],

		[DocumentCard].[DocumentCardClassID],
		[DocumentCard].[DivisionID],
		[DocumentCard].[CustodyPlaceID],
		[DocumentCard].[AppendixCount],
		[DocumentCard].[PageCount],
		[DocumentCard].[Package],
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[Copy],
		[DocumentCard].[StorePeriod],

		[DocumentItem].[ID]		AS [DocumentItemID],
		[DocumentItem].[State]	AS [DocumentItemState],
		[DocumentItem].[Flag]	AS [DocumentItemFlag],
		[DocumentItem].[FileName],
		[DocumentItem].[Extension],
		[DocumentItem].[LatestVersion],
		[DocumentItem].[CheckedOutBy],
		[DocumentVersion].[DataLength],
		[Folder].[FileAs] AS [FolderFileAs],
		[DocumentCard].[Comments],
		[DocumentCard].[Created],
		[DocumentCard].[CreatedBy],
		[DocumentCard].[Modified],
		[DocumentCard].[ModifiedBy],
		[DocumentCard].[Timestamp],
		CAST('6cc877ce-4425-4e49-a3d5-76b01ae709ae' as uniqueidentifier) AS [Guid]
	FROM
		[DocumentCard]
		INNER JOIN [Folder]
			ON [DocumentCard].[FolderID] = [Folder].[ID]
		INNER JOIN [Case]
			ON [Case].[ID] = [DocumentCard].[CaseID]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
		LEFT OUTER JOIN [DocumentVersion]
			ON [DocumentVersion].[DocumentItemID] = [DocumentItem].[ID] AND
				[DocumentVersion].[Version] = [DocumentItem].[LatestVersion]
	WHERE
		[DocumentCard].[State] = 1 AND
		[Case].[AllowOutgoing] = 1 AND
		(@CompanyID IS NULL OR [DocumentCard].[CompanyID] = @CompanyID) AND
		(
			@CorrespondentSelector = 0 OR
			@CorrespondentID IS NULL AND [DocumentCard].[CorrespondentCompanyID] IS NULL OR 
			[DocumentCard].[CorrespondentCompanyID] = @CorrespondentID
		) AND
		(
			@ClassifierSelector = 0 OR 
			@ClassifierID IS NULL AND [DocumentCard].[DocumentCardClassID] IS NULL OR 
			[DocumentCard].[DocumentCardClassID] = @ClassifierID
		) AND
		(
			@DateSelector = 0 OR
			@DateSelector = 1 AND [DocumentCard].[Date] IS NULL OR
			@DateSelector > 1 AND [DocumentCard].[Date] BETWEEN @PeriodStart AND @PeriodEnd
		)
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5OutgoingDocumentDraftBrowse] TO PUBLIC
GO
