IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardSendToApproveNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5DocumentCardSendToApproveNotification'
	DROP PROCEDURE [dbo].[pjm5DocumentCardSendToApproveNotification]
END
GO

PRINT 'Creating procedure pjm5DocumentCardSendToApproveNotification'
GO

/******************************************************************************
**		File: pjm5DocumentCardSendToApproveNotification.sql
**		Name: pjm5DocumentCardSendToApproveNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		02.10.13	SOV				  '&'   -
**									     XML
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardSendToApproveNotification]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	SELECT @FileAs = REPLACE([DocumentCard].[FileAs], '&', '&amp;') FROM [DocumentCard] WHERE [DocumentCard].[ID] = @ID
		
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'Document card ''' + [DocumentCard].[FileAs] + ''' has been sent to approving.'
			ELSE '  ''' + [DocumentCard].[FileAs] + '''   .'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[DocumentCard].[Class],
		[DocumentCard].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'Document card ''' + @FileAs + ''' has been sent to approving.'
			ELSE '  ''' + @FileAs+ '''   .'
		END,
		NULL
	FROM
		[DocumentCard]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCard].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[CardSettings] & 0x0001) = 0x0001
	WHERE
		[DocumentCard].[ID] = @ID AND
		dbo.fnFolderHasRightAccess([Folder].[ID], [FolderNotificationSettings].[TrusteeID], 'READITEMS') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5DocumentCardSendToApproveNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardApprovedNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5DocumentCardApprovedNotification'
	DROP PROCEDURE [dbo].[pjm5DocumentCardApprovedNotification]
END
GO

PRINT 'Creating procedure pjm5DocumentCardApprovedNotification'
GO

/******************************************************************************
**		File: pjm5DocumentCardApprovedNotification.sql
**		Name: pjm5DocumentCardApprovedNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		02.10.13	SOV				  '&'   -
**									     XML
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardApprovedNotification]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	SELECT @FileAs = REPLACE([DocumentCard].[FileAs], '&', '&amp;') FROM [DocumentCard] WHERE [DocumentCard].[ID] = @ID

	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'Document card ''' + [DocumentCard].[FileAs] + ''' has been approved.'
			ELSE '  ''' + [DocumentCard].[FileAs] + ''' .'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[DocumentCard].[Class],
		[DocumentCard].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'Document card ''' + @FileAs + ''' has been approved.'
			ELSE '  ''' + @FileAs + ''' .'
		END,
		NULL
	FROM
		[DocumentCard]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCard].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[CardSettings] & 0x0010) = 0x0010
	WHERE
		[DocumentCard].[ID] = @ID AND
		dbo.fnFolderHasRightAccess([Folder].[ID], [FolderNotificationSettings].[TrusteeID], 'READITEMS') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5DocumentCardApprovedNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardRecommitedNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5DocumentCardRecommitedNotification'
	DROP PROCEDURE [dbo].[pjm5DocumentCardRecommitedNotification]
END
GO

PRINT 'Creating procedure pjm5DocumentCardRecommitedNotification'
GO

/******************************************************************************
**		File: pjm5DocumentCardRecommitedNotification.sql
**		Name: pjm5DocumentCardRecommitedNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		02.10.13	SOV				  '&'   -
**									     XML
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardRecommitedNotification]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@FileAs TName
			
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	SELECT @FileAs = REPLACE([DocumentCard].[FileAs], '&', '&amp;') FROM [DocumentCard] WHERE [DocumentCard].[ID] = @ID

	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'Document card ''' + [DocumentCard].[FileAs] + ''' has been recommited.'
			ELSE '  ''' + [DocumentCard].[FileAs] + '''   .'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[DocumentCard].[Class],
		[DocumentCard].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'Document card ''' + @FileAs + ''' has been recommited.'
			ELSE '  ''' + @FileAs + '''   .'
		END,
		NULL
	FROM
		[DocumentCard]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCard].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[CardSettings] & 0x0100) = 0x0100
	WHERE
		[DocumentCard].[ID] = @ID AND
		dbo.fnFolderHasRightAccess([Folder].[ID], [FolderNotificationSettings].[TrusteeID], 'READITEMS') = 1

	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5DocumentCardRecommitedNotification] TO [public]
GO
