 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemCheckEditAccess]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemCheckEditAccess'
		DROP PROCEDURE [dbo].[pjm5DocumentItemCheckEditAccess]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemCheckEditAccess'
GO

/******************************************************************************
**		File: pjm5DocumentItemCheckEditAccess.sql
**		Name: pjm5DocumentItemCheckEditAccess
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentItemCheckEditAccess]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @CurrentEmployeeID TIdentifier
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	IF NOT EXISTS (
		SELECT * 
			FROM 
				[DocumentItem]
				INNER JOIN [TaskRequest]
					ON [TaskRequest].[DocumentCardID] = [DocumentItem].[DocumentCardID]
				INNER JOIN [TaskRequestAssignment]
					ON [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND
						[TaskRequestAssignment].[EmployeeID]=@CurrentEmployeeID
			WHERE 
				[DocumentItem].[ID] = @ID AND
				[TaskRequest].[DocumentEditAccess] = 1 AND
				[TaskRequest].[State] = 2
	)
	BEGIN
		DECLARE @UserID TIdentifier, @CreatedBy TIdentifier
		SET @UserID = dbo.adfGetCurrentUserID()
		
		DECLARE @FolderID TIdentifier
		SELECT 
			@FolderID = [DocumentCard].[FolderID],
			@CreatedBy = [DocumentItem].[CreatedBy]
		FROM
			[DocumentItem]
			INNER JOIN [DocumentCard]
				ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		WHERE
			[DocumentItem].[ID] = @ID
		IF @FolderID = 0
			RETURN 0
			
		IF @FolderID = -1
			RETURN 0

		IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'EditAll') = 1
			RETURN 0

		IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'EditOwn') = 1
		BEGIN
			IF @UserID = @CreatedBy
				RETURN 0
		END

		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemCheckEditAccess TO PUBLIC
GO
