 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemCreate'
		DROP PROCEDURE [dbo].[pjm5DocumentItemCreate]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemCreate'
GO

/******************************************************************************
**		File: pjm5DocumentItemCreate.sql
**		Name: pjm5DocumentItemCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		20.02.13	SAP				  OPENXML   
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentItemCreate]
	@Xml XML
AS
	SET NOCOUNT ON
	DECLARE
		@ID TIdentifier,
		@State TState,
		@CardID TIdentifier,
		@CardClass TClass,
		@CardState TState,
		@CaseID TIdentifier,
		@UserID TIdentifier,
		@rv int
	
	SET @CardState = dbo.adfwfGetInitialState('6cc877ce-4425-4e49-a3d5-76b01ae709ae')
	IF @CardState IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	DECLARE
		@FolderID TIdentifier,
		@FileAs TName,
		@FileName TName,
		@Extension TName,
		@PublicationControl TBool,
		@FolderPublication TBool,
		@CompanyID TIdentifier
	
	
	SELECT
		@FolderID = T.c.value('FolderID[1]','int'),
		@FileAs = CASE 
			WHEN [DocumentCard].[CaseID] IS NULL 
				THEN ISNULL(T.c.value('FileAs[1]','nvarchar(512)'), T.c.value('FileName[1]','nvarchar(512)'))
				ELSE [DocumentCard].[FileAs]
			END,
		@FileName = T.c.value('FileName[1]','nvarchar(512)'),
		@Extension = T.c.value('Extension[1]','nvarchar(512)'),
		@CardID = T.c.value('DocumentCardID[1]','int'),
		@PublicationControl = [Folder].[PublicationControl],
		@CompanyID = [Folder].[CompanyID],
		@CaseID = [DocumentCard].[CaseID]
	FROM
		@Xml.nodes('/pjm5DocumentItemGet/DocumentItem') AS T(c)		
		INNER JOIN [Folder]
			ON [Folder].[ID] = T.c.value('FolderID[1]','int')
		LEFT OUTER JOIN [DocumentCard]
			ON [DocumentCard].[ID] = T.c.value('DocumentCardID[1]','int')
	
	
	IF @FolderID = 0
	BEGIN
		SET @State = 4
	END
	ELSE
	BEGIN
		SET @State = dbo.adfwfGetInitialState('acb865ab-ae3c-429e-af10-d14d6a46363b')
		IF @State != 1
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END

	IF NOT EXISTS(SELECT * FROM [Folder] WHERE [ID] = @FolderID)
	BEGIN
		RAISERROR('#folderisdeleted', 18, -1)
		RETURN 1
	END
	
	SET @UserID = dbo.adfGetCurrentUserID()
	IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'FolderOwner') = 0 AND
		dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'CreateItems') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @FolderPublication = 1
	IF @PublicationControl = 1 AND @CaseID IS NULL
		SET @FolderPublication = dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'FolderPublication')

	BEGIN TRANSACTION
	IF @CardID IS NULL
	BEGIN
		INSERT INTO [DocumentCard]
			([State], [Flag], [FileAs], [FolderID], [CompanyID])
		VALUES
			(@CardState, 0, @FileAs, @FolderID, @CompanyID)
		
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @CardID = SCOPE_IDENTITY()
		
		IF @CardState = 5 -- NOT VISIBLE
		BEGIN
			UPDATE 
				[DocumentCard]
			SET
				[State] = 1
			WHERE
				[ID] = @CardID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		UPDATE 
			[DocumentCard]
		SET
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @CardID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	INSERT INTO [DocumentItem]
		([State], [Flag], [FileAs], [FileName], [Extension], [FolderID], [DocumentCardID])
	VALUES
		(@State, 0, @FileAs, @FileName, @Extension, @FolderID, @CardID)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [DocumentVersion] ([DocumentItemID], [Version], [Extension]) VALUES (@ID, 1, @Extension)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF @FolderPublication = 1 AND @State != 4
	BEGIN
		EXEC @rv = pjm5DocumentItemChangeStateInternal @ID, 2
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	EXEC pjm5DocumentItemCreateNotification @ID

	COMMIT TRANSACTION
	
	EXEC pjm5DocumentItemGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemCreate TO PUBLIC
GO
