IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ExchangeSyncStateUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ExchangeSyncStateUpdate'
		DROP PROCEDURE [dbo].[pjm7ExchangeSyncStateUpdate]
	END
GO

PRINT 'Creating procedure pjm7ExchangeSyncStateUpdate'
GO

/******************************************************************************
**		File: ExchangeSyncStateUpdate.sql
**		Name: pjm7ExchangeSyncStateUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 26.12.2011 17:15:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		09.08.13	SAP				  /       
*******************************************************************************/
CREATE PROCEDURE pjm7ExchangeSyncStateUpdate
	@DocumentID		TIdentifier,
	@DocumentClass	TClass,
	@State			TBool,
	@EmployeeID		TIdentifier = NULL
AS
	SET NOCOUNT ON;
	
	DECLARE	
		@CurrentUserID	TIdentifier,
		@MeetingRequestClass int = [dbo].[adfGetClassByName]('Pjm5.MeetingRequest'),
		@OriginatorUserID int,
		@OriginatorSyncMarkExists bit,
		@EmployeesSyncMarkExists bit,
		@AllowAdd bit = 1,
		@AllowDelete bit = 0
		
		
	IF @EmployeeID IS NULL	
		SET @CurrentUserID = dbo.adfGetCurrentUserID()
	ELSE
		SET @CurrentUserID = (SELECT [UserID] FROM [Employee] WHERE [ID] = @EmployeeID)


	IF(@DocumentClass = @MeetingRequestClass AND @State = 1)
	BEGIN
		SELECT
			@OriginatorUserID = [Employee].[UserID]
		FROM
			[MeetingRequest]
			INNER JOIN [Employee]
				ON [Employee].[ID] = [MeetingRequest].[OriginatorEmployeeID]				
		WHERE
			[MeetingRequest].[ID] = @DocumentID

		IF EXISTS(SELECT * FROM [ExchangeDocumentSync] WHERE [DocumentClass] = @MeetingRequestClass AND [DocumentID] = @DocumentID AND [UserID] = @OriginatorUserID)
			SET @OriginatorSyncMarkExists = 1		
		ELSE
			SET @OriginatorSyncMarkExists = 0

		IF EXISTS(SELECT * FROM [ExchangeDocumentSync] WHERE [DocumentClass] = @MeetingRequestClass AND [DocumentID] = @DocumentID AND [UserID] <> @OriginatorUserID)
			SET @EmployeesSyncMarkExists = 1		
		ELSE
			SET @EmployeesSyncMarkExists = 0


		--     -  ...
		IF(@CurrentUserID <> @OriginatorUserID)
		BEGIN
			--...   ,     
			IF (@OriginatorSyncMarkExists = 0)
			BEGIN
				SET @AllowAdd = 1
			END
			ELSE
			BEGIN
				SET @AllowAdd = 0
			END
		END
		--     - ...
		ELSE
		BEGIN
			--...     
			SET @AllowAdd = 1

			IF(@EmployeesSyncMarkExists = 0)
			BEGIN
				SET @AllowDelete = 0
			END
			--...    ,   
			ELSE
			BEGIN
				SET @AllowDelete = 1
			END
		END
	END
	
	IF @State = 1 
		AND NOT EXISTS(SELECT * FROM [ExchangeDocumentSync] WHERE [DocumentClass] = @DocumentClass AND	[DocumentID] = @DocumentID AND [UserID] = @CurrentUserID) 
		AND @AllowAdd = 1
	BEGIN
		INSERT INTO [ExchangeDocumentSync] 
			([DocumentClass], [DocumentID], [UserID]) 
		VALUES 
			(@DocumentClass, @DocumentID, @CurrentUserID)
	END
	ELSE IF @State = 0 
			AND EXISTS(SELECT * FROM [ExchangeDocumentSync] WHERE [DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID AND [UserID] = @CurrentUserID)					
	BEGIN
		DELETE FROM [ExchangeDocumentSync] WHERE [DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID AND [UserID] = @CurrentUserID
	END

	IF (@AllowDelete = 1)
	BEGIN
		DELETE FROM [ExchangeDocumentSync]
		WHERE 
			[DocumentClass] = @DocumentClass 
			AND 
			[DocumentID] = @DocumentID
			AND
			[UserID] <> @OriginatorUserID
	END

	if @@ERROR != 0
	BEGIN
		RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm7ExchangeSyncStateUpdate TO PUBLIC
GO