IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseBrowse'
		DROP PROCEDURE [dbo].[pjm5ExpenseBrowse]
	END
GO

PRINT 'Creating procedure pjm5ExpenseBrowse'
GO

/******************************************************************************
**		File: pjm5ExpenseBrowse.sql
**		Name: pjm5ExpenseBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.10.12	SAP				  " "
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseBrowse]
	@EmployeeID TIdentifier,
	@ProjectSelector INT,
	@ActiveProjectID TIdentifier,
	@NotActiveProjectID TIdentifier,
	@StateSelector INT,
	@DateSelector	INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime
AS
	SET NOCOUNT ON
	SET DATEFIRST 1
	DECLARE 
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@RestrictedView TBool,
		@ExpenseSecretary TBool
		
	SET @ExpenseSecretary = dbo.adfHasAccessRightByName('ManageExpenseWithoutAssignment')
	SET @RestrictedView = dbo.adfHasAccessRight(dbo.adfGetRightID('RestrictedView'))
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)

	IF @DateSelector = 1 -- last seven days
		SELECT
			@PeriodEnd = DATEADD(day, 1, @date),
			@PeriodStart = DATEADD(day, -6, @date)

	IF @DateSelector = 2 -- current month
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @date, 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(day, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(month, 1, @PeriodStart)

	IF @DateSelector = 3 -- last month
		SELECT
			@PeriodEnd = DATEADD(day, 1 - DATEPART(day, @date), @date),
			@PeriodStart = DATEADD(month, -1, @PeriodEnd)
			
	IF @DateSelector = 4 -- arbitrary period
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodEnd)
			
			
	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[EmployeeID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		[Expense].[VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency],
		[Project].[CustomerCompanyID],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentClassName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT dbo.adfGetDocumentClassNameByTable('Task'))
		END AS [DocumentClassName],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT [Task].[FileAs] FROM [Task] WHERE [Task].[ID] = [Expense].[TaskID])
		END AS [DocumentName],
		[CostCenter].[FileAs] AS [CostCenterName]
	FROM
		[pjm5vwExpense] AS [Expense]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
		LEFT JOIN [CostCenter]
			ON [CostCenter].[ID] = [Project].[CostCenterID]
	WHERE
		( 
			dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR 
			dbo.fnPjm5AllowCreateProjectEntry([Project].[ID], [Expense].[EmployeeID]) = 1 OR
			(dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1 AND @RestrictedView = 0) OR
			@ExpenseSecretary = 1
		) AND
		(@EmployeeID IS NULL OR [Expense].[EmployeeID] = @EmployeeID) AND 
		(
			(@ProjectSelector = 0) OR
			(
				@ProjectSelector = 1 AND 
				(
					(@ActiveProjectID IS NULL AND [Project].[State] = 2) OR
					(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID)
				)
			) OR
			(
				@ProjectSelector = 2 AND 
				(
					(@NotActiveProjectID IS NULL AND [Project].[State] != 2) OR
					(@NotActiveProjectID IS NOT NULL AND [Project].[ID] = @NotActiveProjectID)
				)
			)
		) AND
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [Expense].[State] IN (1, 5)) OR		-- / 
			(@StateSelector = 2 AND [Expense].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [Expense].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [Expense].[State] = 6) OR			--   
			(@StateSelector = 5 AND [Expense].[State] = 4)				-- 
		) AND
		(
			@DateSelector = 0 OR
			[Expense].[Date] >= @PeriodStart AND 
			[Expense].[Date] < @PeriodEnd
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseBrowseByProject]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseBrowseByProject'
		DROP PROCEDURE [dbo].[pjm5ExpenseBrowseByProject]
	END
GO

PRINT 'Creating procedure pjm5ExpenseBrowseByProject'
GO

/******************************************************************************
**		File: pjm5ExpenseBrowseByProject.sql
**		Name: pjm5ExpenseBrowseByProject
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.05.13	SOV				   . -
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseBrowseByProject]
	@ProjectID TIdentifier,
	@EmployeeID TIdentifier,
	@StateSelector INT,
	@DateSelector	INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime
AS
	SET NOCOUNT ON
	DECLARE 
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@CurrentUserID TIdentifier,
		@RestrictedView TBool,
		@ExpenseSecretary TBool,
		@HasFinanceAccess TBool
		
	SET @ExpenseSecretary = dbo.adfHasAccessRightByName('ManageExpenseWithoutAssignment')
		
	SET @RestrictedView = dbo.adfHasAccessRight(dbo.adfGetRightID('RestrictedView'))	
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @CurrentUserID = dbo.adfGetCurrentUserID()

	SELECT
		@CurrentEmployeeID = dbo.adfGetCurrentEmployeeID(),
		@date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)		
	
	SET @HasFinanceAccess = dbo.fnPjm5HasFinansDataAccess(@ProjectID, @CurrentEmployeeID, NULL, NULL)

	IF @DateSelector = 1 -- last seven days
		SELECT
			@PeriodEnd = DATEADD(day, 1, @date),
			@PeriodStart = DATEADD(day, -6, @date)

	IF @DateSelector = 2 -- current month
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @date, 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(day, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(month, 1, @PeriodStart)

	IF @DateSelector = 3 -- last month
		SELECT
			@PeriodEnd = DATEADD(day, 1 - DATEPART(day, @date), @date),
			@PeriodStart = DATEADD(month, -1, @PeriodEnd)
			
	IF @DateSelector = 4 -- arbitrary period
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodEnd)


	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[EmployeeID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		CASE
			WHEN (@ViewAllFinance = 0 AND [Expense].[EmployeeID] != @CurrentEmployeeID AND [Expense].[CreatedBy]!= @CurrentUserID AND
				dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
				dbo.fnPjm5IsProjectEnhancementMember(@ProjectID, @CurrentEmployeeID) = 0 ) AND
				@ExpenseSecretary = 0 AND @HasFinanceAccess = 0 THEN -1
			ELSE [Expense].[Price]
		END AS [Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		CASE
			WHEN (@ViewAllFinance = 0 AND [Expense].[EmployeeID] != @CurrentEmployeeID AND [Expense].[CreatedBy]!= @CurrentUserID AND
				dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
				dbo.fnPjm5IsProjectEnhancementMember(@ProjectID, @CurrentEmployeeID) = 0 ) AND
				@ExpenseSecretary = 0 AND @HasFinanceAccess = 0 THEN -1
			ELSE [Expense].[VAT]
		END AS [VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentClassName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT dbo.adfGetDocumentClassNameByTable('Task'))
		END AS [DocumentClassName],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT [Task].[FileAs] FROM [Task] WHERE [Task].[ID] = [Expense].[TaskID])
		END AS [DocumentName]
	FROM
		[pjm5vwExpense] AS [Expense]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
	WHERE
		[Project].[ID] = @ProjectID AND
		( 
			@HasFinanceAccess = 1 OR 
			dbo.fnPjm5AllowCreateProjectEntry([Project].[ID], [Expense].[EmployeeID]) = 1 OR
			(dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1 AND @RestrictedView = 0) OR
			@ExpenseSecretary = 1
		) AND
		(
			@EmployeeID IS NULL OR
			[Expense].[EmployeeID] = @EmployeeID
		) AND 
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [Expense].[State] IN (1, 5)) OR	-- / 
			(@StateSelector = 2 AND [Expense].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [Expense].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [Expense].[State] = 6) OR			--   
			(@StateSelector = 5 AND [Expense].[State] = 4)			-- 
		) AND
		(
			@DateSelector = 0 OR
			[Expense].[Date] >= @PeriodStart AND 
			[Expense].[Date] < @PeriodEnd
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseBrowseByProject] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseBrowseOwn]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseBrowseOwn'
		DROP PROCEDURE [dbo].[pjm5ExpenseBrowseOwn]
	END
GO

PRINT 'Creating procedure pjm5ExpenseBrowseOwn'
GO

/******************************************************************************
**		File: pjm5ExpenseBrowseOwn.sql
**		Name: pjm5ExpenseBrowseOwn
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseBrowseOwn]
	@ProjectSelector INT,
	@ActiveProjectID TIdentifier,
	@NotActiveProjectID TIdentifier,
	@StateSelector INT,
	@DateSelector INT,
	@PeriodStart datetime,
	@PeriodEnd datetime
AS
	SET NOCOUNT ON
	SET DATEFIRST 1
	DECLARE 
		@date datetime,
		@EmployeeID TIdentifier
		
	SELECT 
		@EmployeeID = dbo.adfGetCurrentEmployeeID(),
		@date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)

	IF @DateSelector = 1 -- last seven days
		SELECT
			@PeriodEnd = DATEADD(day, 1, @date),
			@PeriodStart = DATEADD(day, -6, @date)

	IF @DateSelector = 2 -- current month
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @date, 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(day, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(month, 1, @PeriodStart)

	IF @DateSelector = 3 -- last month
		SELECT
			@PeriodEnd = DATEADD(day, 1 - DATEPART(day, @date), @date),
			@PeriodStart = DATEADD(month, -1, @PeriodEnd)
			
	IF @DateSelector = 4 -- arbitrary period
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodEnd)
			
	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[TaskID],
		[Expense].[EmployeeID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		[Expense].[VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentClassName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT dbo.adfGetDocumentClassNameByTable('Task'))
		END AS [DocumentClassName],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT [Task].[FileAs] FROM [Task] WHERE [Task].[ID] = [Expense].[TaskID])
		END AS [DocumentName]
	FROM
		[pjm5vwExpense] AS [Expense]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
	WHERE
		[Expense].[EmployeeID] = @EmployeeID AND 
		(
			(@ProjectSelector = 0) OR
			(
				@ProjectSelector = 1 AND 
				(
					(@ActiveProjectID IS NULL AND [Project].[State] = 2) OR
					(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID)
				)
			) OR
			(
				@ProjectSelector = 2 AND 
				(
					(@NotActiveProjectID IS NULL AND [Project].[State] != 2) OR
					(@NotActiveProjectID IS NOT NULL AND [Project].[ID] = @NotActiveProjectID)
				)
			)
		) AND
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [Expense].[State] IN (1, 5)) OR		-- / 
			(@StateSelector = 2 AND [Expense].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [Expense].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [Expense].[State] = 6) OR			--   
			(@StateSelector = 5 AND [Expense].[State] = 4)				-- 
		) AND
		(
			@DateSelector = 0 OR
			[Expense].[Date] >= @PeriodStart AND 
			[Expense].[Date] < @PeriodEnd
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseBrowseOwn] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseBrowseByCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseBrowseByCategory'
		DROP PROCEDURE [dbo].[pjm5ExpenseBrowseByCategory]
	END
GO

PRINT 'Creating procedure pjm5ExpenseBrowseByCategory'
GO

/******************************************************************************
**		File: pjm5ExpenseBrowseByCategory.sql
**		Name: pjm5ExpenseBrowseByCategory
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.10.12	SAP				  " "
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseBrowseByCategory]
	@EmployeeID TIdentifier,
	@ProjectSelector INT,
	@ActiveProjectID TIdentifier,
	@NotActiveProjectID TIdentifier,
	@StateSelector INT,
	@DateSelector	INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime
AS
	SET NOCOUNT ON
	SET DATEFIRST 1
	DECLARE 
		@date datetime,
		@CurrentEmployeeID TIdentifier,
		@ViewAllFinance TBool,
		@none nvarchar(6),
		@RestrictedView TBool,
		@ExpenseSecretary TBool
		
	SET @ExpenseSecretary = dbo.adfHasAccessRightByName('ManageExpenseWithoutAssignment')
	SET @RestrictedView = dbo.adfHasAccessRight(dbo.adfGetRightID('RestrictedView'))
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	IF dbo.adfGetLanguage() = 'ru'
		SET @none = '()'
	ELSE
		SET @none = '(none)'

	SELECT 
		@CurrentEmployeeID = dbo.adfGetCurrentEmployeeID(),
		@date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)

	IF @DateSelector = 1 -- last seven days
		SELECT
			@PeriodEnd = DATEADD(day, 1, @date),
			@PeriodStart = DATEADD(day, -6, @date)

	IF @DateSelector = 2 -- current month
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @date, 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(day, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(month, 1, @PeriodStart)

	IF @DateSelector = 3 -- last month
		SELECT
			@PeriodEnd = DATEADD(day, 1 - DATEPART(day, @date), @date),
			@PeriodStart = DATEADD(month, -1, @PeriodEnd)
			
	IF @DateSelector = 4 -- arbitrary period
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodEnd)
			
			
	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[EmployeeID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		[Expense].[VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency],
		[Project].[CustomerCompanyID],
		ISNULL([Category].[FileAs], @none) as [Category],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentClassName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT dbo.adfGetDocumentClassNameByTable('Task'))
		END AS [DocumentClassName],
		CASE
			WHEN [Expense].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([Expense].[DocumentID], [Expense].[DocumentClass]))
				ELSE (SELECT [Task].[FileAs] FROM [Task] WHERE [Task].[ID] = [Expense].[TaskID])
		END AS [DocumentName],
		[CostCenter].[FileAs] AS [CostCenterName]
	FROM
		[pjm5vwExpense] AS [Expense]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
		LEFT OUTER JOIN [DocumentCategory]
			ON ([Expense].[Class] = [DocumentCategory].[DocumentClass] AND [Expense].[ID] = [DocumentCategory].[DocumentID])
		LEFT OUTER JOIN [Category]
			ON ([DocumentCategory].[DocumentClass] = [Category].[DocumentClass] AND [DocumentCategory].[CategoryID] = [Category].[ID])
		LEFT JOIN [CostCenter]
			ON [CostCenter].[ID] = [Project].[CostCenterID]
	WHERE
		( 
			dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR 
			dbo.fnPjm5AllowCreateProjectEntry([Project].[ID], [Expense].[EmployeeID]) = 1 OR
			(dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1 AND @RestrictedView = 0) OR
			@ExpenseSecretary = 1
		) AND
		(
			@EmployeeID IS NULL OR
			[Expense].[EmployeeID] = @EmployeeID
		) AND 
		(
			(@ProjectSelector = 0) OR
			(
				@ProjectSelector = 1 AND 
				(
					(@ActiveProjectID IS NULL AND [Project].[State] = 2) OR
					(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID)
				)
			) OR
			(
				@ProjectSelector = 2 AND 
				(
					(@NotActiveProjectID IS NULL AND [Project].[State] != 2) OR
					(@NotActiveProjectID IS NOT NULL AND [Project].[ID] = @NotActiveProjectID)
				)
			)
		) AND
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [Expense].[State] IN (1, 5)) OR		-- / 
			(@StateSelector = 2 AND [Expense].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [Expense].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [Expense].[State] = 6) OR			--   
			(@StateSelector = 5 AND [Expense].[State] = 4)				-- 
		) AND
		(
			@DateSelector = 0 OR
			[Expense].[Date] >= @PeriodStart AND 
			[Expense].[Date] < @PeriodEnd
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseBrowseByCategory] TO PUBLIC
GO
