 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6LockFinancePeriod]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6LockFinancePeriod'
		DROP PROCEDURE [dbo].[pjm6LockFinancePeriod]
	END
GO

PRINT 'Creating procedure pjm6LockFinancePeriod'
GO

/******************************************************************************
**		File: pjm6LockFinancePeriod.sql
**		Name: pjm6LockFinancePeriod
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.svintsov
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		17/03/10	SPV				First Version
**		29.07.10	SYV				   ,   
*******************************************************************************/
CREATE PROCEDURE [pjm6LockFinancePeriod]
	@StartDate TDate,
	@EndDAte TDate,
	@SupplierID TIdentifier,
	@Locked TBool
	
AS

	DECLARE @for_update TABLE ([ID] INT not null)

	IF @SupplierID IS NULL
	BEGIN
		INSERT INTO @for_update
			(ID)
		SELECT 
			[ID] 
		FROM 
			[Company] 
		WHERE 
			[ExchangeBanned] = 0
	END
	ELSE
	BEGIN
		INSERT INTO @for_update VALUES(@SupplierID)
	END

	UPDATE
		[Facture]
	SET
		[Facture].[ExchangeBanned] = @Locked
	WHERE
		[Facture].[SupplierCompanyID] IN (SELECT [ID] FROM @for_update) AND
		[Facture].[Date] BETWEEN @StartDate AND @EndDAte
		
		
	UPDATE
		[Invoice]
	SET
		[Invoice].[ExchangeBanned] = @Locked
	WHERE
		[Invoice].[SupplierCompanyID] IN (SELECT [ID] FROM @for_update) AND
		[Invoice].[Date] BETWEEN @StartDate AND @EndDAte
		
	UPDATE
		[Statement]
	SET
		[Statement].[ExchangeBanned] = @Locked
	WHERE
		[Statement].[SupplierCompanyID] IN (SELECT [ID] FROM @for_update) AND
		[Statement].[Date] BETWEEN @StartDate AND @EndDAte
	
	RETURN 0
GO

GRANT EXECUTE ON pjm6LockFinancePeriod TO PUBLIC
GO
