  IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestFind'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestFind]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestFind'
GO

/******************************************************************************
**		File: pjm5ServiceRequestFind.sql
**		Name: pjm5ServiceRequestFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		08.08.12	SOV				     [ServiceRequest].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	SELECT
		[ServiceRequest].[Class],
		[ServiceRequest].[ID],
		[ServiceRequest].[State],
		[ServiceRequest].[DueDate],
		[ServiceRequest].[Number],
		[ServiceRequest].[FileAs],
		[ServiceRequest].[Comments],
		[ServiceRequest].[ProjectID],
		[ServiceRequest].[Flag],
		[ServiceRequest].[Created],
		[ServiceRequest].[CreatedBy],
		[ServiceRequest].[Modified],
		[ServiceRequest].[ModifiedBy]
	FROM
		[ServiceRequest] INNER JOIN dbo.fnPjm5GetAvailableProjects() as [P]
			ON ([ServiceRequest].[ProjectID] = [P].[ID])
	WHERE
		(
			@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [ServiceRequest].[ProjectID] = @ProjectID)
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [ServiceRequest].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([ServiceRequest].[FileAs] LIKE '%' + @Text + '%' OR [ServiceRequest].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([ServiceRequest].[Number] LIKE '%' + @Text + '%' OR [ServiceRequest].[FileAs] LIKE '%' + @Text + '%' OR [ServiceRequest].[Comments] LIKE '%' + @Text + '%'))
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [ServiceRequest].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [ServiceRequest].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND [EmployeeID] = @EmployeeID)
			OR
			(@UserOption = 1 AND ([CreatedBy] = @UserID OR [ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [ServiceRequest].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [ServiceRequest].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[ServiceRequest].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceRequestFind] TO PUBLIC
GO