IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderBrowse'
		DROP PROCEDURE [dbo].[pjm5FolderBrowse]
	END
GO

PRINT 'Creating procedure pjm5FolderBrowse'
GO

/******************************************************************************
**		File: pjm5FolderBrowse.sql
**		Name: pjm5FolderBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      27.06.11	SPV				Optimization
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderBrowse]
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	DECLARE @UserID TIdentifier, @TakeOwnership TBool
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @TakeOwnership = dbo.adfHasAccessRight(dbo.adfGetRightID('TakeOwnership'))
	
	SELECT
		[ID],
		[Class],
		[State],
		[Flag],
		[CompanyID],
		[FolderID],
		[SubfolderCount],
		[ItemCount],
		(
			SELECT
				COUNT(*)
			FROM
				[CaseOfFolder]
			 WHERE
				[CaseOfFolder].[FolderID] = [Folder].[ID] AND
				[CaseOfFolder].[CaseID] IN
				(
					SELECT [ID] FROM [Case] WHERE [State] = 1
				)
		) AS [CaseCount],
		[Code],
		CASE
			WHEN [ID] = 1 AND @Lang != 'ru' THEN 'Public Folders'
			ELSE [FileAs]
		END AS [FileAs],
		[VersionControl],
		[PublicationControl],
		[FileTemplate],
		[Parameters],
		[Created],
		[CreatedBy],
		[Modified],
		[ModifiedBy],
		CAST([Timestamp] AS bigint) AS [Timestamp]
	FROM
		[Folder]
	WHERE
		[ID] > 0 AND
		ISNULL(@FolderID, -100) = ISNULL(FolderID, -100) AND
		(@TakeOwnership = 1 OR dbo.fnFolderHasRightAccess([ID], @UserID, 'FolderVisible') = 1)

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderBrowse] TO PUBLIC
GO
