IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'Pjm6FindInvoice')
	BEGIN
		PRINT 'Dropping Procedure Pjm6FindInvoice'
		DROP  Procedure  Pjm6FindInvoice
	END

GO

PRINT 'Creating Procedure Pjm6FindInvoice'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
---------------------------------------------------------------------------------------
	DATE		Author		Comments
---------------------------------------------------------------------------------------
	18.06.10	SPV			first version
--------------------------------------------------------------------------------------*/
CREATE PROCEDURE Pjm6FindInvoice
	@Number TName = NULL,
	@Date TDate = NULL,
	@Contract TName,
	@Sum TMoney
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @InvoiceID TIdentifier
	
	SET @Number = ISNULL(@Number, '')
	SET @Date = ISNULL(@Date, '')
	
	SELECT
		ISNULL([Invoice].[ID], 0)
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
	WHERE
		(
			[Project].[ExchangeSystemName] = @Contract OR
			@Contract LIKE ([Project].[ContractNumber] + '  ' + CONVERT(varchar(5),  [Project].[ContractDate], 104) + '%')
		) AND [Invoice].[State] IN (2, 4) AND
		(
			([Invoice].[Number] = @Number) AND
			([Invoice].[Date] = @Date)
			OR
			([Invoice].[TotalWithVAT] = @Sum AND @Number = '' AND @Date = '')
		)
		
	RETURN 0
	
END
GO

GRANT EXEC ON Pjm6FindInvoice TO PUBLIC
GO
