IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm6CreateExportItem')
	BEGIN
		PRINT 'Dropping Procedure pjm6CreateExportItem'
		DROP  Procedure  pjm6CreateExportItem
	END
GO

PRINT 'Creating Procedure pjm6CreateExportItem'
GO
--------------------------------------------------------------------------------------
-- Copyright (c) 2010 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
---------------------------------------------------------------------------------------
	DATE		Author		Comments
--	---------	---------	-----------------------------------------------------------
	21.06.10	SPV			first version
--------------------------------------------------------------------------------------*/
CREATE Procedure pjm6CreateExportItem
	@CompanyID TIdentifier,
	@PeriodStart TDate,
	@PeriodEnd TDate,
	@ExportType int
AS
	SET NOCOUNT ON
	
	DECLARE
		@EmployeeID TIdentifier,
		@Date TDate
		
	SET @Date = GETDATE()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	INSERT INTO [ExportItem] ([Date], [EmployeeID], [CompanyID], [PeriodStart], [PeriodEnd], [ExportTypeID])
	VALUES (@DATE, @EmployeeID, @CompanyID, @PeriodStart, @PeriodEnd, @ExportType)
	
	RETURN 0
GO

GRANT EXEC ON pjm6CreateExportItem TO PUBLIC
GO