IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[IssueBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure IssueBrowseSelectorDialog'
		DROP PROCEDURE [dbo].[IssueBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure IssueBrowseSelectorDialog'
GO

/******************************************************************************
**		File: pjm5IssueBrowseByCategory.sql
**		Name: pjm5IssueBrowseByCategory
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [IssueBrowseSelectorDialog]
	@EmployeeID TIdentifier,
	@ProjectID TIdentifier,
	@State TIdentifier,
	@View int
AS
	SET NOCOUNT ON
	
	DECLARE 
		@StateClass TClass,
		@IssueManager int
		
	SET @StateClass = dbo.adfGetClassByName('Pjm5.Issue')
	SET @IssueManager = dbo.adfHasAccessRightByName('ManageIssues')
	
	IF (@EmployeeID = 0)
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SELECT
		[Issue].[ID],
		[Issue].[State],
		[Issue].[ProjectID],
		[Issue].[Number],
		[Issue].[FileAs],
		[State].[Name] as [StateName],
		[Employee].[FileAs] as [Employee]
	FROM
		[Issue]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Issue].[EmployeeID]
		INNER JOIN [State]
			ON [State].[State] = [Issue].[State]
			AND [State].[Class] = @StateClass
		INNER JOIN dbo.fnPjm6GetAvailableProjectsForTimeEntryGet(@EmployeeID, @ProjectID) AS [Project]
			ON [Project].[ID] = [Issue].[ProjectID]
	WHERE
		[Issue].[State] IN (2, 3, 4, 6) AND
		
		(
			@IssueManager = 1 OR [Issue].[EmployeeID] IS NULL OR
			[Issue].[EmployeeID] = @EmployeeID
		) AND 
		(
			@ProjectID IN (0, -1, -2, -3, -4) OR
			[Issue].[ProjectID] = @ProjectID
		) AND
		(
			[Issue].[State] = @State OR	--   
			@State = 0 --   
		) AND
		(
			@View = 0 OR --   
			[Issue].[EmployeeID] = @EmployeeID --   
		)
		 
		
	RETURN 0
GO

GRANT EXECUTE ON [IssueBrowseSelectorDialog] TO PUBLIC
GO
 