IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IssueGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IssueGet'
		DROP PROCEDURE [dbo].[pjm5IssueGet]
	END
GO

PRINT 'Creating procedure pjm5IssueGet'
GO

/******************************************************************************
**		File: pjm5IssueGet.sql
**		Name: pjm5IssueGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**      27.10.10    BVY             Added the verification of rights when you try to open the issue 
**		03.04.13	SOV				    . - 
**									     " "
*******************************************************************************/
CREATE PROCEDURE [pjm5IssueGet]
	@ID TIdentifier
AS
	DECLARE
		@ProjectID TIdentifier,
		@UserID TIdentifier,
		@IsFinanceEnable	bit,
		@ViewAllFinance TBool,
		@ViewFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@IsPM TBool,
		@IsMember TBool,
		@IsTemplate bit,
		@IsFinanceManager TBool,
		@FinanceManagement TBool
		
	SET NOCOUNT ON
	
	SELECT
		@ProjectID = [Issue].[ProjectID]
	FROM
		[Issue]
	WHERE
		[Issue].[ID] = @ID
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance'))
	SET @FinanceManagement = dbo.fnPjm7HasPossibilityToProjectFinanceManagement(@ProjectID, @CurrentEmployeeID)
	SET @IsPM = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
	SET @IsMember = @IsPM | dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)
	SET @IsFinanceManager = dbo.fnPjm7IsFinanceManager(@ProjectID, @CurrentEmployeeID)

	SET @IsFinanceEnable = @IsMember & @ViewFinance & @FinanceManagement
	SET @IsFinanceEnable = @IsFinanceEnable | @ViewAllFinance | @IsPM | @IsFinanceManager
	
	SELECT @IsTemplate = (SELECT COUNT(*) FROM [ProjectTemplate] WHERE [ID] = @ProjectID)

	IF @IsTemplate = 0 AND  dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID) != 1 AND dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) = 0
		BEGIN
			IF @IsMember = 0
			BEGIN
				RAISERROR('#NotEnoughPermissions', 18, -1)
				RETURN 1
			END
		END

	SELECT
		[Issue].[Class],
		[Issue].[ID],
		[Issue].[State],
		[Issue].[Flag],
		[Issue].[Number],
		[Issue].[FileAs],
		[Issue].[DuplicateOfIssueID],
		[Issue].[ProjectID],
		[Issue].[EmployeeID],
		[Issue].[SeverityID],
		[Issue].[PriorityID],
		[Issue].[DueDate],
		[Issue].[EndTime],
		[Issue].[ResolutionID],
		[Issue].[Resolution],
		[Issue].[SendStatusReport],
		[Issue].[WSSDocumentURL],
		[Issue].[UDF1],
		[Issue].[UDF2],
		[Issue].[UDF3],
		[Issue].[UDF4],
		[Issue].[Comments],
		[Issue].[Created],
		[Issue].[CreatedBy],
		[Issue].[Modified],
		[Issue].[ModifiedBy],
		[Issue].[Timestamp],
		[Issue].[ActualManHour],
		[Issue].[ManHour],
		[Issue].[ActualBudget],
		[Issue].[Budget],
		ISNULL([Project].[CurrencyCode], 'RUB') AS [CurrencyCode],
		[Project].[ProjectTypeID],
		CASE 
			WHEN (@IsFinanceEnable = 1 AND [Project].[ProjectTypeID] = 1) 		
				THEN 1
			ELSE 0
		END AS [HasFinanceAccess],
		(SELECT [UDFCaption] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=1) as [UDF1Caption],
		(SELECT [UDFCaption] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=2) as [UDF2Caption],
		(SELECT [UDFCaption] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=3) as [UDF3Caption],
		(SELECT [UDFCaption] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=4) as [UDF4Caption],
		(SELECT [SortOrderAscending] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=1) as [UDF1SortOrder],
		(SELECT [SortOrderAscending] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=2) as [UDF2SortOrder],
		(SELECT [SortOrderAscending] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=3) as [UDF3SortOrder],
		(SELECT [SortOrderAscending] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=4) as [UDF4SortOrder],
		(SELECT [NamedListID] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=1) as [UDF1List],
		(SELECT [NamedListID] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=2) as [UDF2List],
		(SELECT [NamedListID] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=3) as [UDF3List],
		(SELECT [NamedListID] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=4) as [UDF4List],
		ISNULL([UserReminder].[State], CAST(0 as int)) AS [ReminderState],
		ISNULL([UserReminder].[OriginalInterval], dbo.fnPjm5GetReminderInterval([Issue].[Class], 'ID', @UserID)) AS [ReminderInterval]
	FROM
		[Issue]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [Issue].[Class] AND
				[Reminder].[DocumentID] = [Issue].[ID] AND
				[Reminder].[Subtype] = 'ID')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
		LEFT OUTER JOIN [Project]
			ON [Project].[ID] = [Issue].[ProjectID]
	WHERE
		[Issue].[ID] = @ID
		
	SELECT
		[NamedListID],
		[Code]
	FROM
		[NamedListEntry]
	WHERE
		[NamedListID] IN (SELECT [ID] FROM [NamedList] WHERE [ProjectID] = @ProjectID)

	RETURN 0
GO

GRANT EXECUTE ON [pjm5IssueGet] TO PUBLIC
GO

 