IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[lmIssue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure lmIssue'
		DROP PROCEDURE [dbo].[lmIssue]
	END
GO

PRINT 'Creating procedure lmIssue'
GO

/******************************************************************************
**		File: pjm6lmIssue.sql
**		Name: lmIssue
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: SPV
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [lmIssue]
AS
	SET NOCOUNT ON
		
	DECLARE @EmployeeID TIdentifier,
		@IssueManager int
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @IssueManager = dbo.adfHasAccessRightByName('ManageIssues')

	SELECT
		[Issue].[ID],
		[Issue].[State],
		[Issue].[FileAs] AS [Name],
		[Issue].[ProjectID]
	FROM
		[Issue] INNER JOIN dbo.fnPjm5GetAvailableProjects() as [P]
			ON ([Issue].[ProjectID] = [P].[ID])
	WHERE
		[Issue].[State] IN (3,4) AND
		(
			@IssueManager = 1 OR
			[Issue].[EmployeeID] = @EmployeeID
		)
	
	RETURN 0
GO

GRANT EXECUTE ON [lmIssue] TO PUBLIC
GO
 