 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmEmployeeAccessible')
	BEGIN
		PRINT 'Dropping Procedure lmEmployeeAccessible'
		DROP  Procedure  lmEmployeeAccessible
	END

GO

PRINT 'Creating Procedure lmEmployeeAccessible'
GO
/******************************************************************************
**		File: 
**		Name: lmEmployeeAccessible
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmEmployeeAccessible
AS
	SET NOCOUNT ON
		
	EXEC lmEmployeeAccessibleInternal

	RETURN 0
GO

GRANT EXEC ON lmEmployeeAccessible TO PUBLIC
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmEmployeeAccessibleInternal')
	BEGIN
		PRINT 'Dropping Procedure lmEmployeeAccessibleInternal'
		DROP  Procedure  lmEmployeeAccessibleInternal
	END

GO

PRINT 'Creating Procedure lmEmployeeAccessibleInternal'
GO
/******************************************************************************
**		File: 
**		Name: lmEmployeeAccessibleInternal
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		17.06.10	PAM				  
**    
*******************************************************************************/
CREATE Procedure lmEmployeeAccessibleInternal
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRightByName('ViewAllProjects') = 1 OR 
		dbo.adfHasAccessRightByName('ViewAllEmployees') = 1 OR
		dbo.adfHasAccessRightByName('ManageExpenseWithoutAssignment') = 1

			
		SELECT
			[Employee].[ID],
			[Employee].[FileAs] as [Name],
			[Employee].[CompanyID],
			[Employee].[State],
			[Employee].[UserID],
			[Company].[Own],
			[Employee].[Initials] as [Code],
			[Employee].[DivisionID],
			1 AS [Strong] 
		FROM
			[Employee] 
			INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID])
		WHERE 
			[Company].[State] = 1	AND [Company].[Own] = 1
		
	ELSE
	BEGIN
		DECLARE
			@EmployeeID int,
			@ManageProject TBool
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()	
		SET @ManageProject = dbo.adfHasAccessRightByName('ManageProject')
			
		SELECT
			[Employee].[ID],
			[Employee].[FileAs] as [Name],
			[Employee].[CompanyID],
			[Employee].[State],
			[Employee].[UserID],
			[Company].[Own],
			[Employee].[Initials] as [Code],
			[Employee].[DivisionID],
			CASE [Employee].[ID] 
				WHEN @EmployeeID THEN 1
				ELSE @ManageProject
			END AS [Strong]
		FROM
			[Employee]
			INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID])
			INNER JOIN fnPjm6GetAvailableProjectsAssignment() AS APA
				ON ([Employee].[ID] = [APA].[ID])
			WHERE
				[Company].[State] = 1
	END
	RETURN 0
GO

GRANT EXEC ON lmEmployeeAccessibleInternal TO PUBLIC
GO