IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmInvoice')
	BEGIN
		PRINT 'Dropping Procedure lmInvoice'
		DROP  Procedure  lmInvoice
	END

GO

PRINT 'Creating Procedure lmInvoice'
GO
/******************************************************************************
**		File: 
**		Name: lmInvoice
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmInvoice
AS
	SET NOCOUNT ON

	SELECT
		[Invoice].[ID],
		[Invoice].[Number] as [Code],
		[Invoice].[FileAs] as [Name],
		[Invoice].[State],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Invoice].[SupplierBankAccountID],
		[Invoice].[CurrencyCode]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
	WHERE
		[Invoice].[State] = 2
	
	RETURN 0
GO

GRANT EXEC ON lmInvoice TO PUBLIC
GO
 