IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmProjectActivityType')
	BEGIN
		PRINT 'Dropping Procedure lmProjectActivityType'
		DROP  Procedure  lmProjectActivityType
	END

GO

PRINT 'Creating Procedure lmProjectActivityType'
GO
/******************************************************************************
**		File: 
**		Name: lmProjectActivityType
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		04.02.13	SAP				  Color
*******************************************************************************/
CREATE Procedure lmProjectActivityType
AS
	SET NOCOUNT ON

	SELECT
		[ActivityType].[ID],
		[ActivityType].[Code],
		[ActivityType].[FileAs] as [Name],
		[ActivityType].[State],
		[ProjectActivityType].[Billable],
		[ActivityType].[PhoneCallAccessible],
		[ProjectActivityType].[ProjectID],
		[ProjectActivityType].[Actively],
		[ActivityType].[Color]
	FROM
		[ActivityType]
		INNER JOIN [ProjectActivityType]
			ON ([ActivityType].[ID] = [ProjectActivityType].[ActivityTypeID])
		
	RETURN 0
GO

GRANT EXEC ON lmProjectActivityType TO PUBLIC
GO
 