IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsTimeScaleValuesGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsTimeScaleValuesGet'
		DROP PROCEDURE [dbo].[pjm6MsTimeScaleValuesGet]
	END
GO

PRINT 'Creating procedure pjm6MsTimeScaleValuesGet'
GO


CREATE PROCEDURE [pjm6MsTimeScaleValuesGet] 
				@MsAssignmentID TIdentifier
				
AS
	
	SET NOCOUNT ON

	DECLARE
		@ProjectID TIdentifier,
		@TaskID TIdentifier,
		@AssignmentID TIdentifier


	SELECT
		@AssignmentID = [Assignment].[ID],
		@ProjectID = [Assignment].[ProjectID],
		@TaskID = [Task].[ID]
	FROM
		[Assignment]
			INNER JOIN [MsResource]
				ON [Assignment].[MsResourceID] = [MsResource].[ID]
			INNER JOIN [MsAssignment]
				ON [MsAssignment].[ResourceID] = [MsResource].[ID]
			INNER JOIN [Task]
				ON [MsAssignment].[TaskID] = [Task].[MsTaskID]
	WHERE
		[MsAssignment].[ID] = @MsAssignmentID 
		
	SELECT
		[BusyEntry].[Date] AS [Date],
		[BusyEntry].[ActualWork] + [BusyEntry].[ActualOvertimeWork] AS [Value],
		0 AS [Type]
	FROM
		[BusyEntry] 
	WHERE
		[BusyEntry].[AssignmentID] = @AssignmentID AND
		[BusyEntry].[TaskID] = @TaskID AND
		[BusyEntry].[ProjectID] = @ProjectID AND
		([BusyEntry].[Date] <= CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime) 
			OR [BusyEntry].[ActualWork] != 0)
		
	UNION ALL
	
	SELECT
		[BusyEntry].[Date] AS [Date],
		[BusyEntry].[ActualOvertimeWork] AS [Value],
		1 AS [Type]
	FROM
		[BusyEntry] 
	WHERE
		[BusyEntry].[AssignmentID] = @AssignmentID AND
		[BusyEntry].[TaskID] = @TaskID AND
		[BusyEntry].[ProjectID] = @ProjectID AND
		([BusyEntry].[Date] <= CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime) 
			OR [BusyEntry].[ActualOvertimeWork] != 0)
	
RETURN 0
GO

GRANT EXECUTE ON [pjm6MsTimeScaleValuesGet] TO PUBLIC
GO
 