IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7NormBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7NormBrowse'
		DROP PROCEDURE [dbo].[pjm7NormBrowse]
	END
GO

PRINT 'Creating procedure pjm7NormBrowse'
GO

/******************************************************************************
**		File: pjm7NormBrowse.sql
**		Name: pjm7NormBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Avgusta.Bekhtina
**		Date: 19/06/2014 12:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm7NormBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[Norm].[Class],
		[Norm].[ID],
		[Norm].[State],
		[Norm].[Flag],
		[Norm].[Code],
		[Norm].[FileAs],
		DATEPART(year, [NormValue].[Year]) as [Year],
		[NormValue].[UtilizationHours] as [UtilizationHours],
		[NormValue].[RealizationHours] as [RealizationHours],
		CAST((CAST([NormValue].[RealizationHours] as decimal(18,4)) / [NormValue].[UtilizationHours]) as decimal(18,4)) * 100 as [RealizationPercent],
		[NormValue].[Revenue] as [Revenue],
		[Norm].[Comments],
		[Norm].[Created],
		[Norm].[CreatedBy],
		[Norm].[Modified],
		[Norm].[ModifiedBy],
		[Norm].[Timestamp],
		[dbo].[fnPjm5GetBaseCurrency]() as [BaseCurrency]
	FROM
		[Norm] LEFT OUTER JOIN [NormValue] ON
			([Norm].[ID] = [NormValue].[NormID])
		AND 
			(CAST(DATEPART(year, [NormValue].[Year]) as int) = 
				(SELECT
					MAX(CAST(DATEPART(year, [NormValue].[Year]) as int)) 
				FROM [NormValue]
				WHERE [NormValue].[NormID] = [Norm].[ID]))

	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector != 0 AND [Norm].[State] = @StateSelector)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm7NormBrowse] TO PUBLIC
GO
