IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7NormChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7NormChangeState'
		DROP PROCEDURE [dbo].[pjm7NormChangeState]
	END
GO

PRINT 'Creating procedure pjm7NormChangeState'
GO

/******************************************************************************
**		File: pjm7NormChangeState.sql
**		Name: pjm7NormChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Avgusta.Bekhtina
**		Date: 19/06/2014 12:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm7NormChangeState]
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Norm].[Class],
		@FromState = [Norm].[State]
	FROM
		[Norm]
	WHERE
		[Norm].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[Norm]
	SET
		[Norm].[State] = @ToState,
		[Norm].[Modified] = GETDATE(),
		[Norm].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Norm].[ID] = @ID
	AND
		[Norm].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON [pjm7NormChangeState] TO PUBLIC
GO
