IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallUpdate'
		DROP PROCEDURE [dbo].[pjm5PhoneCallUpdate]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallUpdate'
GO

/******************************************************************************
**		File: pjm5PhoneCallUpdate.sql
**		Name: pjm5PhoneCallUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		12.07.11	SYV				   
**		12.03.13	SOV				 OpenXml  Xml 
*******************************************************************************/
CREATE PROCEDURE pjm5PhoneCallUpdate
	@Xml XML
AS
	DECLARE
		@ID TIdentifier,
		@FileAs TName,
		@ActivityTypeID TIdentifier,
		@AssignmentID TIdentifier,
		@EmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@TaskID TIdentifier,
		@StartTime TDateTime,
		@Duration TCount,
		@TimeBillable TBool,
		@ExpenseBillable TBool,
		@Overtime TBool,
		@ExpenseCodeID TIdentifier,
		@Amount TCount,
		@Price TMoney,
		@ExpenseCurrencyCode TCode3,
		@ProjectCurrencyCode TCode3,
		@BillableDuration TCount,
		@Rate TMoney,
		@VATRate TPercent,
		@VAT TMoney,
		@Comments TNotes,
		@PhoneCallCodeID TIdentifier,
		@TimeEntryID TIdentifier,
		@ExpenseID TIdentifier,
		@rv int,
		@MyEmployeeID int,
		@OldAssignmentID TIdentifier,
		@VatIsIncluded TBool,
		@UOMID TIdentifier,
		@value TVariant,
		@DocumentClass TIdentifier,
		@DocumentID TIdentifier,
		@PrevEmployeeID TIdentifier

	SET NOCOUNT ON
	
	SELECT
		@ID = [XmlTable].value('ID[1]', 'int'),
		@FileAs = [XmlTable].value('FileAs[1]', 'nvarchar(256)'), 
		@PhoneCallCodeID = [XmlTable].value('PhoneCallCodeID[1]', 'int'),
		@ActivityTypeID = [XmlTable].value('ActivityTypeID[1]', 'int'),
		@ProjectID = [XmlTable].value('ProjectID[1]', 'int'), 
		@TaskID = [XmlTable].value('TaskID[1]', 'int'), 
		@StartTime = CAST([XmlTable].value('StartTime[1]', 'varchar(19)') as datetime), 
		@Duration = [XmlTable].value('Duration[1]', 'int'), 
		@TimeBillable = CASE WHEN [XmlTable].value('Billable[1]', 'varchar(5)') = 'false' THEN 0 ELSE 1 END, 
		@ExpenseBillable = CASE WHEN [XmlTable].value('ExpenseBillable[1]', 'varchar(5)') = 'false' THEN 0 ELSE 1 END, 
		@Overtime = CASE WHEN [XmlTable].value('Overtime[1]', 'varchar(5)') = 'false' THEN 0 ELSE 1 END, 
		@ProjectCurrencyCode = [Project].[CurrencyCode], 
		@VATRate = dbo.fnPjm5GetVATRate(),
		@Price = ROUND([PhoneCallRate].[Price], 2), 
		@TimeEntryID = [XmlTable].value('TimeEntryID[1]', 'int'),
		@ExpenseID = [XmlTable].value('ExpenseID[1]', 'int'),
		@Comments = [XmlTable].value('Comments[1]', 'nvarchar(max)'),
		@EmployeeID = [XmlTable].value('EmployeeID[1]', 'int'),
		@VatIsIncluded = [PhoneCallCode].[VatIsIncluded],
		@DocumentClass = dbo.adfGetClassByName([XmlTable].value('DocumentClass[1]', 'nvarchar(max)')),
		@DocumentID = [XmlTable].value('DocumentID[1]', 'TIdentifier')
	FROM
		@Xml.nodes('/pjm5PhoneCallGet/PhoneCall') AS List(XmlTable)
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].value('ProjectID[1]', 'int')
		INNER JOIN [PhoneCallCode]
			ON [PhoneCallCode].[ID] = [XmlTable].value('PhoneCallCodeID[1]', 'int')
		LEFT OUTER JOIN [PhoneCallRate]
			ON ([PhoneCallRate].[PhoneCallCodeID] = [PhoneCallCode].[ID] AND
				[PhoneCallRate].[CurrencyCode] = [Project].[CurrencyCode])
			
	IF NOT EXISTS(
		SELECT *
		FROM [ProjectExpenseCode]
		WHERE
			[ProjectID] = @ProjectID AND
			[ExpenseCodeID] = 1
		)
	BEGIN
		RAISERROR('#phonecallisnotenabled', 18, -1)
		RETURN 1
	END

	IF @Price IS NULL
	BEGIN
		RAISERROR('#pricenotfound', 18, -1)
		RETURN 1
	END

	DECLARE @language TLanguage
	SET @language = dbo.adfGetLanguage()
	IF @FileAs IS NULL
		SELECT 
			@FileAs = CASE @language
				WHEN 'en' THEN 'Phone call, code '
				ELSE ' ,  '
			END + ISNULL([FileAs], [Code])
		FROM
			[PhoneCallCode]
		WHERE
			[ID] = @PhoneCallCodeID
	
	SELECT
		@PrevEmployeeID = [TimeEntry].[EmployeeID]
	FROM
		[TimeEntry]
	WHERE
		[TimeEntry].[ID] = @TimeEntryID

	BEGIN TRANSACTION
	EXEC @rv = pjm5TimeEntryUpdateInternal 
		@TimeEntryID, 
		@FileAs, 
		@ActivityTypeID,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID, 
		@TaskID, 
		@StartTime, 
		@Duration, 
		@TimeBillable,
		@Duration, 
		@Overtime, 
		@ProjectCurrencyCode, 
		@VATRate, 
		NULL,
		@Comments,
		@PrevEmployeeID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	IF @VATIsIncluded = 1
		SET @VAT = @Duration * @Price * @VATRate / (1 + @VATRate)
	ELSE
		SET @VAT = @Duration * @Price * @VATRate
		
	EXEC adfParameterGet @Name='MinuteUOMID', @Group='Pjm5', @Value = @value OUTPUT
	SET @UOMID = CAST(@value as int)
	
	EXEC @rv = pjm5ExpenseUpdateInternal 
		@ExpenseID, 
		@FileAs,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		1, --@ExpenseCodeID,
		@StartTime,
		@UOMID,
		@Duration, --@Amount,
		@ExpenseBillable,
		@Price,
		@ProjectCurrencyCode, --@ExpenseCurrencyCode,
		@ProjectCurrencyCode,
		1, --@CurrencyRate,
		@VATRate,
		@VatIsIncluded,
		@VAT, -- VAT
		@Comments
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE 
		[PhoneCall]
	SET
		[PhoneCall].[FileAs] = @FileAs,
		[PhoneCall].[TimeEntryID] = @TimeEntryID,
		[PhoneCall].[ExpenseID] = @ExpenseID,
		[PhoneCall].[PhoneCallCodeID] = @PhoneCallCodeID,
		[PhoneCall].[Comments] = @Comments,
		[PhoneCall].[Modified] = GETDATE(),
		[PhoneCall].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[PhoneCall].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm5PhoneCallGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5PhoneCallUpdate TO PUBLIC
GO
 