IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectTemplateChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectTemplateChangeState'
		DROP PROCEDURE [dbo].[pjm5ProjectTemplateChangeState]
	END
GO

PRINT 'Creating procedure pjm5ProjectTemplateChangeState'
GO

/******************************************************************************
**		File: pjm5ProjectTemplateChangeState.sql
**		Name: pjm5ProjectTemplateChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ProjectTemplateChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@result INT
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Project].[Class],
		@FromState = [Project].[State]
	FROM
		[Project]
	WHERE
		[Project].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @EndDate TDate
	
	SET @EndDate = CONVERT(datetime, CONVERT(varchar(8), GETDATE(), 112), 112)
	
	BEGIN TRANSACTION
	
	
	UPDATE
		[Project]
	SET
		[Project].[EndDate] = (CASE WHEN @ToState = 4 THEN @EndDate ELSE NULL END),
		[Project].[State] = @ToState,
		[Project].[Modified] = DEFAULT,
		[Project].[ModifiedBy] = DEFAULT
	WHERE
		[Project].[ID] = @ID
	AND
		[Project].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE
		[Document]
	SET
		[Document].[State] = @ToState,
		[Document].[Modified] = DEFAULT,
		[Document].[ModifiedBy] = DEFAULT
	WHERE
		[Document].[Class] = dbo.adfGetClassByName('Pjm5.ProjectTemplate') AND
		[Document].[ID] = @ID
	AND
		[Document].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5ProjectTemplateChangeState TO PUBLIC
GO
 