IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportAllocationByCostCenterHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportAllocationByCostCenterHeader'
		DROP  Procedure  ReportAllocationByCostCenterHeader
	END

GO

PRINT 'Creating Procedure ReportAllocationByCostCenterHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/ 
CREATE PROCEDURE [dbo].[ReportAllocationByCostCenterHeader]
       @CompanyID TIdentifier,
       @DateSelector int,
       @StartDate TDate OUTPUT,
       @EndDate TDate OUTPUT,
       @CurrencySelector int,
       @InvoiceSelector int,
       @Clients int,
       @BaseCurrency TCode3,
       @NationalCurrency TCode3
AS

SET NOCOUNT ON

DECLARE
    @CompanyName TName,
    @CurrencyName TCode3,
    @Value TVariant,
    @InvoiceState TName,
    @Date TDate,
    @PeriodName varchar(64),
    @UserID TIdentifier,
    @UserName TName,
    @PeriodEnd TDate

SET @UserID = dbo.adfGetCurrentUserID()
SELECT 
    @UserName = [Trustee].[DisplayName]
FROM
	[Trustee]
WHERE
	[Trustee].[ID] = @UserID

IF @CompanyID IS NULL  
         SET @CompanyName = '( )'
ELSE
SELECT 
         @CompanyName = [Company].[FileAs]
   FROM
         [Company]
   WHERE 
         [Company].[ID] = @CompanyID


SET @PeriodEnd = @EndDate
EXEC Pjm6GetTimeIntervalFormatted @StartDate, @PeriodEnd, 'ru', @Result = @PeriodName  OUTPUT  

SET @CurrencyName = CASE WHEN @CurrencySelector = 0 THEN @BaseCurrency
                         WHEN @CurrencySelector = 1 THEN @NationalCurrency
                    END

IF @InvoiceSelector = 0
    SET @InvoiceState = '  '
ELSE
    SET @InvoiceState = '  '

SELECT @UserName AS [UserName],
       @CompanyName AS [CompanyName],
       @CurrencyName AS [CurrencyName],
       @InvoiceState AS [InvoiceState],
       @StartDate AS [StartDate],
       @EndDate AS [EndDate],
       @PeriodName AS [PeriodName],
       @Clients AS [Clients]

RETURN 0
GO

GRANT EXEC ON ReportAllocationByCostCenterHeader TO PUBLIC

GO
