IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestSimpleUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestSimpleUpdate'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestSimpleUpdate]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestSimpleUpdate'
GO

/******************************************************************************
**		File: pjm5ResourceRequestSimpleUpdate.sql
**		Name: pjm5ResourceRequestSimpleUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceRequestSimpleUpdate
	@ID TIdentifier,
	@StartTime TDateTime,
	@EndTime TDateTime,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	DECLARE
		@CurrentEmployee	TIdentifier,
		@MeetingRequest		TIdentifier
	
	SET @CurrentEmployee =  dbo.adfGetCurrentEmployeeID()
	SET @MeetingRequest = (SELECT [MeetingRequestID] FROM [ResourceRequest] WHERE [ID] = @ID)
	
	IF (@MeetingRequest IS NOT NULL OR
		@CurrentEmployee <> (SELECT [EmployeeID] FROM [ResourceRequest] WHERE [ResourceRequest].[ID] = @ID))
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE [ResourceRequest]
	SET
		[ResourceRequest].[StartTime] = @StartTime,
		[ResourceRequest].[Duration] = DATEDIFF(minute, @StartTime, @EndTime),
		[ResourceRequest].[Comments] = @Comments,
		[ResourceRequest].[Modified] = DEFAULT,
		[ResourceRequest].[ModifiedBy] = DEFAULT
	WHERE
		[ResourceRequest].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5ResourceRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceRequestSimpleUpdate TO PUBLIC
GO
 