IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestMyTimelineBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestMyTimelineBrowse'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestMyTimelineBrowse]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestMyTimelineBrowse'
GO

/******************************************************************************
**		File: pjm5ServiceRequestMyTimelineBrowse.sql
**		Name: pjm5ServiceRequestMyTimelineBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestMyTimelineBrowse]
	@StateSelector	int,
	@PeriodStart	TDateTime = NULL,
	@PeriodEnd		TDateTime = NULL
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentEmployeeID TIdentifier
	
	SET @CurrentEmployeeID =  dbo.adfGetCurrentEmployeeID()
	DECLARE @ViewAllFinance TBool
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	SELECT
		[ServiceRequest].[Class],
		[ServiceRequest].[ID],
		[ServiceRequest].[ProjectID],
		[ServiceRequest].[EmployeeID],
		[ServiceRequest].[PriorityID],
		[ServiceRequest].[State],
		[ServiceRequest].[Flag],
		[ServiceRequest].[Date],
		[ServiceRequest].[Number],
		[ServiceRequest].[FileAs],
		[ServiceRequest].[Description],
		[ServiceRequest].[StartDate],
		[ServiceRequest].[DueDate],
		[ServiceRequest].[Billable],
		[ServiceRequest].[VATIsIncluded],
		[ServiceRequest].[Comments],
		[ServiceRequest].[Created],
		[ServiceRequest].[CreatedBy],
		[ServiceRequest].[Modified],
		[ServiceRequest].[ModifiedBy],
		[ServiceRequest].[Timestamp],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Project].[CurrencyCode] AS [CurrencyCode],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Project].[ContractSubject] AS [Project],
		[Priority].[FileAs] AS [Priority],
		[ServiceRequest].[ManHour],
		[ServiceRequest].[ActualManHour],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [ServiceRequest].[ActualBudget]
			ELSE -1
		END AS [ActualBudget]
	FROM
		[ServiceRequest]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceRequest].[ProjectID]
		INNER JOIN [Priority]
			ON [Priority].[ID] = [ServiceRequest].[PriorityID]
	WHERE
		(@PeriodStart IS NULL OR (@PeriodStart IS NOT NULL AND [ServiceRequest].[DueDate] >= @PeriodStart)) 
		AND
		(@PeriodEnd IS NULL OR (@PeriodEnd IS NOT NULL AND [ServiceRequest].[StartDate] < @PeriodEnd)) 
		AND
		[ServiceRequest].[EmployeeID] = @CurrentEmployeeID AND
		(
			@StateSelector = 0 OR
			[ServiceRequest].[State] = @StateSelector
		)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceRequestMyTimelineBrowse] TO PUBLIC
GO 