IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementAdvanceBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5StatementAdvanceBrowse'
	DROP PROCEDURE [dbo].[pjm5StatementAdvanceBrowse]
END
GO

PRINT 'Creating procedure pjm5StatementAdvanceBrowse'
GO

/******************************************************************************
**		File: pjm5StatementAdvanceBrowse.sql
**		Name: pjm5StatementAdvanceBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementAdvanceBrowse]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],
		
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Invoice].[CurrencyCode],
		ISNULL([Invoice].[TotalWithVAT], 0.0) AS [Value],
		ISNULL([Invoice].[VAT], 0.0) AS [VAT],
		[StatementAdvanceInvoice].[StatementID],
		ISNULL([StatementAdvanceInvoice].[StatementPaymentValue], 0.0) AS [StatementPaymentValue],
		ISNULL([StatementAdvanceInvoice].[StatementPaymentVAT], 0.0) AS [StatementPaymentVAT],
		ISNULL([StatementAdvanceInvoice].[StatementPaymentValuePC], 0.0) AS [StatementPaymentValuePC],
		ISNULL([StatementAdvanceInvoice].[StatementPaymentVATPC], 0.0) AS [StatementPaymentVATPC]
	FROM
		[StatementAdvanceInvoice]
		INNER JOIN [Invoice]
			ON [Invoice].[ID] = [StatementAdvanceInvoice].[AdvanceInvoiceID]
	WHERE
		[StatementAdvanceInvoice].[StatementID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5StatementAdvanceBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementAdvanceSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5StatementAdvanceSelectorDialog'
	DROP PROCEDURE [dbo].[pjm5StatementAdvanceSelectorDialog]
END
GO

PRINT 'Creating procedure pjm5StatementAdvanceSelectorDialog'
GO

/******************************************************************************
**		File: pjm5StatementAdvanceSelectorDialog.sql
**		Name: pjm5StatementAdvanceSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementAdvanceSelectorDialog]
	@ID TIdentifier,
	@PeriodStart TDate,
	@PeriodEnd TDate,
	@Category TName,
	@ProjectID TIdentifier = NULL,
	@CurrencyCode TCode3 = NULL
AS
	SET NOCOUNT ON
	IF @ID IS NOT NULL
		SELECT 
			@ProjectID = [ProjectID],
			@CurrencyCode = [CurrencyCode]
		FROM
			[Statement]
		WHERE	
			[ID] = @ID

	DECLARE 
		@Lang TLanguage,
		@VAT TName
	SET @Lang = dbo.adfGetLanguage()
	IF @Lang = 'en'
		SET @VAT = ', VAT '
	ELSE
		SET @VAT = ',  '
	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],		
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Invoice].[CurrencyCode],
		ISNULL([Invoice].[TotalWithVAT], 0.0) AS [Value],
		ISNULL([Invoice].[VAT], 0.0) AS [VAT],
		SUM([StatementAdvanceInvoice].[StatementPaymentValue]) AS [StatementPaymentValue],
		SUM([StatementAdvanceInvoice].[StatementPaymentVAT]) AS [StatementPaymentVAT],
		SUM([StatementAdvanceInvoice].[StatementPaymentValuePC]) AS [StatementPaymentValuePC],
		SUM([StatementAdvanceInvoice].[StatementPaymentVATPC]) AS [StatementPaymentVATPC]
	FROM
		[Invoice]
		LEFT OUTER JOIN [StatementAdvanceInvoice]
			ON [Invoice].[ID] = [StatementAdvanceInvoice].[AdvanceInvoiceID]
	WHERE
		[Invoice].[State] IN (2, 5) AND
		[Invoice].[ProjectID] = @ProjectID AND
		[Invoice].[CurrencyCode] = @CurrencyCode AND
		[Invoice].[Advance] = 1 AND
		[Invoice].[Date] BETWEEN @PeriodStart AND @PeriodEnd AND
		NOT EXISTS 
		(
			SELECT * 
			FROM [StatementAdvanceInvoice] 
			WHERE [AdvanceInvoiceID] = [Invoice].[ID] AND [StatementID] = @ID
		) AND
		(
			@Category IS NULL OR
			LEN(@Category) = 0 OR
			EXISTS(
				SELECT * 
				FROM [DocumentCategory] 
					INNER JOIN [Category]
						ON [Category].[ID] = [DocumentCategory].[CategoryID] 
				WHERE
					[DocumentCategory].[DocumentClass] = [Invoice].[Class] AND
					[DocumentCategory].[DocumentID] = [Invoice].[ID] AND
					[Category].[FileAs] LIKE @Category
			)
		)
	GROUP BY 
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],		
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Invoice].[CurrencyCode],
		[Invoice].[TotalWithVAT],
		[Invoice].[VAT]
	HAVING
		ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentValue]), 0) < ISNULL([Invoice].[TotalWithVAT], 0.0)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5StatementAdvanceSelectorDialog] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementAdvanceAppend]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5StatementAdvanceAppend'
	DROP PROCEDURE [dbo].[pjm5StatementAdvanceAppend]
END
GO

PRINT 'Creating procedure pjm5StatementAdvanceAppend'
GO

/******************************************************************************
**		File: pjm5StatementAdvanceAppend.sql
**		Name: pjm5StatementAdvanceAppend
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementAdvanceAppend]
	@ID TIdentifier,
	@AdvanceInvoiceID TIdentifier,
	@StatementPaymentValue TMoney,
	@StatementPaymentVAT TMoney,
	@StatementPaymentValuePC TMoney,
	@StatementPaymentVATPC TMoney
AS
	SET NOCOUNT ON
	INSERT INTO [StatementAdvanceInvoice]
		([StatementID], [AdvanceInvoiceID], [StatementPaymentValue], [StatementPaymentVAT], [StatementPaymentValuePC], [StatementPaymentVATPC]) 
	VALUES 
		(@ID, @AdvanceInvoiceID, ISNULL(@StatementPaymentValue, 0), ISNULL(@StatementPaymentVAT, 0), ISNULL(@StatementPaymentValuePC, 0), ISNULL(@StatementPaymentVATPC, 0))
	IF @@error != 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5StatementAdvanceAppend] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementAdvanceEdit]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5StatementAdvanceEdit'
	DROP PROCEDURE [dbo].[pjm5StatementAdvanceEdit]
END
GO

PRINT 'Creating procedure pjm5StatementAdvanceEdit'
GO

/******************************************************************************
**		File: pjm5StatementAdvanceEdit.sql
**		Name: pjm5StatementAdvanceEdit
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementAdvanceEdit]
	@ID TIdentifier,
	@AdvanceInvoiceID TIdentifier,
	@StatementPaymentValue TMoney,
	@StatementPaymentVAT TMoney,
	@StatementPaymentValuePC TMoney,
	@StatementPaymentVATPC TMoney
AS
	SET NOCOUNT ON
	UPDATE 
		[StatementAdvanceInvoice]
	SET
		[StatementPaymentValue] = ISNULL(@StatementPaymentValue, 0),
		[StatementPaymentVAT] = ISNULL(@StatementPaymentVAT, 0),
		[StatementPaymentValuePC] = ISNULL(@StatementPaymentValuePC, 0),
		[StatementPaymentVATPC] = ISNULL(@StatementPaymentVATPC, 0)
	WHERE 
		[StatementID] = @ID AND
		[AdvanceInvoiceID] =  @AdvanceInvoiceID
	IF @@error != 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5StatementAdvanceEdit] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementAdvanceRemove]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5StatementAdvanceRemove'
	DROP PROCEDURE [dbo].[pjm5StatementAdvanceRemove]
END
GO

PRINT 'Creating procedure pjm5StatementAdvanceRemove'
GO

/******************************************************************************
**		File: pjm5StatementAdvanceRemove.sql
**		Name: pjm5StatementAdvanceRemove
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementAdvanceRemove]
	@ID TIdentifier,
	@AdvanceInvoiceID TIdentifier
AS
	SET NOCOUNT ON
	DELETE [StatementAdvanceInvoice] WHERE [AdvanceInvoiceID] = @AdvanceInvoiceID AND [StatementID] = @ID
	IF @@error != 0
	BEGIN
		RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON [pjm5StatementAdvanceRemove] TO PUBLIC
GO
