IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestAcceptAssignment]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskRequestAcceptAssignment'
		DROP PROCEDURE [dbo].[pjm6TaskRequestAcceptAssignment]
	END
GO

PRINT 'Creating procedure pjm6TaskRequestAcceptAssignment'
GO

/******************************************************************************
**		File: pjm6TaskRequestAcceptAssignment.sql
**		Name: pjm6TaskRequestAcceptAssignment
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestAcceptAssignment]
	@ID	TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@CurrentUserID TIdentifier,
		@CurrentEmployeeID TIdentifier,
		@Author TIdentifier,
		@Supervisor TIdentifier
		
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		@Author = [TaskRequest].[CreatedBy],
		@Supervisor = [TaskRequest].[SupervisorEmployeeID]
	FROM
		[TaskRequest]
	WHERE
		[TaskRequest].[ID] = @ID
	
	UPDATE 
		[TaskRequestAssignment] 
	SET
		[Accepted] = 1
	WHERE 
		[TaskRequestID] = @ID AND
		[EmployeeID] = @CurrentEmployeeID

	IF @CurrentUserID != @Author
		EXEC pjm6TaskRequestAssignmentAcceptNotification @ID, @Author
	IF @Supervisor IS NOT NULL
	BEGIN
		SELECT @Supervisor = [UserID] FROM [Employee] WHERE [ID] = @Supervisor
		IF @CurrentUserID != @Supervisor AND @Author != @Supervisor
			EXEC pjm6TaskRequestAssignmentAcceptNotification @ID, @Supervisor
	END
	RETURN 0
GO

GRANT EXECUTE ON [pjm6TaskRequestAcceptAssignment] TO PUBLIC
GO

  