IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestCreate'
		DROP PROCEDURE [dbo].[pjm5TaskRequestCreate]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestCreate'
GO

/******************************************************************************
**		File: pjm5TaskRequestCreate.sql
**		Name: pjm5TaskRequestCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/21/2006 18:26:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.07.10	MAN				 ,     .
**		21.03.13	MAB				  OPENXML
**		19.06.13	SOV				       
**		25.06.13	SOV				  /     
**									   
**		28.06.13	SOV				        ,
**									   
**		17.07.13	SOV				     
**		12.11.13	SAP				   @CreatedTaskRequestID
**									(      )
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskRequestCreate]
	@Xml XML,
	@GetTaskRequest TBool = 1,		--      ?
	@AssignTaskRequestByTemplate TBool = NULL,	--        ?
	@CreatedTaskRequestID TIdentifier = NULL OUTPUT
AS
	DECLARE @State					TState,
			@ID						TIdentifier,
			@FileAs					TName,
			@ProjectID				TIdentifier,
			@PriorityID				TIdentifier,
			@DueTime				TDateTime,
			@StartTime				TDateTime,
			@SendStatusReport		TBool,
			@TaskRequestStatusID	TIdentifier,
			@PercentComplete		int,
			@Comments				TNotes,
			@ExternalID				TExternalIdentifier,
			@ReminderState			TState,
			@ReminderInterval		TTimeSpan,
			@DocumentCardID			TIdentifier,
			@EmployeeID				TIdentifier,
			@SupervisorEmployeeID	TIdentifier,
			@EndTime				TDateTime,
			@Resolution				TNotes,
			@DocumentEditAccess		TBool,
			@ManHour				TCount,
			@Budget					TMoney,
			@ActualManHour			TCount,
			@ActualBudget			TMoney,
			@ProjectState			TState,
			@CurrentEmployeeID		TIdentifier,
			@AssignmentID			TIdentifier,
			@SupervisorAssignmentID	TIdentifier
	
	SET NOCOUNT ON
	
	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	
	SET @State = dbo.adfwfGetInitialState('87a91fee-cef2-4262-9019-30f8c6effd9d')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT
		@DocumentCardID			= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/DocumentCardID)[1]','int'),
		@FileAs					= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/FileAs)[1]','nvarchar(256)'),
		@ProjectID				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/ProjectID)[1]','int'),
		@EmployeeID				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/EmployeeID)[1]','int'),
		@AssignmentID			= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/AssignmentID)[1]','int'),
		@SupervisorEmployeeID	= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/SupervisorEmployeeID)[1]','int'),
		@SupervisorAssignmentID	= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/SupervisorAssignmentID)[1]','int'),
		@PriorityID				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/PriorityID)[1]','int'),
		@PercentComplete		= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/PercentComplete)[1]','int'),
		@DueTime				= CAST(@Xml.value('(/pjm5TaskRequestGet/TaskRequest/DueTime)[1]','varchar(19)') as datetime),
		@StartTime				= CAST(@Xml.value('(/pjm5TaskRequestGet/TaskRequest/StartTime)[1]','varchar(19)') as datetime),
		@EndTime				= CAST(@Xml.value('(/pjm5TaskRequestGet/TaskRequest/EndTime)[1]','varchar(19)') as datetime),
		@SendStatusReport		= (CASE @Xml.value('(/pjm5TaskRequestGet/TaskRequest/SendStatusReport)[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@TaskRequestStatusID	= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/TaskRequestStatusID)[1]','int'),
		@Resolution				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/Resolution)[1]','nvarchar(max)'),
		@DocumentEditAccess		= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/DocumentEditAccess)[1]','bit'),
		@Comments				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/Comments)[1]','nvarchar(max)'),
		@ReminderState			= (CASE @Xml.value('(/pjm5TaskRequestGet/TaskRequest/ReminderState)[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderInterval		= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/ReminderInterval)[1]','int'),
		@ManHour				= ISNULL(@Xml.value('(/pjm5TaskRequestGet/TaskRequest/ManHour)[1]','int'), 0),
		@Budget					= ISNULL(@Xml.value('(/pjm5TaskRequestGet/TaskRequest/Budget)[1]','decimal(18,4)'), 0),
		@ActualManHour			= 0,
		@ActualBudget			= 0

	IF @ProjectID IS NOT NULL 
	BEGIN 
		IF	(
				(	
					SELECT 
						COUNT(*)
					FROM 
						@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
				) !=	(
							SELECT 
								COUNT(*) AS Expr1
							FROM 
								[vwAssignment]
							WHERE 
							(
								[ProjectID] = @ProjectID
							) AND 
							((
								[State] = 1 AND
								[EmployeeID] IN	(	
													SELECT 
														T.c.value('EmployeeID[1]','int')
													FROM 
														@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
												)
							) OR
							(
								[State] = 3 AND
								[ID] IN	(	
											SELECT 
												T.c.value('AssignmentID[1]','int')
											FROM 
												@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
									)
							))
				)
			)
		BEGIN 
			RAISERROR ('#notassignedtospecifiedproject', 18, - 1) 
			RETURN 1 
		END 
	END
	
	SELECT 
		@ProjectState = [Project].[State]
	FROM
		[Project]
	WHERE
		[Project].[ID] = @ProjectID

	IF @ProjectState IN (5, 6) -- (  )
		SET @State = 6 --,   
	ELSE
		SET @State = 1 -- New
	
	DECLARE
		@RecurrenceID TIdentifier,
		@RStartDate TDatetime, 
		@REndDate TDatetime, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount
	SELECT
		@RStartDate = CAST(@Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/StartDate)[1]','varchar(19)') as datetime),
		@REndDate = CAST(@Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/EndDate)[1]','varchar(19)') as datetime),
		@RRecurrenceType = @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/RecurrenceType)[1]','int'),
		@ROccurrences = @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/Occurrences)[1]','int'),
		@RInterval = @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/Interval)[1]','int'),
		@RDayOfWeekMask = @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/DayOfWeekMask)[1]','int'),
		@RInstance = @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/Instance)[1]','int'),
		@RMonthOfYear = @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/MonthOfYear)[1]','int'),
		@RDayOfMonth = @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/DayOfMonth)[1]','int')

	IF @DueTime IS NULL AND @RRecurrenceType IS NOT NULL
		SET @DueTime = @RStartDate
	ELSE IF @DueTime IS NOT NULL AND @RRecurrenceType IS NOT NULL
	BEGIN	
		IF CAST(CONVERT(varchar(8), @DueTime, 112) AS datetime) < @RStartDate
			SET @RStartDate = CAST(CONVERT(varchar(8), @DueTime, 112) AS datetime)
	END
	
	BEGIN TRANSACTION

	IF @RRecurrenceType IS NOT NULL
	BEGIN
		INSERT INTO [RecurrencePattern]
			([StartDate], [EndDate], [RecurrenceType], [Occurrences], [Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
		VALUES
			(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences, @RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @RecurrenceID = SCOPE_IDENTITY()
	END

	INSERT INTO [TaskRequest]

		([Flag], [State], [FileAs], [ProjectID], 
		[PriorityID], [DueTime], [StartTime], 
		[SendStatusReport], [TaskRequestStatusID], 
		[PercentComplete], [Comments],
		[DocumentCardID], 
		[EmployeeID], 
		[AssignmentID], 
		[SupervisorEmployeeID], 
		[SupervisorAssignmentID], 
		[EndTime], [Resolution], [DocumentEditAccess],
		[ManHour], [Budget], [ActualManHour], [ActualBudget])
	VALUES
		(0, @State, @FileAs, @ProjectID, @PriorityID, @DueTime, @StartTime, 
		@SendStatusReport, @TaskRequestStatusID, 
		CAST(@PercentComplete as decimal(5, 2)) / CAST(100 as decimal(5, 2)), @Comments,
		@DocumentCardID, 
		(CASE @State
			WHEN 6 THEN
				NULL
			ELSE 
				@EmployeeID
		END),
		(CASE @State
			WHEN 6 THEN
				@AssignmentID
			ELSE 
				NULL
		END),
		(CASE @State
			WHEN 6 THEN
				NULL
			ELSE 
				@SupervisorEmployeeID
		END), 
		(CASE @State
			WHEN 6 THEN
				@SupervisorAssignmentID
			ELSE 
				NULL
		END), 
		@EndTime, @Resolution, @DocumentEditAccess,
		@ManHour, @Budget, @ActualManHour, @ActualBudget)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	SET @CreatedTaskRequestID = @ID
	
	IF @ProjectState IN (5, 6)
	BEGIN
		INSERT INTO [TaskRequestAssignment]([TaskRequestID], [AssignmentID])
		SELECT
			@ID, 
			T.c.value('AssignmentID[1]','int')
		FROM
			@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
	END
	ELSE
	BEGIN
	INSERT INTO [TaskRequestAssignment]([TaskRequestID], [EmployeeID])
	SELECT
		@ID, 
		T.c.value('EmployeeID[1]','int')
	FROM
		@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
	END	
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE @Employee TIdentifier

	IF @ProjectState IN (5, 6)
	BEGIN
		SET @Employee = (SELECT [ID] FROM [Employee] WHERE [UserID] = dbo.adfGetCurrentUserID())
		UPDATE [TaskRequestAssignment] 
		SET [Accepted] = 1 
		WHERE [TaskRequestID] = @ID and [EmployeeID] = @Employee 
	END

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @Class AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	DECLARE @rv int		
	IF @State != 6
	BEGIN
		EXEC @rv = pjm7TaskRequestReminderCreate @ID, @DueTime, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
		IF (@AssignTaskRequestByTemplate IS NULL OR @AssignTaskRequestByTemplate = 1)
		BEGIN
	EXEC @rv = pjm6TaskRequestAutoAssign @ID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
			--         
			IF @AssignTaskRequestByTemplate = 1 AND NOT EXISTS(SELECT * FROM [TaskRequest] WHERE [ID] = @ID AND [State] = 2)
			BEGIN
				BEGIN TRY
					EXEC pjm5TaskRequestChangeState @ID = @ID, @ToState = 2
				END TRY
				BEGIN CATCH		
				END CATCH
			END
		END
	END
	
	COMMIT TRANSACTION
	
	IF (@GetTaskRequest = 1)
	EXEC pjm5TaskRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskRequestCreate TO PUBLIC
GO
 