IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryBrowseByTask]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryBrowseByTask'
		DROP PROCEDURE [dbo].[pjm5TimeEntryBrowseByTask]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryBrowseByTask'
GO

/******************************************************************************
**		File: TimeEntryBrowseByTask.sql
**		Name: pjm5TimeEntryBrowseByTask
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		01.04.13	SOV				. -      
**		09.09.13	SOV				. -    -  ;
**									      
**		17.10.13	SOV				   - fnpjm7BillableHourGet
*******************************************************************************/
CREATE PROCEDURE [pjm5TimeEntryBrowseByTask]
	@EmployeeID TIdentifier,
	@StateSelector INT,
	@TaskID TIdentifier,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	SET DATEFIRST 1
	DECLARE
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@HasFinansDataAccess INT,
		@IsProjectApprover INT,
		@AllowCreateProjectEntry INT,
		@IsProjectMember INT,
		@ProjectID INT,
		@ViewAllProjects TBool,
		@Assistant TBool,
		@IsManagerAssistant TBool
		
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)
	
	SELECT @ProjectID = [TimeEntry].[ProjectID]
	FROM
		[vwTimeEntry] as [TimeEntry]
	WHERE
		(			
			([TimeEntry].[TaskID] = @TaskID)
		) AND
		(
			@EmployeeID IS NULL OR
			[TimeEntry].[EmployeeID] = @EmployeeID
		) 
	
	SET @HasFinansDataAccess = dbo.fnPjm5HasFinansDataAccess(@ProjectID, @CurrentEmployeeID, NULL, NULL)
	SET @IsProjectApprover = dbo.fnPjm5IsProjectApprover(@ProjectID, @CurrentEmployeeID)
	SET @IsManagerAssistant = dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID)

	SET @AllowCreateProjectEntry = dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, @CurrentEmployeeID)
		
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) 
	SET @Assistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
	
	IF @AllowCreateProjectEntry = 0 AND @ViewAllProjects = 1 AND @Assistant = 1
	   SET @AllowCreateProjectEntry = 1
	
	DECLARE	@value	TVariant,
			@BillableHoursStyle int

	EXEC adfParameterGet @Name='BillableHoursStyle', @Group='Pjm7', @Value = @Value OUTPUT
	SET	@BillableHoursStyle = CONVERT(int, @value)

	SELECT
		[TimeEntry].[Class],
		[TimeEntry].[ID],
		[TimeEntry].[State],
		[TimeEntry].[Flag],
		[TimeEntry].[FileAs],
		[TimeEntry].[ActivityTypeID],
		[TimeEntry].[EmployeeID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[TaskID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[RoundedDuration],
		[TimeEntry].[Billable],
		dbo.fnpjm7BillableHourGet([TimeEntry].[ProjectID], [TimeEntry].[BillableDuration], @BillableHoursStyle,
			CASE [TimeEntry].[EmployeeID]
				WHEN @CurrentEmployeeID THEN 1
				ELSE 0
			END
		) AS BillableDuration,
		[TimeEntry].[Overtime],
		[TimeEntry].[Rate],
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[VATRate],
		CASE 
			WHEN @HasFinansDataAccess != 1
				THEN -1
			ELSE CAST([TimeEntry].[Billable] AS int) * [TimeEntry].[Rate] * [TimeEntry].[BillableHour]
		END AS [Sum],
		[TimeEntry].[Color],
		[TimeEntry].[Comments],
		[TimeEntry].[Created],
		[TimeEntry].[CreatedBy],
		[TimeEntry].[Modified],
		[TimeEntry].[ModifiedBy],
		[TimeEntry].[Timestamp]
	FROM
		[vwTimeEntry] as [TimeEntry]
		INNER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
	WHERE
		( 
			@ViewAllFinance = 1 OR 
			@AllowCreateProjectEntry = 1
		) AND
		(
			([TimeEntry].[TaskID] = @TaskID)
		) AND
		(
			@EmployeeID IS NULL OR
			[TimeEntry].[EmployeeID] = @EmployeeID
		) AND 
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [TimeEntry].[State] IN (1, 5)) OR	-- / 
			(@StateSelector = 2 AND [TimeEntry].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [TimeEntry].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [TimeEntry].[State] = 6) OR			--   
			(@StateSelector = 5 AND [TimeEntry].[State] = 4)			-- 
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TimeEntryBrowseByTask] TO PUBLIC
GO
    