IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryUpdate'
		DROP PROCEDURE [dbo].[pjm5TimeEntryUpdate]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryUpdate'
GO

/******************************************************************************
**		File: pjm5TimeEntryUpdate.sql
**		Name: pjm5TimeEntryUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		06.10.09	SYV				  pjm6AssignmentCheckBudgetOverdraft
**		12.07.11	SYV				   
**		02.03.12	PAM				   " "
**		31.01.12	SAP				    BillableHour
**		13.03.13	MAB				  OPENXML
**		04.07.13	SAP				   BillableHour   
**		23.08.13	SOV				      " "
*******************************************************************************/
CREATE PROCEDURE pjm5TimeEntryUpdate 
	@Xml XML
AS
	DECLARE
		@Class						TClass,
		@ID							TIdentifier,
		@FileAs						TName,
		@ActivityTypeID				TIdentifier,
		@EmployeeID					TIdentifier,
		@ProjectID					TIdentifier,
		@DocumentClass				TClass,
		@DocumentID					TIdentifier,
		@TaskID						TIdentifier,
		@StartTime					TDateTime,
		@Duration					TCount,
		@RoundedDuration			TCount,
		@Billable					TBool,
		
		@BillableHour				decimal(18,2),
		
		@Overtime					TBool,
		@Rate						TMoney,
		@CurrencyCode				TCode3,
		@VATRate					TPercent,
		@Comments					TNotes,
		@rv							int,
		@MyEmployeeID				int,
		@State						TState,
		@Color						TColor,
		@RecurrenceID				TIdentifier,
		@ReminderState				TState,
		@ReminderInterval			TTimeSpan,
		@RemainingWork				TAmount,
		@RemainingOvertimeWork		TAmount,
		@PrevTaskID					TIdentifier,
		@PrevAssignmentID			Tidentifier,
		@PrevProgectID				TIdentifier,
		@PrevEmployeeID				TIdentifier,
		@result						TBool,
		@BillableIsModified			TBool

	DECLARE -- RECURRENCE
		@StartDate TDate, 
		@EndDate TDate, 
		@RecurrenceType TIdentifier, 
		@Occurrences TCount,
		@Interval TCount, 
		@DayOfWeekMask TIdentifier, 
		@Instance TIdentifier, 
		@MonthOfYear TCount, 
		@DayOfMonth TCount,
		@Recurrence TBool
	SET NOCOUNT ON

	SELECT
		@ID						= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ID)[1]','int'),
		@Class					= [TimeEntry].[Class],
		@State					= [TimeEntry].[State],
		@FileAs					= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/FileAs)[1]','nvarchar(256)'),
		@ActivityTypeID			= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ActivityTypeID)[1]','int'),
		@EmployeeID				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/EmployeeID)[1]','int'),
		@ProjectID				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ProjectID)[1]','int'),
		@DocumentClass			= dbo.adfGetClassByName(@Xml.value('(/pjm5TimeEntryGet/TimeEntry/DocumentClass)[1]','varchar(32)')),
		@DocumentID				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/DocumentID)[1]','int'),
		@TaskID					= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/TaskID)[1]','int'),
		@StartTime				= CAST(@Xml.value('(/pjm5TimeEntryGet/TimeEntry/StartTime)[1]','varchar(19)') as datetime),
		@Duration				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Duration)[1]','int'),
		@RoundedDuration		= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/RoundedDuration)[1]','int'),
		@Billable				= (	CASE 
										WHEN @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Billable)[1]','varchar(5)') = 'false' THEN 
											0 
										ELSE 
											1 
									END),
		
		@BillableHour			= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/BillableHour)[1]','decimal(18,4)'),
		@BillableIsModified		= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/BillableIsModified)[1]','bit'),
		@Overtime				= (	CASE 
										WHEN @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Overtime)[1]','varchar(5)') = 'false' THEN 
											0 
										ELSE 
											1 
									END),
		@CurrencyCode			= [Project].[CurrencyCode],
		@VATRate				= dbo.fnPjm5GetVATRate(),
		@Comments				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Comments)[1]','nvarchar(max)'),
		@Color					= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Color)[1]','int'),
		@RecurrenceID			= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/RecurrencePatternID)[1]','int'),
		@ReminderState			=	CASE 
										WHEN @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ReminderState)[1]','varchar(5)') = 'false' THEN 
											0 
										ELSE 
											1 
									END,
		@ReminderInterval		= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ReminderInterval)[1]','int'),
		@RemainingWork			= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/RemainingWork)[1]','decimal(18,4)'),
		@RemainingOvertimeWork	= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/RemainingOvertimeWork)[1]','decimal(18,4)'),
		@PrevTaskID				= [TimeEntry].[TaskID],
		@PrevEmployeeID			= [TimeEntry].[EmployeeID],
		@PrevAssignmentID		= dbo.fnPjm5GetProjectAssignment([TimeEntry].[ProjectID], [TimeEntry].[EmployeeID])
	FROM
		[TimeEntry]
		LEFT OUTER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
	WHERE
		[TimeEntry].[ID] = @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ID)[1]','int')
	
	SET @Recurrence = 0
	IF (SELECT @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/ID)[1]','int')) IS NOT NULL
	BEGIN
		SET @Recurrence = 1
		SELECT
			@StartDate		= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/StartDate)[1]','varchar(19)'), 
			@EndDate		= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/EndDate)[1]','varchar(19)'), 
			@RecurrenceType	= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/RecurrenceType)[1]','int'), 
			@Occurrences	= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/Occurrences)[1]','int'), 
			@Interval		= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/Interval)[1]','int'), 
			@DayOfWeekMask	= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/DayOfWeekMask)[1]','int'), 
			@Instance		= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/Instance)[1]','int'), 
			@MonthOfYear	= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/MonthOfYear)[1]','int'), 
			@DayOfMonth		= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/DayOfMonth)[1]','int')
	END

	BEGIN TRANSACTION

	IF @State = 1
	BEGIN
		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@StartDate, @EndDate, @RecurrenceType, @Occurrences,
				@Interval, @DayOfWeekMask, @Instance, @MonthOfYear, @DayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE
				[RecurrencePattern]
			SET
				[StartDate] = @StartDate, 
				[EndDate] = @EndDate, 
				[RecurrenceType] = @RecurrenceType, 
				[Occurrences] = @Occurrences,
				[Interval] = @Interval, 
				[DayOfWeekMask] = @DayOfWeekMask, 
				[Instance] = @Instance, 
				[MonthOfYear] = @MonthOfYear, 
				[DayOfMonth] = @DayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	
	IF @TaskID IS NOT NULL
	BEGIN
		IF (dbo.fnPjm5IsTaskAssigned(@TaskID, @EmployeeID) = 0)
		BEGIN
			RAISERROR('#NotAssignmentByTask', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE @AssignmentID TIdentifier
	SET @AssignmentID = dbo.fnPjm5GetProjectAssignment(@ProjectID, @EmployeeID)

	EXEC @rv = pjm5TimeEntryUpdateInternal
		@ID,
		@FileAs,
		@ActivityTypeID,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@StartTime,
		@Duration,
		@Billable,
		
		@BillableHour,
		
		@Overtime,
		@CurrencyCode,
		@VATRate,
		@Color,
		@Comments,
		@PrevEmployeeID

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	IF @State = 5
	BEGIN
		EXEC @rv = pjm5TimeEntryChangeState @ID, 1
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF @State = 6
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#CannotApproveCalculationTimeEntry', 18, -1)
		RETURN 1
	END
	
	IF (@BillableIsModified = 1)
	BEGIN
		UPDATE [EntryAmount]
		SET 
			[Modified] = GETDATE(),
			[ModifiedBy] = dbo.adfGetCurrentUserID()
		WHERE
			[EntryAmount].[ID] = @ID

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF @DocumentID IS NULL SET @DocumentClass = NULL
	EXEC @rv = pjm5TimeEntryUpdateInternal
		@ID,
		@FileAs,
		@ActivityTypeID,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@StartTime,
		@Duration,
		@Billable,
		
		@BillableHour,
		
		@Overtime,
		@CurrencyCode,
		@VATRate,
		@Color,
		@Comments,
		@PrevEmployeeID

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	
	EXEC @rv = pjm7TimeEntryReminderCreate @ID,
		@StartTime, @ReminderState,	@ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm6TaskPercentUpdate @TaskID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	EXEC @rv = pjm6TaskPercentUpdate @PrevTaskID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	EXEC @rv = pjm7ExchangeSyncStateUpdateNewDocument @ID, @Class, @EmployeeID, 0
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	

	EXEC pjm6TimeEntryGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimeEntryUpdate TO PUBLIC
GO
 