 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'V' AND name = 'vwLatestAttendeeResponse')
	BEGIN
		PRINT 'Dropping View vwLatestAttendeeResponse'
		DROP  View vwLatestAttendeeResponse
	END
GO

/******************************************************************************
**		File: 
**		Name: vwLatestAttendeeResponse
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating View vwLatestAttendeeResponse'
GO

SET QUOTED_IDENTIFIER ON 
GO

CREATE View vwLatestAttendeeResponse
as
	SELECT
		[R].[MeetingRequestID],
		[R].[EmployeeID],
		[R].[ID],
		[R].[ResponseType],
		[R].[FileAs],
		[R].[Comments],
		[R].[Created]
	FROM
		[AttendeeResponse] as [R] INNER JOIN 
			(SELECT [MeetingRequestID],
					[EmployeeID],
					MAX([ID]) as [ID] FROM [AttendeeResponse] GROUP BY [MeetingRequestID], [EmployeeID]) as [L]
			ON ([R].[MeetingRequestID] = [L].[MeetingRequestID] AND
				[R].[EmployeeID] = [L].[EmployeeID] AND
				[R].[ID] = [L].[ID])


GO

 